﻿using System;
using KRO.Contents;

namespace KRO.Models
{
    [Serializable]
    public class BlockReportParameterHistoryLine
    {
        public int ID { get; private set; }
        public int ReportParameterID { get; set; }
        public int UserID { get; set; }
        public string UserFullName { get; set; }
        public int RoleID { get; set; }
        public string RoleName { get; set; }
        public int DepartmentID { get; set; }
        public string DepartmentName { get; set; }
        public string OfficeName { get; set; }
        public long BlockValue { get; set; }
        public string OperationDesription { get; set; }
        public string OperationData { get; set; }
        public string Comment { get; set; }
        public BlockReportParameterHistoryLine(int AID, int AReportParameterID, int AUserID, string AUserFullName,
                                               int ARoleID, string ARoleName, int ADepartmentID, string ADepartmentName,
                                               string AOfficeName, long ABlockValue, string AOperationDesription,
                                               string AOperationData, string AComment)
        {
            this.ID = AID;
            this.ReportParameterID = AReportParameterID;
            this.UserID = AUserID;
            this.UserFullName = AUserFullName;
            this.RoleID = ARoleID;
            this.RoleName = ARoleName;
            this.DepartmentID = ADepartmentID;
            this.DepartmentName = ADepartmentName;
            this.OfficeName = AOfficeName;
            this.BlockValue = ABlockValue;
            this.OfficeName = AOfficeName;
            this.OperationDesription = AOperationDesription;
            this.OperationData = AOperationData;
            this.Comment = AComment;
        }
        public BlockReportParameterHistoryLine(int AReportParameterID, int AUserID, string AUserFullName,
                                               int ARoleID, string ARoleName, int ADepartmentID, string ADepartmentName,
                                               string AOfficeName, long ABlockValue, string AOperationDesription,
                                               string AOperationData, string AComment)
        {
            this.ID = -1;
            this.ReportParameterID = AReportParameterID;
            this.UserID = AUserID;
            this.UserFullName = AUserFullName;
            this.RoleID = ARoleID;
            this.RoleName = ARoleName;
            this.DepartmentID = ADepartmentID;
            this.DepartmentName = ADepartmentName;
            this.OfficeName = AOfficeName;
            this.BlockValue = ABlockValue;
            this.OfficeName = AOfficeName;
            this.OperationDesription = AOperationDesription;
            this.OperationData = AOperationData;
            this.Comment = AComment;
        }
        public BlockReportParameterHistoryLine()
        {
            this.ID = -1;
            this.ReportParameterID = -1;
            this.UserID = -1;
            this.UserFullName = "";
            this.RoleID = -1;
            this.RoleName = "";
            this.DepartmentID = -1;
            this.DepartmentName = "";
            this.OfficeName = "";
            this.BlockValue = 0;
            this.OfficeName = "";
            this.OperationDesription = "";
            this.OperationData = "";
            this.Comment = "";
        }
        public void SetID(int AID)
        {
            if (AID > 0) this.ID = AID; else this.ID = -1;
        }
    }
}