﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using  System.Web.UI.WebControls;

namespace KRO.Models
{
    public class CellTemplate : ITemplate
  {
    private DataControlRowType templateType;
    private string columnName;
    private bool _onlyLabel;


    public CellTemplate(DataControlRowType type, string colname,bool onlyLabel = false)
    {
        templateType = type;
        columnName = colname;
        _onlyLabel = onlyLabel;
    }


    public void InstantiateIn(System.Web.UI.Control container)
    {
        // Создание контента для различных типов строк.
      switch(templateType)
      {
        case DataControlRowType.Header:
        // Создание элементов управления для ввода в заголовке 
        // Раздел и установить их свойства.
          Literal lc = new Literal();
          lc.Text = "&lt;B>" + columnName + "&lt;/B>";


          // Добавить элементы управления в коллекцию элементов управления 
          // Контейнера.
          container.Controls.Add(lc);
          break;
        case DataControlRowType.DataRow:
          // Создание элементов управления поставить в строке данных 
          // Раздел и установить их свойства.
          Label lLabel = new Label();
          lLabel.ID = "lbl"+columnName;
          lLabel.DataBinding += new EventHandler(this.lLabel_DataBinding);
          container.Controls.Add(lLabel);
              if (!_onlyLabel)
              {
                  TextBox lTextBox = new TextBox();
                  lTextBox.ID = "tb" + columnName;
                  lTextBox.CssClass = "ssTextBox";
                  lTextBox.DataBinding += new EventHandler(this.lTextBox_DataBinding);
                  container.Controls.Add(lTextBox);
              }


          // Для поддержки привязки данных, зарегистрировать методы обработки событий 
          // Выполнить привязку данных. Каждый элемент управления нуждается в собственной событие 
          // Обработчик.
          //lLabel.DataBinding += new EventHandler(this.lLabel_DataBinding);


          // Добавить элементы управления в коллекцию элементов управления 
          // Контейнера.
          // container.Controls.Add(lLabel);
          break;

        // Вставьте случаев для создания контента для друга 
        // Типы строк, если это необходимо.
        default:
          // Вставьте код для обработки неожиданные значения.
          break;
      }
    }


    private void lLabel_DataBinding(Object sender, EventArgs e)
    {
        // Получить контроль этикетки связывать значение.Метка контроля 
        // Содержится в объекте, что поднял DataBinding 
        // Событие (параметр отправителя).
        Label lLabel = (Label) sender;

        // Получить объект, содержащий GridViewRow контроль Label.
        GridViewRow lRow = (GridViewRow)lLabel.NamingContainer;

        // Получить значение поля из объекта GridViewRow и 
        // Присвоить его текста имущества управления Label.
        lLabel.Text = DataBinder.Eval(lRow.DataItem, columnName).ToString();
    }


    private void lTextBox_DataBinding(Object sender, EventArgs e)
    {
       TextBox lTextBox = (TextBox) sender;
       GridViewRow lRow = (GridViewRow)lTextBox.NamingContainer;
       lTextBox.Text = DataBinder.Eval(lRow.DataItem, columnName).ToString();
    }
  }
}