﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using KRO.Contents;

namespace KRO.Models
{
    [Serializable]
    public class DepIncludeRegionLine
    {
        public int ID { get; private set; }
        public int DepartmentID { get; set; }
        public string DepartmentName { get; set; }
        public string DepartmentSort { get; set; }
        public string DepartmentCode { get; set; }
        public int MounthID { get; set; }
        public string MounthName { get; set; }
        public int YearID { get; set; }
        public string YearName { get; set; }
        public DateTime DateIn { get; set; }
        public int Flag { get; private set; }

        private List<RegionLine> RegionList;
        public DepIncludeRegionLine(int AID, int ADepartmentID, string ADepartmentName, 
                                    string ADepartmentSort, string ADepartmentCode, 
                                    int AMonthID, string AMounthName, int AYearID,
                                    string AYearName, DateTime ADateIn, int AFlag)
        {
            this.ID = AID; 
            this.DepartmentID = ADepartmentID;
            this.DepartmentName = ADepartmentName;
            this.DepartmentCode = ADepartmentCode;
            this.DepartmentSort = ADepartmentSort;
            this.MounthID = AMonthID;
            this.MounthName = AMounthName;
            this.YearID = AYearID;
            this.YearName = AYearName;
            this.DateIn = ADateIn;
            this.Flag = AFlag;
            SetFlagFields();
        }
        public DepIncludeRegionLine()
        {
            this.ID = -1;
            this.DepartmentID = -1;
            this.DepartmentName = "";
            this.DepartmentSort = "";
            this.DepartmentCode = "";
            this.MounthID = -1;
            this.MounthName = "";
            this.YearID = -1;
            this.YearName = "";
            this.DateIn = DateTime.Today;
            this.Flag = 0;
            SetFlagFields();
        }
        public void SetID(int AID)
        {
            if (AID > 0) this.ID = AID; else this.ID = -1;
        }
        public void SetFlag(int AFlag)
        {
            if (AFlag > 0) this.Flag = AFlag; else this.Flag = 0;
            SetFlagFields();
        }
        public void SetFlagFields()
        {
           // if ((this.Flag & KROFlag.flOnlyPerformerFlag) == KROFlag.flOnlyPerformerFlag) this.OnlyPerformerFlag = true; else this.OnlyPerformerFlag = false;
        }
    }
}