﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using KRO.Contents;

namespace KRO.Models
{
    [Serializable]
    public class DepartmentIDInPeriodLine
    {
        public int ID { get; private set; }
        public int DepListInPeriodID { get; set; }
        public int DepartmentID { get; set; }
        public string DepartmentName { get; set; }
        public string DepartmentSort { get; set; }
        public string DepartmentCode { get; set; }
        public int Flag { get; private set; }
        public bool DepartmentIDCheckedInPeriod { get; private set; }
        public DepartmentIDInPeriodLine(int AID, int ADepListInPeriodID, 
                                    int ADepartmentID, string ADepartmentName,
                                    string ADepartmentSort, string ADepartmentCode, int AFlag)
        {
            this.ID = AID;
            this.DepListInPeriodID = ADepListInPeriodID;
            this.DepartmentID = ADepartmentID;
            this.DepartmentName = ADepartmentName;
            this.DepartmentSort = ADepartmentSort;
            this.DepartmentCode = ADepartmentCode;
            this.Flag = AFlag;
            SetFlagFields();
        }
        public DepartmentIDInPeriodLine()
        {
            this.ID = -1;
            this.DepListInPeriodID = -1;
            this.DepartmentID = -1;
            this.DepartmentName = "";
            this.DepartmentSort = "";
            this.DepartmentCode = "";
            this.Flag = 0;
            SetFlagFields();
        }
        public void SetID(int AID)
        {
            if (AID > 0) this.ID = AID; else this.ID = -1;
        }
        public void SetFlag(int AFlag)
        {
            if (AFlag > 0) this.Flag = AFlag; else this.Flag = 0;
            SetFlagFields();
        }
        public void SetFlagValue()
        {
            int lFlag = 0;
            if (this.DepartmentIDCheckedInPeriod) lFlag = lFlag |= KROFlag.flDepartmentIDCheckedInPeriod;
            this.Flag = lFlag;
        }
        public void SetFlagFields()
        {
            if ((this.Flag & KROFlag.flDepartmentIDCheckedInPeriod) == KROFlag.flDepartmentIDCheckedInPeriod) this.DepartmentIDCheckedInPeriod = true; else this.DepartmentIDCheckedInPeriod = false;
        }
        public void SetDepartmentDirectionCheckedInPeriod(bool ADepartmentIDCheckedInPeriod)
        {
            this.DepartmentIDCheckedInPeriod = ADepartmentIDCheckedInPeriod;
            SetFlagValue();
        }
    }
}