﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using KRO.Contents;

namespace KRO.Models
{
    [Serializable]
    public class DepartmentLine
    {   
        public int DepartmentID { get; private set; }
        public string DepartmentName { get; set; }
        public string DepartmentSort { get; set; }
        public string DepartmentCode { get; set; }
        public int? DepartmentCategory { get; private set; } //used how Flags field
        public bool OnlyPerformerFlag { get; private set; }
        public bool DepartmentChecked { get; set; } //for only table DepListInperiod generate DepartmentList
        public DepartmentLine(int AID, string ADepartmentName, string ADepartmentSort, string ADepartmentCode, int? ADepartmentCategory, bool ADepartmentChecked = false)
        {
            this.DepartmentID = AID;
            this.DepartmentName = ADepartmentName;
            this.DepartmentSort = ADepartmentSort;
            this.DepartmentCode = ADepartmentCode;
            this.DepartmentCategory = ADepartmentCategory;
            this.DepartmentChecked = ADepartmentChecked;
            SetFlagFields();
        }
        public DepartmentLine()
        {
            this.DepartmentID = -1;
            this.DepartmentName = "";
            this.DepartmentSort = "";
            this.DepartmentCode = "";
            this.DepartmentCategory = 0;
            this.DepartmentChecked = false;
            SetFlagFields();
        }
        public void SetDepartmentID(int ADepartmentID)
        {
            if (ADepartmentID > 0) this.DepartmentID = ADepartmentID; else this.DepartmentID = -1;
        }
        public void SetFlag(int AFlag)
        {
            if (AFlag > 0) this.DepartmentCategory = AFlag; else this.DepartmentCategory = 0;
            SetFlagFields();
        }
        private void SetFlagFields()
        {
            if ((this.DepartmentCategory & KROFlag.flOnlyPerformerFlag) == KROFlag.flOnlyPerformerFlag) this.OnlyPerformerFlag = true; else this.OnlyPerformerFlag = false;
         }
    }
}