﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using KRO.Contents;

namespace KRO.Models
{
	[Serializable]
    public class DinamicMetricReportLine
    {
        public long MetricID { get; set; }
        public string MetricName { get; set; }
        public string MetricCode { get; set; }
        public string MetricSort { get; set; }
        public string MetricScreenCode { get; set; }
        /// <summary>
        /// Сочетание MetricFlags
        /// </summary>
        public long MetricFlag { get; set; }
        // Flag fields
        public bool FlagMetricWrite { get; private set; }
        public bool FlagMetricCalculation { get; private set; }
        public bool FlagMetricTextRow { get; private set; }
        public string MetricColorCode { get; private set; }
        public List<DinamicFactLine> MetricRegionFactList { get; private set; } 
        public DinamicMetricReportLine(long AMetricID, 
            string AMetricName,
            string AMetricCode,
            string AMetricSort,
            string AMetricScreenCode,
            long AMetricFlag)
        {
            MetricID = AMetricID;
            MetricName = AMetricName;
            MetricCode = AMetricCode;
            MetricSort = AMetricSort;
            MetricScreenCode = AMetricScreenCode;
            MetricFlag = AMetricFlag;
            MetricRegionFactList = new List<DinamicFactLine>();
            SetFlagFields();
        }
        private void SetFlagFields()
        {
            // определим значение по умолчанию для цвета отображения (белый)
            this.MetricColorCode = KROConstants.clRowDefaultCode;
            //далее разбор флага
            if ((this.MetricFlag & KROFlag.flMetricTextRow) == KROFlag.flMetricTextRow)
            {   // если показатель текстовый то ни вводить значения ни участвовать в расчетах не может
                this.FlagMetricTextRow = true;
                this.FlagMetricCalculation = false;
                this.FlagMetricWrite = false;
                this.MetricColorCode = KROConstants.clRowGrayCode;
            }
            else
            {
                this.FlagMetricTextRow = false;
                //дальше начнем выставлять рассчетные показатели
                if ((this.MetricFlag & KROFlag.flMetricWrite) == KROFlag.flMetricWrite) this.FlagMetricWrite = true; else this.FlagMetricWrite = false;
                if ((this.MetricFlag & KROFlag.flMetricCalculations) == KROFlag.flMetricCalculations) this.FlagMetricCalculation = true; else this.FlagMetricCalculation = false;
                // вспомогательные свойства из поля флаг
                // цвет отображения показателя
                //определим цвет строки
                if ((this.MetricFlag & KROFlag.flMetricBrownColor) == KROFlag.flMetricBrownColor) this.MetricColorCode = KROConstants.clRowBrownCode;
                if ((this.MetricFlag & KROFlag.flMetricYellowColor) == KROFlag.flMetricYellowColor) this.MetricColorCode = KROConstants.clRowYellowCode;
                if ((this.MetricFlag & KROFlag.flMetricGreenColor) == KROFlag.flMetricGreenColor) this.MetricColorCode = KROConstants.clRowGreenCode;
                if ((this.MetricFlag & KROFlag.flMetricBlueColor) == KROFlag.flMetricBlueColor) this.MetricColorCode = KROConstants.clRowBlueCode;
            }
        }
    }
}