﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using KRO.Contents;

namespace KRO.Models
{
    [Serializable]
    public class LogOutLine
    {
        public long ID { get; private set; }
        public DateTime LogDate { get; set; }
        public int? UserID { get; set; }
        public string Family { get; set; }
        public string FirstName { get; set; }
        public string SecondName { get; set; }
        public long UserFlag { get; set; }
        public string RoleName { get; set; }
        public string DepartmentName { get; set; }
        public long TypeFlag { get; private set; }
        public string LogType { get; private set; }
        public string LogMessage { get; set; }
        public LogOutLine(long ALogID, DateTime ALogDate, int? AUserID, string AFamily, 
                          string AFirstName, string ASecondName, long AUserFlag,
                          string ARoleName, string ADepartmentName, long ATypeFlag, string ALogMessage)
		{
            this.ID = ALogID; 
            this.LogDate = ALogDate;
            this.UserID = AUserID;
            this.Family = AFamily;
            this.FirstName = AFirstName;
            this.SecondName = ASecondName;
            this.UserFlag = AUserFlag;
            this.RoleName = ARoleName;
            this.DepartmentName = ADepartmentName;
            this.TypeFlag = ATypeFlag;
            this.LogMessage = ALogMessage;
            SetLogType();
		}
        public LogOutLine(DateTime ALogDate, int? AUserID, string AFamily,
                          string AFirstName, string ASecondName, long AUserFlag,
                          string ARoleName, string ADepartmentName, long ATypeFlag, string ALogMessage)
		{
            this.ID = -1; 
            this.LogDate = ALogDate;
            this.UserID = AUserID;
            this.Family = AFamily;
            this.FirstName = AFirstName;
            this.SecondName = ASecondName;
            this.UserFlag = AUserFlag;
            this.RoleName = ARoleName;
            this.DepartmentName = ADepartmentName;
            this.TypeFlag = ATypeFlag;
            this.LogMessage = ALogMessage;
            SetLogType();
		}
        public LogOutLine()
        {
            this.ID = -1;
            this.LogDate = new DateTime();
            this.UserID = -1;
            this.Family = "";
            this.FirstName = "";
            this.SecondName = "";
            this.UserFlag = 0;
            this.RoleName = "";
            this.DepartmentName = "";
            this.TypeFlag = 0;
            this.LogMessage = "";
            SetLogType();
        }
        public void SetID(int ALogID)
        {
            if (ALogID > 0) this.ID = ALogID; else this.ID = -1; 
        }
        public void SetFlag(int AFlag)
        {
            if (AFlag > 0) this.TypeFlag = AFlag; else this.TypeFlag = 0;
        }
        private void SetLogType()
        {
            string lLogType="";
            if ((this.TypeFlag & KROFlag.flLogUserSession) == KROFlag.flLogUserSession) lLogType = KROConstants.lgLogUserSessionType;


            if ((this.TypeFlag & KROFlag.flLogExchangeUsers) == KROFlag.flLogExchangeUsers) {
                if (lLogType.Length>0) lLogType = lLogType + " | " + KROConstants.lgExchangeUsersType; else lLogType = KROConstants.lgExchangeUsersType;
            }
            this.LogType = lLogType;   
        }
    }
}