﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using KRO.Contents;

namespace KRO.Models
{
    [Serializable]
    public class MetricFunctionInPeriodBaseLine
    {
        public int ID { get; private set; }
        public string Name { get; set; }
        public int MounthID { get; set; }
        public string MounthName { get; set; }
        public int YearID { get; set; }
        public string YearName { get; set; }
        public DateTime DateIn { get; set; }
        public int CalcMetricID { get; private set; }
        public string CalcMetricName { get; set; }
        public string CalcMetricSort { get; set; }
        public string CalcMetricCode { get; set; }
        public string CalcMetricScreenCode { get; set; }
        public long CalcMetricFlag { get; private set; }

        public MetricFunctionInPeriodBaseLine(int AID, int AMonthID, string AMounthName, int AYearID,
                                   string AYearName, DateTime ADateIn, int ACalcMetricID,
                                   string ACalcMetricName, string ACalcMetricSort, string ACalcMetricCode,
                                   string ACalcMetricScreenCode, long ACalcMetricFlag)
        {
            this.ID = AID;
            this.Name = KROConstants.MessageIncludedMetricFunction;
            this.MounthID = AMonthID;
            this.MounthName = AMounthName;
            this.YearID = AYearID;
            this.YearName = AYearName;
            this.DateIn = ADateIn;
            this.CalcMetricID = ACalcMetricID;
            this.CalcMetricName = ACalcMetricName;
            this.CalcMetricSort = ACalcMetricSort;
            this.CalcMetricCode = ACalcMetricCode;
            this.CalcMetricScreenCode = ACalcMetricScreenCode;
            this.CalcMetricFlag = ACalcMetricFlag;
            SetFlagFields();
        }
        public MetricFunctionInPeriodBaseLine()
        {
            this.ID = -1;
            this.Name = KROConstants.MessageIncludedMetricFunction;
            this.MounthID = -1;
            this.MounthName = "";
            this.YearID = -1;
            this.YearName = "";
            this.DateIn = DateTime.Today;
            this.CalcMetricID = -1;
            this.CalcMetricName = "";
            this.CalcMetricSort = "";
            this.CalcMetricCode = "";
            this.CalcMetricScreenCode = "";
            this.CalcMetricFlag = 0;
            SetFlagFields();
        }
        public void SetID(int AID)
        {
            if (AID > 0) this.ID = AID; else this.ID = -1;
        }
        public void SetFlag(int AFlag)
        {
            if (AFlag > 0) this.CalcMetricFlag = AFlag; else this.CalcMetricFlag = 0;
            SetFlagFields();
        }
        public void SetFlagFields()
        {
           // if ((this.Flag & KROFlag.flOnlyPerformerFlag) == KROFlag.flOnlyPerformerFlag) this.OnlyPerformerFlag = true; else this.OnlyPerformerFlag = false;
        }
    }
}