﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using KRO.Contents;

namespace KRO.Models
{
    [Serializable]
    public class MetricFunctionInPeriodLine
    {
        public int ID { get; private set; }
        public int MetricListInPeriodID { get; set; }
        public int CalcMetricID { get; set; }
        public int SumMetricID { get; set; }
        public string SumMetricName { get; set; }
        public string SumMetricSort { get; set; }
        public string SumMetricCode { get; set; }
        public string SumMetricScreenCode { get; set; }
        public bool SumMetricIDIsNegative { get; private set; }
        public long CalcMetricFlag { get; private set; }
        public long SumMetricFlag { get; private set; }
        public int SumMetricDK { get; set; }
        public bool SumMetricIDCheckedInFunction { get; set; }
        public MetricFunctionInPeriodLine(int AID, int AMetricListInPeriodID, int ACalcMetricID, long ACalcMetricFlag,
                                    int ASumMetricID, string ASumMetricName,
                                    string ASumMetricSort, string ASumMetricCode,
                                    string ASumMetricScreenCode, long ASumMetricFlag, int ASumMetricDK = 1,
                                    bool ASumMetricIDCheckedInFunction = false)
        {
            this.ID = AID;
            this.MetricListInPeriodID = AMetricListInPeriodID;
            this.CalcMetricID = ACalcMetricID;
            this.CalcMetricFlag = ACalcMetricFlag;
            this.SumMetricID = ASumMetricID;
            this.SumMetricName = ASumMetricName;
            this.SumMetricSort = ASumMetricSort;
            this.SumMetricCode = ASumMetricCode;
            this.SumMetricScreenCode = ASumMetricScreenCode;
            this.SumMetricFlag = ASumMetricFlag;
            this.SumMetricDK = ASumMetricDK;
            this.SumMetricIDCheckedInFunction = ASumMetricIDCheckedInFunction;
            SetFlagFields();
        }
        public MetricFunctionInPeriodLine()
        {
            this.ID = -1;
            this.MetricListInPeriodID = -1;          
            this.CalcMetricID = -1;
            this.CalcMetricFlag = 0;
            this.SumMetricID = -1;
            this.SumMetricName = "";
            this.SumMetricSort = "";
            this.SumMetricCode = "";
            this.SumMetricScreenCode = "";
            this.SumMetricFlag = 0;
            this.SumMetricDK = 1;
            this.SumMetricIDCheckedInFunction = false;
            SetFlagFields();
        }
        public void SetID(int AID)
        {
            if (AID > 0) this.ID = AID; else this.ID = -1;
        }
        public void SetFlagFields()
        {
            if (this.SumMetricDK <0) this.SumMetricIDIsNegative = true; else this.SumMetricIDIsNegative = false;
        }
        public void SetSumMetricIDIsNegative(bool AIsnegative)
        {
            this.SumMetricIDIsNegative = AIsnegative;
            if (this.SumMetricIDIsNegative) this.SumMetricDK = -1; else this.SumMetricDK = 1;
        }
    }
}