﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using KRO.Contents;

namespace KRO.Models
{
    [Serializable]
    public class MetricIDInPeriodLine
    {
        public int ID { get; private set; }
        public int MetricListInPeriodID { get; set; }
        public int MetricID { get; set; }
        public string MetricName { get; set; }
        public string MetricSort { get; set; }
        public string MetricCode { get; set; }

        public string MetricScreenCode { get; set; }
        public long MetricFlag { get; private set; }
        public int Flag { get; private set; }
        public bool MetricIDCheckedInPeriod { get; private set; }

        public bool FlagMetricCalculated { get; private set; }
        public MetricIDInPeriodLine(int AID, int AMetricListInPeriodID, 
                                    int AMetricID, string AMetricName,
                                    string AMetricSort, string AMetricCode,
                                    string AMetricScreenCode,long AMetricFlag, int AFlag)
        {
            this.ID = AID;
            this.MetricListInPeriodID = AMetricListInPeriodID;
            this.MetricID = AMetricID;
            this.MetricName = AMetricName;
            this.MetricSort = AMetricSort;
            this.MetricCode = AMetricCode;
            this.MetricScreenCode = AMetricScreenCode;
            this.MetricFlag = AMetricFlag;
            this.Flag = AFlag;
            SetFlagFields();
        }
        public MetricIDInPeriodLine()
        {
            this.ID = -1;
            this.MetricListInPeriodID = -1;
            this.MetricID = -1;
            this.MetricName = "";
            this.MetricSort = "";
            this.MetricCode = "";
            this.MetricScreenCode = "";
            this.MetricFlag = 0;
            this.Flag = 0;
            SetFlagFields();
        }
        public void SetID(int AID)
        {
            if (AID > 0) this.ID = AID; else this.ID = -1;
        }
        public void SetFlag(int AFlag)
        {
            if (AFlag > 0) this.Flag = AFlag; else this.Flag = 0;
            SetFlagFields();
        }
        public void SetFlagValue()
        {
            int lFlag = 0;
            if (this.MetricIDCheckedInPeriod) lFlag = lFlag |= KROFlag.flMetricIDCheckedInPeriod;
            this.Flag = lFlag;
        }
        public void SetFlagFields()
        {
            if ((this.Flag & KROFlag.flMetricIDCheckedInPeriod) == KROFlag.flMetricIDCheckedInPeriod) this.MetricIDCheckedInPeriod = true; else this.MetricIDCheckedInPeriod = false;
            if ((this.MetricFlag & KROFlag.flMetricCalculations) == KROFlag.flMetricCalculations) this.FlagMetricCalculated = true; else this.FlagMetricCalculated = false;
        }
        public void SetMetricIDCheckedInPeriod(bool AMetricIDCheckedInPeriod)
        {
            this.MetricIDCheckedInPeriod = AMetricIDCheckedInPeriod;
            SetFlagValue();
        }
    }
}