﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using KRO.Contents;

namespace KRO.Models
{   [Serializable]
    public class MetricListInPeriodLine
    {
        public int ID { get; private set; }
        public string Name { get; set; }
        public int MounthID { get; set; }
        public string MounthName { get; set; }
        public int YearID { get; set; }
        public string YearName { get; set; }
        public DateTime DateIn { get; set; }
        public int Flag { get; private set; }

        public MetricListInPeriodLine(int AID, int AMonthID, string AMounthName, int AYearID,
                                   string AYearName, DateTime ADateIn, int AFlag)
        {
            this.ID = AID;
            this.Name = KROConstants.MessageIncludedMetric;
            this.MounthID = AMonthID;
            this.MounthName = AMounthName;
            this.YearID = AYearID;
            this.YearName = AYearName;
            this.DateIn = ADateIn;
            this.Flag = AFlag;
            SetFlagFields();
        }
        public MetricListInPeriodLine()
        {
            this.ID = -1;
            this.Name = KROConstants.MessageIncludedMetric;
            this.MounthID = -1;
            this.MounthName = "";
            this.YearID = -1;
            this.YearName = "";
            this.DateIn = DateTime.Today;
            this.Flag = 0;
            SetFlagFields();
        }
        public void SetID(int AID)
        {
            if (AID > 0) this.ID = AID; else this.ID = -1;
        }
        public void SetFlag(int AFlag)
        {
            if (AFlag > 0) this.Flag = AFlag; else this.Flag = 0;
            SetFlagFields();
        }
        public void SetFlagFields()
        {
           // if ((this.Flag & KROFlag.flOnlyPerformerFlag) == KROFlag.flOnlyPerformerFlag) this.OnlyPerformerFlag = true; else this.OnlyPerformerFlag = false;
        }
    }
}