﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using KRO.Contents;

namespace KRO.Models
{
    [Serializable]
    public class RegionDirectionInPeriodLine
    {
        public int ID { get; private set; }
        public int DepPerInclRegID { get; set; }
        public int RegionID { get; set; }
        public string RegionName { get; set; }
        public string RegionSort { get; set; }
        public string RegionCode { get; set; }
        public string RegionDirectionName { get; set; }
        public int Flag { get; private set; }
        public bool RegionDirectionCheckedInPeriod { get; private set; }
        public RegionDirectionInPeriodLine(int AID, int ADepPerInclRegID, 
                                    int ARegionID, string ARegionName,
                                    string ARegionSort, string ARegionCode,
                                    string ARegionDirectionName, int AFlag)
        {
            this.ID = AID;
            this.DepPerInclRegID = ADepPerInclRegID;
            this.RegionID = ARegionID;
            this.RegionName = ARegionName;
            this.RegionSort = ARegionSort;
            this.RegionCode = ARegionCode;
            this.RegionDirectionName = ARegionDirectionName;
            this.Flag = AFlag;
            SetFlagFields();
        }
        public RegionDirectionInPeriodLine()
        {
            this.ID = -1;
            this.DepPerInclRegID = -1;
            this.RegionID = -1;
            this.RegionName = "";
            this.RegionSort = "";
            this.RegionCode = "";
            this.RegionDirectionName = "";
            this.Flag = 0;
            SetFlagFields();
        }
        public void SetID(int AID)
        {
            if (AID > 0) this.ID = AID; else this.ID = -1;
        }
        public void SetFlag(int AFlag)
        {
            if (AFlag > 0) this.Flag = AFlag; else this.Flag = 0;
            SetFlagFields();
        }
        public void SetFlagValue()
        {
            int lFlag = 0;
            if (this.RegionDirectionCheckedInPeriod) lFlag = lFlag |= KROFlag.flRegionDirectionCheckedInPeriod;
            this.Flag = lFlag;
        }
        public void SetFlagFields()
        {
            if ((this.Flag & KROFlag.flRegionDirectionCheckedInPeriod) == KROFlag.flRegionDirectionCheckedInPeriod) this.RegionDirectionCheckedInPeriod = true; else this.RegionDirectionCheckedInPeriod = false;
        }
        public void SetRegionDirectionCheckedInPeriod(bool ARegionDirectionCheckedInPeriod)
        {
            this.RegionDirectionCheckedInPeriod = ARegionDirectionCheckedInPeriod;
            SetFlagValue();
        }
    }
}