﻿using System;
using KRO.Contents;

namespace KRO.Models
{
    [Serializable]
    public class ReportsParameterLine
    {
        public int ReportParameterID { get; private set; }
        public int MonthID { get; set; }
        public string MonthName { get; set; }
        public int YearID { get; set; }
        public string YearName { get; set; }
        public int TypeID { get; set; }
        public string TypeReportName { get; set; }
        public string ViewType { get; set; }
        public int DepartmentID { get; set; }
        public string DepartmentCode { get; set; }
        public string DepartmentName { get; set; }
        public string DepartmentCategory { get; set; }
        public string DepartmentSort { get; set; }
        public int ContractorID { get; set; }
        public long ReportFlag { get; private set; }
        public string Comment { get; set; }
        //Flag fields
        public bool ReportIsCheckEconomic { get; private set; }
        public bool ReportIsCheckFilial { get; private set; }
        public bool ReportIsCheckRegion { get; private set; }
        public ReportsParameterLine(int AReportParameterID, int AMonthID, string AMonthName, int AYearID,
            string AYearName,int ATypeID,string ATypeReportName,string AViewType,int ADepartmentID,
            string ADepartmentCode,string ADepartmentName,string ADepartmentCategory,
            string ADepartmentSort, int AContractorID, long AReportFlag, string AComment)
		{
             this.ReportParameterID =AReportParameterID;
             this.MonthID=AMonthID;
             this.MonthName=AMonthName;
             this.YearID=AYearID;
             this.YearName=AYearName;
             this.TypeID=ATypeID;
             this.TypeReportName=ATypeReportName;
             this.ViewType=AViewType;
             this.DepartmentID=ADepartmentID;
             this.DepartmentCode=ADepartmentCode;
             this.DepartmentName=ADepartmentName;
             this.DepartmentCategory=ADepartmentCategory;
             this.DepartmentSort=ADepartmentSort;
             this.ContractorID = AContractorID;
             this.ReportFlag=AReportFlag;
             this.Comment =AComment;

             SetFlagFields();
		}
        public ReportsParameterLine(int AMonthID, string AMonthName, int AYearID,
            string AYearName, int ATypeID, string ATypeReportName, string AViewType, int ADepartmentID,
            string ADepartmentCode, string ADepartmentName, string ADepartmentCategory,
            string ADepartmentSort, int AContractorID, long AReportFlag, string AComment)
        {
            this.ReportParameterID = -1;
            this.MonthID = AMonthID;
            this.MonthName = AMonthName;
            this.YearID = AYearID;
            this.YearName = AYearName;
            this.TypeID = ATypeID;
            this.TypeReportName = ATypeReportName;
            this.ViewType = AViewType;
            this.DepartmentID = ADepartmentID;
            this.DepartmentCode = ADepartmentCode;
            this.DepartmentName = ADepartmentName;
            this.DepartmentCategory = ADepartmentCategory;
            this.DepartmentSort = ADepartmentSort;
            this.ContractorID = AContractorID;
            this.ReportFlag = AReportFlag;
            this.Comment = AComment;

            SetFlagFields();
        }
        public ReportsParameterLine()
        {
             this.ReportParameterID =-1;
             this.MonthID=-1;
             this.MonthName = "";
             this.YearID=-1;
             this.YearName="";
             this.TypeID=-1;
             this.TypeReportName="";
             this.ViewType="";
             this.DepartmentID=-1;
             this.DepartmentCode="";
             this.DepartmentName="";
             this.DepartmentCategory="";
             this.DepartmentSort="";
             this.ContractorID=-1;
             this.ReportFlag=0;
             this.Comment = "";

             SetFlagFields();
        }
        public void SetReportParameterID(int AReportParameterID)
        {
            if (AReportParameterID > 0) this.ReportParameterID = AReportParameterID; else this.ReportParameterID = -1; 
        }
        public void SetReportFlag(int AReportFlag)
        {
            if (AReportFlag > 0) this.ReportFlag = AReportFlag; else this.ReportFlag = 0;
        }
        public void SetFlagFields()
        {
            if ((this.ReportFlag & KROFlag.flReportIsCheckEconomic) == KROFlag.flReportIsCheckEconomic) this.ReportIsCheckEconomic = true; else this.ReportIsCheckEconomic = false;
            if ((this.ReportFlag & KROFlag.flReportIsCheckFilial) == KROFlag.flReportIsCheckFilial) this.ReportIsCheckFilial = true; else this.ReportIsCheckFilial = false;
            if ((this.ReportFlag & KROFlag.flReportIsCheckRegion) == KROFlag.flReportIsCheckRegion) this.ReportIsCheckRegion = true; else this.ReportIsCheckRegion = false;
        }

        public void SetReportIsCheckEconomic()
        {
            this.ReportFlag = this.ReportFlag | KROFlag.flReportIsCheckEconomic;
            SetFlagFields();
        }
        public void SetReportIsUnCheckEconomic()
        {
            this.ReportFlag &= ~KROFlag.flReportIsCheckEconomic;
            SetFlagFields();
        }
        public void SetReportIsCheckFilial()
        {
            this.ReportFlag = this.ReportFlag | KROFlag.flReportIsCheckFilial;
            SetFlagFields();
        }
        public void SetReportIsUnCheckFilial()
        {
            this.ReportFlag &= ~KROFlag.flReportIsCheckFilial;
            SetFlagFields();
        }
        public void SetReportIsCheckRegion()
        {
            this.ReportFlag = this.ReportFlag | KROFlag.flReportIsCheckRegion;
            SetFlagFields();
        }
        public void SetReportIsUnCheckRegion()
        {
            this.ReportFlag &= ~KROFlag.flReportIsCheckRegion;
            SetFlagFields();
        }
    }
}