﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using KRO.Contents;

namespace KRO.Models
{

    [Serializable]
    public class UserArtistCheckLine
    {
        public int RegionID { get; private set; }
        public int UserID { get; set; }
        public int? ArtistRegionID { get; set; }
        public string ArtistRegionName { get; set; }
        public string ArtistRegionCode { get; set; }
        public string ArtistRegionSort { get; set; }
        public long Flag { get; private set; }
        public bool CheckRead { get; private set; }
        public bool CheckWrite { get; private set; }
        public bool CheckDepartment { get; private set; }
        public bool CheckRegion { get; private set; }

        public UserArtistCheckLine(int ARegionID, int AUserID, int? AArtistRegionID, string AArtistRegionName,
                                   string AArtistRegionCode, string AArtistRegionSort, long AFlag)
		{
            this.RegionID = ARegionID; 
            this.UserID = AUserID;
            this.ArtistRegionID = AArtistRegionID;
            this.ArtistRegionName = AArtistRegionName;
            this.ArtistRegionCode = AArtistRegionCode;
            this.ArtistRegionSort = AArtistRegionSort;
            this.Flag = AFlag;
            SetFlagFields();
		}
        public UserArtistCheckLine(int ARegionID, int AUserID, string AArtistRegionName,
                                   string AArtistRegionCode, string AArtistRegionSort, long AFlag)
        {
            this.RegionID = ARegionID;
            this.UserID = AUserID;
            this.ArtistRegionID = -1;
            this.ArtistRegionName = AArtistRegionName;
            this.ArtistRegionCode = AArtistRegionCode;
            this.ArtistRegionSort = AArtistRegionSort;
            this.Flag = AFlag;
            SetFlagFields();
        }
        public UserArtistCheckLine()
        {
            this.RegionID = -1;
            this.UserID = -1;
            this.ArtistRegionID = -1;
            this.ArtistRegionName = "";
            this.ArtistRegionCode = "";
            this.ArtistRegionSort = "";
            this.Flag = 0;
            SetFlagFields();
        }
        public void SetID(int ARegionID)
        {
            if (ARegionID > 0) this.RegionID = ARegionID; else this.RegionID = -1; 
        }
        public void SetFlag(int AFlag)
        {
            if (AFlag > 0) this.Flag = AFlag; else this.Flag = 0;
            SetFlagFields();
        }
        private void SetFlagFields()
        {
            if ((this.Flag & KROFlag.flCheckRead) == KROFlag.flCheckRead) this.CheckRead = true; else this.CheckRead = false;
            if ((this.Flag & KROFlag.flCheckWrite) == KROFlag.flCheckWrite) this.CheckWrite = true; else this.CheckWrite = false;
            if ((this.Flag & KROFlag.flCheckDepartment) == KROFlag.flCheckDepartment) this.CheckDepartment = true; else this.CheckDepartment = false;
            if ((this.Flag & KROFlag.flCheckRegion) == KROFlag.flCheckRegion) this.CheckRegion = true; else this.CheckRegion = false;
        }
    }
}