﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using KRO.Contents;

namespace KRO.Models
{
    [Serializable]
    public class UserBalanceCheckLine
    {
        public int RegionID { get; private set; }
        public int UserID { get; set; }
        public int? BalanceRegionID { get; set; }
        public string BalanceRegionName { get; set; }
        public string BalanceRegionCode { get; set; }
        public string BalanceRegionSort { get; set; }
        public long Flag { get; private set; }
        public bool CheckRead { get; private set; }
        public bool CheckWrite { get; private set; }
        public bool CheckDepartment { get; private set; }
        public bool CheckRegion { get; private set; }
        public UserBalanceCheckLine(int ARegionID, int AUserID, int? ABalanceRegionID, string ABalanceRegionName,
                                    string ABalanceRegionCode, string ABalanceRegionSort, long AFlag)
		{
            this.RegionID = ARegionID; 
            this.UserID = AUserID;
            this.BalanceRegionID = ABalanceRegionID;
            this.BalanceRegionName = ABalanceRegionName;
            this.BalanceRegionCode = ABalanceRegionCode;
            this.BalanceRegionSort = ABalanceRegionSort;
            this.Flag = AFlag;
            SetFlagFields();
		}
        public UserBalanceCheckLine(int ARegionID, int AUserID, string ABalanceRegionName,
                                    string ABalanceRegionCode, string ABalanceRegionSort, long AFlag)
        {
            this.RegionID = ARegionID;
            this.UserID = AUserID;
            this.BalanceRegionID = -1;
            this.BalanceRegionName = ABalanceRegionName;
            this.BalanceRegionCode = ABalanceRegionCode;
            this.BalanceRegionSort = ABalanceRegionSort;
            this.Flag = AFlag;
            SetFlagFields();
        }
        public UserBalanceCheckLine()
        {
            this.RegionID = -1;
            this.UserID = -1;
            this.BalanceRegionID = -1;
            this.BalanceRegionName = "";
            this.BalanceRegionCode = "";
            this.BalanceRegionSort = "";
            this.Flag = 0;
            SetFlagFields();
        }
        public void SetRegionID(int ARegionID)
        {
            if (ARegionID > 0) this.RegionID = ARegionID; else this.RegionID = -1; 
        }
        public void SetFlag(int AFlag)
        {
            if (AFlag > 0) this.Flag = AFlag; else this.Flag = 0;
            SetFlagFields();
        }
        private void SetFlagFields()
        {
            if (this.Flag > 0)
            {
                if ((this.Flag & KROFlag.flCheckRead) == KROFlag.flCheckRead) this.CheckRead = true; else this.CheckRead = false;
                if ((this.Flag & KROFlag.flCheckWrite) == KROFlag.flCheckWrite) this.CheckWrite = true; else this.CheckWrite = false;
                if ((this.Flag & KROFlag.flCheckDepartment) == KROFlag.flCheckDepartment) this.CheckDepartment = true; else this.CheckDepartment = false;
                if ((this.Flag & KROFlag.flCheckRegion) == KROFlag.flCheckRegion) this.CheckRegion = true; else this.CheckRegion = false;
            }
        }
    }
}