﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KRO.Authentication;
using KRO.Models;
using KRO.Contents;

namespace KRO.Pages.Admin
{
    public partial class ChangeManagerUser : System.Web.UI.Page
    {
        public User FChangeUser
        {
            get { return (User)ViewState["CheckedUser"]; }
            set { ViewState["CheckedUser"] = value; }
        }
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                ManagerUsers prevPage = PreviousPage as ManagerUsers;
                if (prevPage != null)
                    FChangeUser = prevPage.CheckedUser;
                InitFieldUser();
                gvUserBalanceCheckList.DataSource = ModelsManager.GetUserBalanceCheckList(FChangeUser.ID);
                gvUserBalanceCheckList.DataBind();
            }
        }

        private void InitFieldUser()
        {
            if (FChangeUser == null) FChangeUser = new User();
            lblFamily.Text = FChangeUser.Family;
            lblFirstName.Text = FChangeUser.FirstName;
            lblSecondName.Text = FChangeUser.SecondName;
            lblOfficeName.Text = FChangeUser.OfficeName;
            lblPhone.Text = FChangeUser.Phone;
            lblMail.Text = FChangeUser.EMail;
            lblDepartmentName.Text = FChangeUser.UserDepartmentName;
        }   
        protected void gvUserBalanceCheckList_RowCreated(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.Header)
            {
                GridViewRow lRowHeader1 = new GridViewRow(0, 0, DataControlRowType.Header, DataControlRowState.Normal);
                TableHeaderCell lCellHeader = new TableHeaderCell();
                lCellHeader.Text = "Регион";
                lCellHeader.RowSpan = 2;
                lRowHeader1.Controls.Add(lCellHeader);

                lCellHeader = new TableHeaderCell();
                lCellHeader.Text = "Ввод данных";
                lCellHeader.ColumnSpan = 2;
                lRowHeader1.Controls.Add(lCellHeader);

                lCellHeader = new TableHeaderCell();
                lCellHeader.Text = "Блокировки";
                lCellHeader.ColumnSpan = 2;
                lRowHeader1.Controls.Add(lCellHeader);

                lRowHeader1.CssClass = "ssHeader";
                GridViewRow lRowHeader2 = new GridViewRow(0, 0, DataControlRowType.Header, DataControlRowState.Normal);

                lCellHeader = new TableHeaderCell();
                lCellHeader.Text = "Чтение";
                lRowHeader2.Controls.Add(lCellHeader);

                lCellHeader = new TableHeaderCell();
                lCellHeader.Text = "Редактирование";
                lRowHeader2.Controls.Add(lCellHeader);

                lCellHeader = new TableHeaderCell();
                lCellHeader.Text = "Филиал";
                lRowHeader2.Controls.Add(lCellHeader);

                lCellHeader = new TableHeaderCell();
                lCellHeader.Text = "Регион";
                lRowHeader2.Controls.Add(lCellHeader);

                lRowHeader2.CssClass = "ssHeaderSecond";
               
                gvUserBalanceCheckList.Controls[0].Controls.AddAt(0, lRowHeader2);
                gvUserBalanceCheckList.Controls[0].Controls.AddAt(0, lRowHeader1);
            }
        }
        protected void ButtonCancel_Click(object sender, EventArgs e)
        {
            Server.Transfer(Constants.MANAGER_USERS_PAGE_URL);
        }
        protected void ButtonApply_Click(object sender, EventArgs e)
        {
            if ((gvUserBalanceCheckList != null) && (gvUserBalanceCheckList.Rows.Count > 0))
            {
                int lBalanceRegionID;
                int lUserID;
                int lRegionID;
                long lFlag;
                UserBalanceCheckLine lUserBalanceCheckLine;
                CheckBox lCheckBox;
                Label lLabel;
                foreach (GridViewRow lUserBalanceCheckRow in gvUserBalanceCheckList.Rows)
                {   
                    if (lUserBalanceCheckRow.RowType == DataControlRowType.DataRow)
                    {   
                        //обнулим значения
                        lBalanceRegionID = 0;
                        lUserID = 0;
                        lRegionID = 0;
                        lFlag = 0;
                        lUserBalanceCheckLine = null;
                        //соберем значение флага
                        lCheckBox = null;
                        lCheckBox = (CheckBox)lUserBalanceCheckRow.FindControl("cbCheckRead");
                        if ((lCheckBox != null) && (lCheckBox.Checked)) { lFlag = lFlag |= KROFlag.flCheckRead; }
                        lCheckBox = null;
                        lCheckBox = (CheckBox)lUserBalanceCheckRow.FindControl("cbCheckWrite");
                        if ((lCheckBox != null) && (lCheckBox.Checked)) { lFlag = lFlag |= KROFlag.flCheckWrite; }
                        lCheckBox = null;
                        lCheckBox = (CheckBox)lUserBalanceCheckRow.FindControl("cbCheckDepartment");
                        if ((lCheckBox != null) && (lCheckBox.Checked)) { lFlag = lFlag |= KROFlag.flCheckDepartment; }
                        lCheckBox = null;
                        lCheckBox = (CheckBox)lUserBalanceCheckRow.FindControl("cbCheckRegion");
                        if ((lCheckBox != null) && (lCheckBox.Checked)) { lFlag = lFlag |= KROFlag.flCheckRegion; }
                        //сосчитали флаг
                        lLabel = null;
                        lLabel = (Label)lUserBalanceCheckRow.FindControl("lblBalanceRegionID");
                        if ((lLabel != null) && (lLabel.Text.Length > 0)) lBalanceRegionID = Int32.Parse(lLabel.Text); else lBalanceRegionID=-1;
                        lLabel = null;
                        lLabel = (Label)lUserBalanceCheckRow.FindControl("lblUserID");
                        if ((lLabel != null) && (lLabel.Text.Length > 0)) lUserID = Int32.Parse(lLabel.Text); else lUserID=-1;
                        lLabel = null;
                        lLabel = (Label)lUserBalanceCheckRow.FindControl("lblRegionID");
                        if ((lLabel != null) && (lLabel.Text.Length > 0)) lRegionID = Int32.Parse(lLabel.Text); else lRegionID=-1;
                        //создадим объект UserBalanceCheckLine
                        lUserBalanceCheckLine = new UserBalanceCheckLine(lRegionID, lUserID, lBalanceRegionID, "", "", "", lFlag);

                        if (lUserBalanceCheckLine.BalanceRegionID > 0) ModelsManager.UpdateUserBalanceCheck(lUserBalanceCheckLine); else ModelsManager.InsertUserBalanceCheck(lUserBalanceCheckLine);
                    }
                }
            }
        }

        protected void ButtonUndo_Click(object sender, EventArgs e)
        {
            gvUserBalanceCheckList.DataSource = ModelsManager.GetUserBalanceCheckList(FChangeUser.ID);
            gvUserBalanceCheckList.DataBind();
        }

        protected void CheckAllInputData_Click(object sender, EventArgs e)
        {
            if ((gvUserBalanceCheckList != null) && (gvUserBalanceCheckList.Rows.Count > 0))
            {
                CheckBox lCheckBox;
                foreach (GridViewRow lUserBalanceCheckRow in gvUserBalanceCheckList.Rows)
                {
                    if (lUserBalanceCheckRow.RowType == DataControlRowType.DataRow)
                    {
                        lCheckBox = null;
                        lCheckBox = (CheckBox)lUserBalanceCheckRow.FindControl("cbCheckRead");
                        if (lCheckBox != null) { lCheckBox.Checked = true; }
                        lCheckBox = null;
                        lCheckBox = (CheckBox)lUserBalanceCheckRow.FindControl("cbCheckWrite");
                        if (lCheckBox != null) { lCheckBox.Checked = true; }
                    }
                }
            }
        }

        protected void UnCheckAllInputData_Click(object sender, EventArgs e)
        {
            if ((gvUserBalanceCheckList != null) && (gvUserBalanceCheckList.Rows.Count > 0))
            {
                CheckBox lCheckBox;
                foreach (GridViewRow lUserBalanceCheckRow in gvUserBalanceCheckList.Rows)
                {
                    if (lUserBalanceCheckRow.RowType == DataControlRowType.DataRow)
                    {
                        lCheckBox = null;
                        lCheckBox = (CheckBox)lUserBalanceCheckRow.FindControl("cbCheckRead");
                        if (lCheckBox != null) { lCheckBox.Checked = false; }
                        lCheckBox = null;
                        lCheckBox = (CheckBox)lUserBalanceCheckRow.FindControl("cbCheckWrite");
                        if (lCheckBox != null) { lCheckBox.Checked = false; }
                    }
                }
            }
        }

        protected void CheckAllBlock_Click(object sender, EventArgs e)
        {
            if ((gvUserBalanceCheckList != null) && (gvUserBalanceCheckList.Rows.Count > 0))
            {
                CheckBox lCheckBox;
                foreach (GridViewRow lUserBalanceCheckRow in gvUserBalanceCheckList.Rows)
                {
                    if (lUserBalanceCheckRow.RowType == DataControlRowType.DataRow)
                    {
                        lCheckBox = null;
                        lCheckBox = (CheckBox)lUserBalanceCheckRow.FindControl("cbCheckDepartment");
                        if (lCheckBox != null) { lCheckBox.Checked = true; }
                        lCheckBox = null;
                        lCheckBox = (CheckBox)lUserBalanceCheckRow.FindControl("cbCheckRegion");
                        if (lCheckBox != null) { lCheckBox.Checked = true; }
                    }
                }
            }
        }

        protected void UnCheckAllBlock_Click(object sender, EventArgs e)
        {
            if ((gvUserBalanceCheckList != null) && (gvUserBalanceCheckList.Rows.Count > 0))
            {
                CheckBox lCheckBox;
                foreach (GridViewRow lUserBalanceCheckRow in gvUserBalanceCheckList.Rows)
                {
                    if (lUserBalanceCheckRow.RowType == DataControlRowType.DataRow)
                    {
                        lCheckBox = null;
                        lCheckBox = (CheckBox)lUserBalanceCheckRow.FindControl("cbCheckDepartment");
                        if (lCheckBox != null) { lCheckBox.Checked = false; }
                        lCheckBox = null;
                        lCheckBox = (CheckBox)lUserBalanceCheckRow.FindControl("cbCheckRegion");
                        if (lCheckBox != null) { lCheckBox.Checked = false; }
                    }
                }
            }
        }
    }
}