﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KRO.Authentication;
using KRO.Models;
using KRO.Contents;

namespace KRO.Pages.Admin
{
    public partial class ChangePassword : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                InitFieldChangeUserPassword();
            }
        }
        private void InitFieldChangeUserPassword()
        {
            User lUser = AuthenticationManager.GetAuthenticationUserModel(Session);
            txtUserName.Text = lUser.Name;
        }
        protected void btnChangePassword_Click(object sender, EventArgs e)
        {
            //get parameter;
            string lLogin=txtUserName.Text;
            string lOldPassword=txtPassword.Text;
            string lNewPassword=tbNewPassword.Text;
            string lAnyNewPassword=tbAnyNewPassword.Text;
            if ((lLogin.Length==0) || (lOldPassword.Length==0) || (lNewPassword.Length==0) || (lAnyNewPassword.Length==0) || (!lNewPassword.Equals(lAnyNewPassword))) {
                lblChangePasswordError.Visible = true;
            }  else {
                bool lResult = false;
                User lUser = AuthenticationManager.GetAuthenticationUserModel(Session);
                try
                {
                    lResult = UsersManager.ChangeUserPassword(lUser, lLogin, lOldPassword, lNewPassword);
                    if (!lResult) lblChangePasswordError.Text = KROConstants.msgUserParameterError;
                }
                catch (Exception exp)
                {   //определим что за байда приключилась
                    if (exp.Message.IndexOf(KROConstants.fndExcpUserIndexError) > -1) lblChangePasswordError.Text = KROConstants.msgUserIndexError;
                    else lblChangePasswordError.Text = KROConstants.msgUserParameterError;//восстановим сообщение мало-ли до этого менялось
                }
                // обработка результатов сохранения
                if (lResult)
                {
                    // сохраним удачное сообщение в LogOuts
                    ModelsManager.InsertLogOut(ModelsManager.GetLogMessage(KROConstants.lgChangePasswordUser + " | " + lUser.Name + " | " + lUser.ID, 1), KROFlag.flLogExchangeUsers, lUser.ID);
                    Response.Redirect(Constants.LOGIN_PAGE_URL);
                }
                else {
                    // сохраним неудачное сообщение в LogOuts
                    ModelsManager.InsertLogOut(ModelsManager.GetLogMessage(KROConstants.lgChangePasswordUser + " | " + lUser.Name + " | " + lUser.ID, 2), KROFlag.flLogExchangeUsers, lUser.ID);
                    lblChangePasswordError.Visible = true; 
                } 
            }
        }
    }
}