﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using KRO.Contents;
using KRO.Authentication;
using KRO.Models;

namespace KRO.Pages.Admin
{
    public partial class LogOuts : System.Web.UI.Page
    {
        bool FCreatedHeader;
        private static List<LogOutLine> FLogOutLine = new List<LogOutLine>();
        private static List<LogOutLine> FLogOutLineHeaderEmty = new List<LogOutLine>();
        public LogOutLine CheckedLogOut
        {
            get { return (LogOutLine)ViewState["CheckedLogOut"]; }
            set { ViewState["CheckedLogOut"] = value; }
        }
        protected void Page_Load(object sender, EventArgs e)
        {
            FCreatedHeader = false;
            if (!Page.IsPostBack)
            {
                FLogOutLine = ModelsManager.GetLogOutList(DateTime.Now.AddDays(KROConstants.LogOutDefultDateInterval*(-1)), DateTime.Now);
                GridViewLogOutsList.SelectedIndex = -1;
                GridViewLogOutsList.DataSource = FLogOutLine;
                GridViewLogOutsList.DataBind();
                gvLogOutListHeader.DataSource = FLogOutLineHeaderEmty;
                gvLogOutListHeader.DataBind();
                FCreatedHeader = true;
            }
            if (!FCreatedHeader)
            {
                gvLogOutListHeader_DataBound(gvLogOutListHeader, null);
            }
        }
        protected void gvLogOutListHeader_DataBound(object sender, EventArgs e)
        {
            GridViewRow lRowHeader = new GridViewRow(0, 0, DataControlRowType.Header, DataControlRowState.Normal);
            TableHeaderCell lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Дата";
            lCellHeader.Width = 100;
            lRowHeader.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Тип";
            lCellHeader.Width = 100;
            lRowHeader.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Системное сообщение";
            lCellHeader.Width = 300;
            lRowHeader.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Фамилия";
            lCellHeader.Width = 150;
            lRowHeader.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Имя";
            lCellHeader.Width = 100;
            lRowHeader.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Отчество";
            lCellHeader.Width = 100;
            lRowHeader.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Филиал";
            lCellHeader.Width = 150;
            lRowHeader.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Роль";
            lCellHeader.Width = 80;
            lRowHeader.Controls.Add(lCellHeader);

            lRowHeader.CssClass = "ssHeader";
            if (gvLogOutListHeader.HeaderRow != null)
            {
                gvLogOutListHeader.HeaderRow.Parent.Controls.AddAt(0, lRowHeader);
            }
        }
        protected void GridViewLogOutsList_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow)
            {
                int lColumnCount = e.Row.Cells.Count;
                if (e.Row.RowIndex % 2 == 0) ChangeColorCells(e, lColumnCount, "background:#f7f9fc;", "#f7f9fc");
            }
        }
        protected void ChangeColorCells(GridViewRowEventArgs e, int AEndColumnindex, string AAttributeColor, string AColor)
        {
            for (int columnIndex = 0; columnIndex < AEndColumnindex + 1; columnIndex++)
            {
                try
                {
                    if (columnIndex <= AEndColumnindex)
                    {
                        e.Row.Cells[columnIndex].Attributes["style"] += AAttributeColor;
                        TextBox lTextBox = (TextBox)e.Row.Cells[columnIndex].Controls[3];
                        lTextBox.BackColor = ColorTranslator.FromHtml(AColor);
                    }
                    else { e.Row.Cells[columnIndex].Attributes["style"] += AAttributeColor; }
                }
                catch { }
            }
        }
    }
}