﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using KRO.Contents;
using KRO.Authentication;

namespace KRO.Pages.Admin
{
    public partial class Users : System.Web.UI.Page
    {
        bool FCreatedHeader;
        private static List<User> FUserLine = new List<User>();
        private static List<User> FUserLineHeaderEmty = new List<User>();
        public User CheckedUser
        {  
            get { return (User)ViewState["CheckedUser"]; }
            set { ViewState["CheckedUser"]  = value; }
        }
        protected void Page_Load(object sender, EventArgs e)
        {   
            FCreatedHeader = false;
            if (!Page.IsPostBack)
           {
              FUserLine = UsersManager.GetUsers(KROConstants.FORM_USERS_FOR_ADMIN, AuthenticationManager.GetAuthenticationUserModel(Session).ID, true);
              GridViewUsersList.SelectedIndex = -1;
              GridViewUsersList.DataSource = FUserLine;
              GridViewUsersList.DataBind();
              gvUserListHeader.DataSource = FUserLineHeaderEmty;
              gvUserListHeader.DataBind();
              FCreatedHeader = true;
            }
            if (!FCreatedHeader) {
                gvUserListHeader_DataBound(gvUserListHeader, null); 
            }
        }
        protected void gvUserListHeader_DataBound(object sender, EventArgs e)
        {
            GridViewRow lRowHeader = new GridViewRow(0, 0, DataControlRowType.Header, DataControlRowState.Normal);
            TableHeaderCell lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Фамилия";
            lCellHeader.Width = 100;
            lRowHeader.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Имя";
            lCellHeader.Width = 70;
            lRowHeader.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Отчество";
            lCellHeader.Width = 80;
            lRowHeader.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Логин";
            lCellHeader.Width = 80;
            lRowHeader.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Должность и отдел";
            lCellHeader.Width = 300;
            lRowHeader.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Телефон";
            lCellHeader.Width = 80;
            lRowHeader.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "E-mail";
            lCellHeader.Width = 80;
            lRowHeader.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Филиал";
            lCellHeader.Width = 150;
            lRowHeader.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Роль";
            lCellHeader.Width = 100;
            lRowHeader.Controls.Add(lCellHeader);
            //добавим кнопку новый пользователь

            lCellHeader = new TableHeaderCell();
            ImageButton lImageButton = new ImageButton();
            lImageButton.Enabled = false;
            lImageButton.ImageUrl = KROConstants.IMAGE_EMTY_32;
            lImageButton.ID = "NewUser";

            lImageButton.Visible = true;
            lCellHeader.ColumnSpan = 2;
            lCellHeader.Width = 67;
            lImageButton.Enabled = true;
            lImageButton.ImageUrl = KROConstants.IMAGE_NEW_RECORD;
            lImageButton.Click += lImageButton_Click;

            lCellHeader.Controls.Add(lImageButton);
            lRowHeader.Controls.Add(lCellHeader);

            lRowHeader.CssClass = "ssHeader";
            if (gvUserListHeader.HeaderRow != null)
            {
                gvUserListHeader.HeaderRow.Parent.Controls.AddAt(0, lRowHeader);
            }
        }
        protected void lImageButton_Click(object sender, EventArgs e)
        {
            CheckedUser = new User();
            Server.Transfer(Constants.CHANGE_USER_PAGE_URL);
        }
        protected void GridViewUsersList_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow)
            {
                int lColumnCount = e.Row.Cells.Count;
                if (e.Row.RowIndex % 2 == 0) ChangeColorCells(e, lColumnCount, "background:#f7f9fc;", "#f7f9fc");
                // подменим рисунок удаления
                string lImageUrl;
                if (((User)e.Row.DataItem).IsDeleted) lImageUrl = KROConstants.IMAGE_LOCKED; else lImageUrl = KROConstants.IMAGE_UNLOCK;

                try
                {
                    ((ImageButton)e.Row.Cells[e.Row.Cells.Count - 1].Controls[0]).ImageUrl = lImageUrl;
                }
                catch { }
                // типа подменили уже
            }
        }
        protected void ChangeColorCells(GridViewRowEventArgs e, int AEndColumnindex, string AAttributeColor, string AColor)
        {
            for (int columnIndex = 0; columnIndex < AEndColumnindex+1; columnIndex++)
            {
                try
                {
                    if (columnIndex <= AEndColumnindex)
                    {
                        e.Row.Cells[columnIndex].Attributes["style"] += AAttributeColor;
                        TextBox lTextBox = (TextBox)e.Row.Cells[columnIndex].Controls[3];
                        lTextBox.BackColor = ColorTranslator.FromHtml(AColor);
                    }
                    else { e.Row.Cells[columnIndex].Attributes["style"] += AAttributeColor; }
                } catch {}
            }
        }

        protected void CheckedUserLink_Click(object sender, EventArgs e)
        {
            Response.Redirect(Constants.CHANGE_USER_PAGE_URL);
        }
        protected void GridViewUsersList_SelectedIndexChanged(object sender, EventArgs e)
        {
            GridView lGridView = (GridView)sender;
            if (lGridView.SelectedIndex >= 0) {
                CheckedUser = (User) FUserLine.Find(x => x.ID == (int) lGridView.SelectedDataKey.Value);
            }
            else { CheckedUser = new User(); }
            Server.Transfer(Constants.CHANGE_USER_PAGE_URL); //редактирование данных пользователя
        }
        protected void GridViewUsersList_RowDeleting(object sender, GridViewDeleteEventArgs e)
        {
            GridView lGridView = (GridView) sender;
            TableCell lCell = lGridView.Rows[e.RowIndex].Cells[0];
            int lUserID = (int)lGridView.DataKeys[e.RowIndex].Value;
            if (lUserID > 0)
            {
                User lUserLine = FUserLine.Find(Item => Item.ID == lUserID);
                lUserLine.IsDeleted = !lUserLine.IsDeleted; //инверсия удаления
                if (UsersManager.DeleteUser(lUserLine.ID,lUserLine.IsDeleted, Session))
                GridViewUsersList.DataSource = FUserLine;
                GridViewUsersList.DataBind();
            }
        }
    }
}