﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KRO.Models;
using KRO.Contents;

namespace KRO.Pages
{
    public partial class ChangeReportsParameterLine : System.Web.UI.Page
    {
        public ReportsParameterLine FReportsParameter
        {
            get { return (ReportsParameterLine)ViewState["ReportsParameterLine"]; }
            set { ViewState["ReportsParameterLine"] = value; }
        }
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                ddMounth.DataSource = ModelsManager.GetMounthList();
                ddMounth.DataBind();
                ddYear.DataSource = ModelsManager.GetYearList();
                ddYear.DataBind();
                ddDepartment.DataSource = ModelsManager.GetDepartmentList();
                ddDepartment.DataBind();
                ddTypeID.DataSource = ModelsManager.GetTypeList();
                ddTypeID.DataBind();
                ReportsParameterList prevPage = PreviousPage as ReportsParameterList;
                if (prevPage != null)
                    FReportsParameter = prevPage.CheckedReportsParameterLine;
                InitFieldUser();
            }
        }
        private void InitFieldUser()
        {
            if (FReportsParameter == null) FReportsParameter = new ReportsParameterLine();
            tbReportComment.Text = FReportsParameter.Comment;
            ddMounth.SelectedValue = FReportsParameter.MonthID.ToString();
            ddYear.SelectedValue = FReportsParameter.YearID.ToString();
            ddDepartment.SelectedValue = FReportsParameter.DepartmentID.ToString();
            ddTypeID.SelectedValue = FReportsParameter.TypeID.ToString();
           /* if ((FChangeUser.UserFlag & KROFlag.UserCheckRule) == KROFlag.UserCheckRule)
                cbCheckRule.Checked = true;
            else
                cbCheckRule.Checked = false;*/
        }
        protected void ButtonCancel_Click(object sender, EventArgs e)
        {
            Server.Transfer(Constants.REPORTS_PARAMETER_LIST_PAGE_URL);
        }
        protected void ButtonApply_Click(object sender, EventArgs e)
        {
            lblExecuteError.Visible = false;
            bool lResultExecute = false;
            if (FReportsParameter == null) FReportsParameter = new ReportsParameterLine();

            FReportsParameter.Comment = tbReportComment.Text;
            FReportsParameter.MonthID = Int32.Parse(ddMounth.SelectedValue);
            FReportsParameter.YearID = Int32.Parse(ddYear.SelectedValue);
            FReportsParameter.DepartmentID = Int32.Parse(ddDepartment.SelectedValue);
            FReportsParameter.TypeID = Int32.Parse(ddTypeID.SelectedValue);

            if (FReportsParameter.ReportParameterID > 0) lResultExecute = ModelsManager.UpdateReportsParameter(FReportsParameter);
            else lResultExecute = ModelsManager.InsertReportsParameter(FReportsParameter);
            if (lResultExecute) Server.Transfer(Constants.REPORTS_PARAMETER_LIST_PAGE_URL);
            else lblExecuteError.Visible = true;
        }
    }
}