﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KRO.Authentication;
using KRO.Models;
using KRO.Contents;

namespace KRO.Pages.Directorys
{
    public partial class ChangeDepIncludeRegion : System.Web.UI.Page
    {
        public DepIncludeRegionLine FChangeDepIncludeRegion
        {
            get { return (DepIncludeRegionLine)ViewState["CheckedDepIncludeRegion"]; }
            set { ViewState["CheckedDepIncludeRegion"] = value; }
        }
        List<RegionLine> FAllRegionList;
        List<RegionDirectionInPeriodLine> FOldRegionDirectionList;
        List<RegionDirectionInPeriodLine> FActualRegionDirectionList;
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {   
                DepIncludeRegionList prevPage = PreviousPage as DepIncludeRegionList;
                if (prevPage != null)
                    FChangeDepIncludeRegion = prevPage.CheckedDepIncludeRegion;
                InitFieldDepIncludeRegion();
            }
        }
        private void InitFieldDepIncludeRegion()
        {
            if (FChangeDepIncludeRegion == null) FChangeDepIncludeRegion = new DepIncludeRegionLine();

            //получим списки
            ddlDepartment.DataSource = ModelsManager.GetDepartmentList();
            ddlDepartment.DataBind();
            ddlMounth.DataSource = ModelsManager.GetMounthList();
            ddlMounth.DataBind();
            List<YearLine> lYearList =  ModelsManager.GetYearList(false);
            ddlYear.DataSource = lYearList;
            ddlYear.DataBind();
            //конец блока получения списков

            ddlDepartment.SelectedValue = FChangeDepIncludeRegion.DepartmentID.ToString();
            if (FChangeDepIncludeRegion.ID > 0)
            {
                ddlMounth.SelectedValue = FChangeDepIncludeRegion.MounthID.ToString();
                ddlYear.SelectedValue = FChangeDepIncludeRegion.YearID.ToString();
            } 
            else
            {
                try
                {
                    DateTime lNow = DateTime.Today;
                    int lMounth = lNow.Month;
                    int lYear = lNow.Year;
                    ddlMounth.SelectedValue = lMounth.ToString();
                    ddlYear.SelectedValue = lYearList.Find(Item => Item.YearName == lYear.ToString()).YearID.ToString();
                }
                catch
                {
                    ddlMounth.SelectedValue = FChangeDepIncludeRegion.MounthID.ToString();
                    ddlYear.SelectedValue = FChangeDepIncludeRegion.YearID.ToString();
                }
            }
            if (FAllRegionList == null) FAllRegionList = ModelsManager.GetRegionList();
            // обновим таблицу дирекций
            FActualRegionDirectionList = GetActualRegionDirectionInPeriodList();
            gvDepIncludeRegionCheckList.DataSource = FActualRegionDirectionList;
            gvDepIncludeRegionCheckList.DataBind();
        }
        private List<RegionDirectionInPeriodLine> GetActualRegionDirectionInPeriodList()
        {
           DateTime lCheckDate = DateTime.Today;
           List<RegionDirectionInPeriodLine> lRegionDirectionInPeriodList = new List<RegionDirectionInPeriodLine>();
           if (FAllRegionList == null) FAllRegionList = ModelsManager.GetRegionList();
           if (FChangeDepIncludeRegion.ID > 0)
           {
              FOldRegionDirectionList = ModelsManager.GetRegionDirectionListByDepPerInclID(FChangeDepIncludeRegion.ID);
              if (FOldRegionDirectionList.Count > 0) // что-то получили по старым данным
              {
                  foreach (RegionLine lRegionLine in FAllRegionList)
                  {
                      RegionDirectionInPeriodLine lRegionDirectionLine = FOldRegionDirectionList.Find(x => x.RegionID == (int)lRegionLine.RegionID);
                      if (lRegionDirectionLine != null) lRegionDirectionInPeriodList.Add(lRegionDirectionLine);
                      else lRegionDirectionInPeriodList.Add(new RegionDirectionInPeriodLine(-1,
                                                                                            FChangeDepIncludeRegion.ID,
                                                                                            lRegionLine.RegionID,
                                                                                            lRegionLine.RegionName,
                                                                                            lRegionLine.RegionSort,
                                                                                            lRegionLine.RegionCode,
                                                                                            "",
                                                                                            0));
                  }
              } 
              else // если ни чего не получили тогда ищем последнии по дате
              {
                  // выбрали последние настройки если есть
                  lCheckDate = new DateTime(int.Parse(ddlYear.SelectedItem.ToString()), ddlMounth.SelectedIndex+1, 2);
                  FOldRegionDirectionList = ModelsManager.GetRegionDirectionListByDepartmentIDAndActualDate(Int32.Parse(ddlDepartment.SelectedValue), lCheckDate);
                  foreach (RegionLine lRegionLine in FAllRegionList)
                  {
                      RegionDirectionInPeriodLine lRegionDirectionLine = FOldRegionDirectionList.Find(x => x.RegionID == (int)lRegionLine.RegionID);
                      if (lRegionDirectionLine != null) lRegionDirectionInPeriodList.Add(new RegionDirectionInPeriodLine(-1,
                                                                                            -1,
                                                                                            lRegionLine.RegionID,
                                                                                            lRegionLine.RegionName,
                                                                                            lRegionLine.RegionSort,
                                                                                            lRegionLine.RegionCode,
                                                                                            lRegionDirectionLine.RegionDirectionName,
                                                                                            lRegionDirectionLine.Flag));
                      else lRegionDirectionInPeriodList.Add(new RegionDirectionInPeriodLine(-1,
                                                                                            -1,
                                                                                            lRegionLine.RegionID,
                                                                                            lRegionLine.RegionName,
                                                                                            lRegionLine.RegionSort,
                                                                                            lRegionLine.RegionCode,
                                                                                            "",
                                                                                            0));
                  }
              }                               
           } else // новая запись пытаемся создать полный список со старыми наименованиями.
           { 
                // выбрали последние настройки если есть
                lCheckDate = new DateTime(int.Parse(ddlYear.SelectedItem.ToString()), ddlMounth.SelectedIndex+1, 2);
                FOldRegionDirectionList = ModelsManager.GetRegionDirectionListByDepartmentIDAndActualDate(Int32.Parse(ddlDepartment.SelectedValue),lCheckDate);
                foreach (RegionLine lRegionLine in FAllRegionList)
                    {
                        RegionDirectionInPeriodLine lRegionDirectionLine = FOldRegionDirectionList.Find(x => x.RegionID == (int) lRegionLine.RegionID);
                        if (lRegionDirectionLine != null) lRegionDirectionInPeriodList.Add(new RegionDirectionInPeriodLine(-1,
                                                                                            -1,
                                                                                            lRegionLine.RegionID,
                                                                                            lRegionLine.RegionName,
                                                                                            lRegionLine.RegionSort,
                                                                                            lRegionLine.RegionCode,
                                                                                            lRegionDirectionLine.RegionDirectionName,
                                                                                            lRegionDirectionLine.Flag));
                        else lRegionDirectionInPeriodList.Add(new RegionDirectionInPeriodLine(-1,
                                                                                            -1,
                                                                                            lRegionLine.RegionID,
                                                                                            lRegionLine.RegionName,
                                                                                            lRegionLine.RegionSort,
                                                                                            lRegionLine.RegionCode,
                                                                                            "",
                                                                                            0));
                    }
           }
           return lRegionDirectionInPeriodList;
        }
        protected void gvDepIncludeRegionCheckList_RowCreated(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.Header)
            {
                GridViewRow lRowHeader1 = new GridViewRow(0, 0, DataControlRowType.Header, DataControlRowState.Normal);
                TableHeaderCell lCellHeader = new TableHeaderCell();
                lCellHeader.Text = "Наименование региона";
                lCellHeader.Width = 250;
                lCellHeader.RowSpan = 1;
                lRowHeader1.Controls.Add(lCellHeader);

                lCellHeader = new TableHeaderCell();
                lCellHeader.Text = "Код";
                lCellHeader.Width = 100;
                lCellHeader.ColumnSpan = 1;
                lRowHeader1.Controls.Add(lCellHeader);

                lCellHeader = new TableHeaderCell();
                lCellHeader.Text = "Наименование дирекции";
                lCellHeader.Width = 300;
                lCellHeader.ColumnSpan = 1;
                lRowHeader1.Controls.Add(lCellHeader);

                lCellHeader = new TableHeaderCell();
                lCellHeader.Text = "Включен";
                lCellHeader.Width = 90;
                lCellHeader.ColumnSpan = 1;
                lRowHeader1.Controls.Add(lCellHeader);

                lRowHeader1.CssClass = "ssHeaderSecond";
                gvDepIncludeRegionCheckList.Controls[0].Controls.AddAt(0, lRowHeader1);
            }
        }
        protected void ButtonCancel_Click(object sender, EventArgs e)
        {
            Server.Transfer(Constants.DEPINCLUDEREGION_LIST_PAGE_URL);
        }
        protected void ButtonApply_Click(object sender, EventArgs e)
        {
            bool lAllParameterReady = true;
            lblExecuteError.Visible = false; //первоначально погасим сообщение если было уже включено
            //соберем данные
            FChangeDepIncludeRegion.DepartmentID = Int32.Parse(ddlDepartment.SelectedValue);
            FChangeDepIncludeRegion.DepartmentName = ddlDepartment.Text;
            FChangeDepIncludeRegion.MounthID = Int32.Parse(ddlMounth.SelectedValue);
            FChangeDepIncludeRegion.MounthName = ddlMounth.Text;
            FChangeDepIncludeRegion.YearID = Int32.Parse(ddlYear.SelectedValue);
            FChangeDepIncludeRegion.YearName = ddlYear.Text;
            if ((FChangeDepIncludeRegion.DepartmentID > 0) && (FChangeDepIncludeRegion.MounthID>0) && (FChangeDepIncludeRegion.YearID>0))
            {
                if (FActualRegionDirectionList == null) FActualRegionDirectionList = GetActualRegionDirectionInPeriodList(); // получим список дирекций
                if ((gvDepIncludeRegionCheckList != null) && (gvDepIncludeRegionCheckList.Rows.Count > 0))
                {
                    int lRegionID;
                    string lRegionDirectionName;
                    bool lCheckedRegion;
                    CheckBox lCheckBox;
                    Label lLabelRegionID;
                    TextBox lTextBoxRegionDirectionName;
                    RegionDirectionInPeriodLine lRegionDirectionInPeriodLine;
                    foreach (GridViewRow lDepIncludeRegionCheckRow in gvDepIncludeRegionCheckList.Rows)
                    {
                        if (lDepIncludeRegionCheckRow.RowType == DataControlRowType.DataRow)
                        {
                            //обнулим значения
                            lRegionID = 0;
                            lRegionDirectionName = "";
                            lCheckedRegion = false;
                            //соберем выбранные регионы 
                            lCheckBox = null;
                            lLabelRegionID = null;
                            lTextBoxRegionDirectionName = null;
                            lRegionDirectionInPeriodLine = null;
                            try
                            {
                                //получили ID региона
                                lLabelRegionID = (Label)lDepIncludeRegionCheckRow.FindControl("lblRegionID");
                                if ((lLabelRegionID != null) && (lLabelRegionID.Text.Length > 0)) lRegionID = Int32.Parse(lLabelRegionID.Text); else lRegionID = -1;
                                lTextBoxRegionDirectionName = (TextBox)lDepIncludeRegionCheckRow.FindControl("tbRegionDirection");
                                if ((lTextBoxRegionDirectionName != null) && (lTextBoxRegionDirectionName.Text.Length > 0)) lRegionDirectionName = lTextBoxRegionDirectionName.Text; else lRegionDirectionName = "";                                
                                lCheckBox = (CheckBox)lDepIncludeRegionCheckRow.FindControl("cbCheckRegion");
                                if ((lCheckBox != null) && (lCheckBox.Checked)) lCheckedRegion = true;
                                //найдем объект
                                lRegionDirectionInPeriodLine = FActualRegionDirectionList.Find(x => x.RegionID == (int)lRegionID);
                                //подменим данные
                                lRegionDirectionInPeriodLine.RegionDirectionName = lRegionDirectionName;
                                lRegionDirectionInPeriodLine.SetRegionDirectionCheckedInPeriod(lCheckedRegion);
                            }
                            catch { }
                        }
                    }
                }
                else { lAllParameterReady = false; }
            }
            else { lAllParameterReady = false; }
            int lDepIncludeRegionID = FChangeDepIncludeRegion.ID; //переменная необходима для проверки перед выводом в LogOut. а что собственно пытались сделать
            if (lAllParameterReady)
            {
                //по новой используем переменную lAllParameterReady
                lAllParameterReady = false;
                //попытка сохранения результатов и соответствующая реакция
                try
                {
                    if (FChangeDepIncludeRegion.ID > 0) lAllParameterReady = ModelsManager.UpdateDepIncludeRegionCheck(FChangeDepIncludeRegion, FActualRegionDirectionList);
                    else
                    {   
                        try {
                            lAllParameterReady = ModelsManager.InsertDepIncludeRegion(FChangeDepIncludeRegion, FActualRegionDirectionList);
                        }
                        catch (Exception expinsert) {
                            FChangeDepIncludeRegion.SetID(-1);
                            throw expinsert;
                        }
                    }
                    if (!lAllParameterReady) lblExecuteError.Text = KROConstants.msgUserUpdateError; //восстановим сообщение мало-ли до этого менялось
                }
                catch (Exception exp)
                {   //определим что за байда приключилась
                    if (exp.Message.IndexOf(KROConstants.fndExcpDepIncludeRegionIndexError) > -1) lblExecuteError.Text = KROConstants.msgDepIncludeRegionIndexError;
                    else lblExecuteError.Text = KROConstants.msgUserUpdateError; 
                } 
                // обработка результатов сохранения
                if (lAllParameterReady)
                {
                    // сохраним удачное сообщение в LogOuts
                    if (lDepIncludeRegionID > 0) ModelsManager.InsertLogOut(ModelsManager.GetLogMessage(KROConstants.lgUpdateDepIncludeRegion + " | " + FChangeDepIncludeRegion.DepartmentName + " | " + FChangeDepIncludeRegion.MounthName + " | " + FChangeDepIncludeRegion.YearName, 3), KROFlag.flLogExchangeUsers, AuthenticationManager.GetAuthenticationUserModel(Session).ID);
                    else ModelsManager.InsertLogOut(ModelsManager.GetLogMessage(KROConstants.lgInsertDepIncludeRegion + " | " + FChangeDepIncludeRegion.DepartmentName + " | " + FChangeDepIncludeRegion.MounthName + " | " + FChangeDepIncludeRegion.YearName, 4), KROFlag.flLogExchangeUsers, AuthenticationManager.GetAuthenticationUserModel(Session).ID);
                    Server.Transfer(Constants.DEPINCLUDEREGION_LIST_PAGE_URL);
                }
                else
                {
                    // сохраним неудачное сообщение в LogOuts
                    if (lDepIncludeRegionID > 0) ModelsManager.InsertLogOut(ModelsManager.GetLogMessage(KROConstants.lgUpdateDepIncludeRegion + " | " + FChangeDepIncludeRegion.DepartmentName + " | " + FChangeDepIncludeRegion.MounthName + " | " + FChangeDepIncludeRegion.YearName, 2), KROFlag.flLogExchangeUsers, AuthenticationManager.GetAuthenticationUserModel(Session).ID);
                    else ModelsManager.InsertLogOut(ModelsManager.GetLogMessage(KROConstants.lgInsertDepIncludeRegion + " | " + FChangeDepIncludeRegion.DepartmentName + " | " + FChangeDepIncludeRegion.MounthName + " | " + FChangeDepIncludeRegion.YearName, 2), KROFlag.flLogExchangeUsers, AuthenticationManager.GetAuthenticationUserModel(Session).ID);
                    lblExecuteError.Visible = true;
                }
            }
            else 
            { 
                lblExecuteError.Text = KROConstants.msgUserUpdateError;
                lblExecuteError.Visible = true; 
            }
        }

        protected void ButtonUndo_Click(object sender, EventArgs e)
        {
            InitFieldDepIncludeRegion();
        }
        protected void btnGenLastDirection_Click(object sender, EventArgs e)
        {
            FActualRegionDirectionList = GetActualRegionDirectionInPeriodList();
            gvDepIncludeRegionCheckList.DataSource = FActualRegionDirectionList;
            gvDepIncludeRegionCheckList.DataBind();
        }
    }
}