﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KRO.Authentication;
using KRO.Models;
using KRO.Contents;

namespace KRO.Pages.Directorys
{
    public partial class ChangeDepListInPeriod : System.Web.UI.Page
    {
        public DepListInPeriodLine FChangeDepListInPeriod
        {
            get { return (DepListInPeriodLine)ViewState["CheckedDepListInPeriod"]; }
            set { ViewState["CheckedDepListInPeriod"] = value; }
        }
        List<DepartmentLine> FAllDepartmentList;
        List<DepartmentIDInPeriodLine> FOldDepartmentIDInPeriodList;
        List<DepartmentIDInPeriodLine> FActualDepartmentIDInPeriodList;
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                DepListInPeriodList prevPage = PreviousPage as DepListInPeriodList;
                if (prevPage != null)
                    FChangeDepListInPeriod = prevPage.CheckedDepListInPeriod;
                InitFieldDepListInPeriod();
            }
        }

        private void InitFieldDepListInPeriod()
        {
            if (FChangeDepListInPeriod == null) FChangeDepListInPeriod = new DepListInPeriodLine();
            //получим списки
            ddlMounth.DataSource = ModelsManager.GetMounthList();
            ddlMounth.DataBind();
            List<YearLine> lYearList = ModelsManager.GetYearList(false);
            ddlYear.DataSource = lYearList;
            ddlYear.DataBind();
            //конец блока получения списков
            if (FChangeDepListInPeriod.ID > 0)
            {
                ddlMounth.SelectedValue = FChangeDepListInPeriod.MounthID.ToString();
                ddlYear.SelectedValue = FChangeDepListInPeriod.YearID.ToString();
            }
            else
            {
                try
                {
                    DateTime lNow = DateTime.Today;
                    int lMounth = lNow.Month;
                    int lYear = lNow.Year;
                    ddlMounth.SelectedValue = lMounth.ToString();
                    ddlYear.SelectedValue = lYearList.Find(Item => Item.YearName == lYear.ToString()).YearID.ToString();
                }
                catch
                {
                    ddlMounth.SelectedValue = FChangeDepListInPeriod.MounthID.ToString();
                    ddlYear.SelectedValue = FChangeDepListInPeriod.YearID.ToString();
                }
            }
            // обновим таблицу дирекций
            FActualDepartmentIDInPeriodList = GetActualDepartmentIDInPeriodList();
            gvDepListInPeriodCheckList.DataSource = FActualDepartmentIDInPeriodList;
            gvDepListInPeriodCheckList.DataBind();
        }
        private List<DepartmentIDInPeriodLine> GetActualDepartmentIDInPeriodList()
        {
            DateTime lCheckDate = DateTime.Today;
            List<DepartmentIDInPeriodLine> lDepartmentIDInPeriodList = new List<DepartmentIDInPeriodLine>();
            if (FAllDepartmentList == null) FAllDepartmentList = ModelsManager.GetDepartmentList();
            if (FChangeDepListInPeriod.ID > 0)
            {
                FOldDepartmentIDInPeriodList = ModelsManager.GetDepartmentIDInPeriodByDepListInPeriodID(FChangeDepListInPeriod.ID);
                if (FOldDepartmentIDInPeriodList.Count > 0) // что-то получили по старым данным
                {
                    foreach (DepartmentLine lDepartmentLine in FAllDepartmentList)
                    {
                        DepartmentIDInPeriodLine lDepartmentIDInPeriodLine = FOldDepartmentIDInPeriodList.Find(x => x.DepartmentID == (int)lDepartmentLine.DepartmentID);
                        if (lDepartmentIDInPeriodLine != null) lDepartmentIDInPeriodList.Add(lDepartmentIDInPeriodLine);
                        else lDepartmentIDInPeriodList.Add(new DepartmentIDInPeriodLine(-1,
                                                                                        FChangeDepListInPeriod.ID,
                                                                                        lDepartmentLine.DepartmentID,
                                                                                        lDepartmentLine.DepartmentName,
                                                                                        lDepartmentLine.DepartmentSort,
                                                                                        lDepartmentLine.DepartmentCode,
                                                                                        0));
                    }
                }
                else // если ни чего не получили тогда ищем последнии по дате
                {
                    // выбрали последние настройки если есть
                    lCheckDate = new DateTime(int.Parse(ddlYear.SelectedItem.ToString()), ddlMounth.SelectedIndex + 1, 2);
                    FOldDepartmentIDInPeriodList = ModelsManager.GetDepartmentIDInPeriodListByActualDate(lCheckDate);
                    foreach (DepartmentLine lDepartmentLine in FAllDepartmentList)
                    {
                        DepartmentIDInPeriodLine lDepartmentIDInPeriodLine = FOldDepartmentIDInPeriodList.Find(x => x.DepartmentID == (int)lDepartmentLine.DepartmentID);
                        if (lDepartmentIDInPeriodLine != null) lDepartmentIDInPeriodList.Add(new DepartmentIDInPeriodLine(-1,
                                                                                              -1,
                                                                                              lDepartmentLine.DepartmentID,
                                                                                              lDepartmentLine.DepartmentName,
                                                                                              lDepartmentLine.DepartmentSort,
                                                                                              lDepartmentLine.DepartmentCode,
                                                                                              lDepartmentIDInPeriodLine.Flag));
                        else lDepartmentIDInPeriodList.Add(new DepartmentIDInPeriodLine(-1,
                                                                                              -1,
                                                                                              lDepartmentLine.DepartmentID,
                                                                                              lDepartmentLine.DepartmentName,
                                                                                              lDepartmentLine.DepartmentSort,
                                                                                              lDepartmentLine.DepartmentCode,
                                                                                              0));
                    }
                }
            }
            else // новая запись пытаемся создать полный список со старыми наименованиями.
            {
                // выбрали последние настройки если есть
                lCheckDate = new DateTime(int.Parse(ddlYear.SelectedItem.ToString()), ddlMounth.SelectedIndex + 1, 2);
                FOldDepartmentIDInPeriodList = ModelsManager.GetDepartmentIDInPeriodListByActualDate(lCheckDate);
                foreach (DepartmentLine lDepartmentLine in FAllDepartmentList)
                {
                    DepartmentIDInPeriodLine lDepartmentIDInPeriodLine = FOldDepartmentIDInPeriodList.Find(x => x.DepartmentID == (int)lDepartmentLine.DepartmentID);
                    if (lDepartmentIDInPeriodLine != null) lDepartmentIDInPeriodList.Add(new DepartmentIDInPeriodLine(-1,
                                                                                        -1,
                                                                                        lDepartmentLine.DepartmentID,
                                                                                        lDepartmentLine.DepartmentName,
                                                                                        lDepartmentLine.DepartmentSort,
                                                                                        lDepartmentLine.DepartmentCode,
                                                                                        lDepartmentIDInPeriodLine.Flag));
                    else lDepartmentIDInPeriodList.Add(new DepartmentIDInPeriodLine(-1,
                                                                                        -1,
                                                                                        lDepartmentLine.DepartmentID,
                                                                                        lDepartmentLine.DepartmentName,
                                                                                        lDepartmentLine.DepartmentSort,
                                                                                        lDepartmentLine.DepartmentCode,
                                                                                        0));
                }
            }
            return lDepartmentIDInPeriodList;
        }
        protected void gvDepListInPeriodCheckList_RowCreated(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.Header)
            {
                GridViewRow lRowHeader1 = new GridViewRow(0, 0, DataControlRowType.Header, DataControlRowState.Normal);
                TableHeaderCell lCellHeader = new TableHeaderCell();
                lCellHeader.Text = "Наименование филиала";
                lCellHeader.Width = 300;
                lCellHeader.RowSpan = 1;
                lRowHeader1.Controls.Add(lCellHeader);

                lCellHeader = new TableHeaderCell();
                lCellHeader.Text = "Код";
                lCellHeader.Width = 100;
                lCellHeader.ColumnSpan = 1;
                lRowHeader1.Controls.Add(lCellHeader);

                lCellHeader = new TableHeaderCell();
                lCellHeader.Text = "Включен";
                lCellHeader.Width = 90;
                lCellHeader.ColumnSpan = 1;
                lRowHeader1.Controls.Add(lCellHeader);

                lRowHeader1.CssClass = "ssHeaderSecond";
                gvDepListInPeriodCheckList.Controls[0].Controls.AddAt(0, lRowHeader1);
            }
        }
        protected void ButtonCancel_Click(object sender, EventArgs e)
        {
            Server.Transfer(Constants.DEPLISTINPERIOD_LIST_PAGE_URL);
        }
        protected void ButtonApply_Click(object sender, EventArgs e)
        {
            bool lAllParameterReady = true;
            lblExecuteError.Visible = false; //первоначально погасим сообщение если было уже включено
            //соберем данные
            FChangeDepListInPeriod.MounthID = Int32.Parse(ddlMounth.SelectedValue);
            FChangeDepListInPeriod.MounthName = ddlMounth.Text;
            FChangeDepListInPeriod.YearID = Int32.Parse(ddlYear.SelectedValue);
            FChangeDepListInPeriod.YearName = ddlYear.Text;
            if ((FChangeDepListInPeriod.MounthID > 0) && (FChangeDepListInPeriod.YearID > 0))
            {
                if (FActualDepartmentIDInPeriodList == null) FActualDepartmentIDInPeriodList = GetActualDepartmentIDInPeriodList(); // получим список филиалов
                if ((gvDepListInPeriodCheckList != null) && (gvDepListInPeriodCheckList.Rows.Count > 0))
                {
                    int lDepartmentID;
                    bool lCheckedDepartment;
                    CheckBox lCheckBoxDepartment;
                    Label lLabelDepartmentID;
                    DepartmentIDInPeriodLine lDepartmentIDInPeriodLine;
                    foreach (GridViewRow lDepListInPeriodCheckRow in gvDepListInPeriodCheckList.Rows)
                    {
                        if (lDepListInPeriodCheckRow.RowType == DataControlRowType.DataRow)
                        {
                            //обнулим значения
                            lDepartmentID = 0;
                            lCheckedDepartment = false;
                            //соберем выбранные филиалы 
                            lCheckBoxDepartment = null;
                            lLabelDepartmentID = null;
                            lDepartmentIDInPeriodLine = null;
                            try
                            {
                                //получили ID региона
                                lLabelDepartmentID = (Label)lDepListInPeriodCheckRow.FindControl("lblDepartmentID");
                                if ((lLabelDepartmentID != null) && (lLabelDepartmentID.Text.Length > 0)) lDepartmentID = Int32.Parse(lLabelDepartmentID.Text); else lDepartmentID = -1;
                                lCheckBoxDepartment = (CheckBox)lDepListInPeriodCheckRow.FindControl("cbCheckDepartment");
                                if ((lCheckBoxDepartment != null) && (lCheckBoxDepartment.Checked)) lCheckedDepartment = true;
                                //найдем объект
                                lDepartmentIDInPeriodLine = FActualDepartmentIDInPeriodList.Find(x => x.DepartmentID == (int)lDepartmentID);
                                //подменим данные
                                lDepartmentIDInPeriodLine.SetDepartmentDirectionCheckedInPeriod(lCheckedDepartment);
                            }
                            catch { }                             
                        }
                    }
                }
                else { lAllParameterReady = false; }
            }
            else { lAllParameterReady = false; }
            int lDepListInPeriodID = FChangeDepListInPeriod.ID; //переменная необходима для проверки перед выводом в LogOut. а что собственно пытались сделать
            if (lAllParameterReady)
            {
                //по новой используем переменную lAllParameterReady
                lAllParameterReady = false;
                //попытка сохранения результатов и соответствующая реакция
                try
                {
                    if (FChangeDepListInPeriod.ID > 0) lAllParameterReady = ModelsManager.UpdateDepListInPeriodCheck(FChangeDepListInPeriod, FActualDepartmentIDInPeriodList);
                    else
                    {
                        try {
                           lAllParameterReady = ModelsManager.InsertDepListInPeriod(FChangeDepListInPeriod, FActualDepartmentIDInPeriodList);
                        }
                        catch (Exception expinsert) {
                            FChangeDepListInPeriod.SetID(-1);
                            throw expinsert;
                        }
                    }
                    if (!lAllParameterReady) lblExecuteError.Text = KROConstants.msgUserUpdateError; //восстановим сообщение мало-ли до этого менялось
                }
                catch (Exception exp)
                {   //определим что за байда приключилась
                    if (exp.Message.IndexOf(KROConstants.fndExcpDepListInPeriodIndexError) > -1) lblExecuteError.Text = KROConstants.msgDepListInPeriodIndexError;
                    else lblExecuteError.Text = KROConstants.msgUserUpdateError;
                }
                // обработка результатов сохранения
                if (lAllParameterReady)
                {
                    // сохраним удачное сообщение в LogOuts
                    if (lDepListInPeriodID > 0) ModelsManager.InsertLogOut(ModelsManager.GetLogMessage(KROConstants.lgUpdateDepListInPeriod + " | " + FChangeDepListInPeriod.MounthName + " | " + FChangeDepListInPeriod.YearName, 3), KROFlag.flLogExchangeUsers, AuthenticationManager.GetAuthenticationUserModel(Session).ID);
                    else ModelsManager.InsertLogOut(ModelsManager.GetLogMessage(KROConstants.lgInsertDepListInPeriod + " | " + FChangeDepListInPeriod.MounthName + " | " + FChangeDepListInPeriod.YearName, 4), KROFlag.flLogExchangeUsers, AuthenticationManager.GetAuthenticationUserModel(Session).ID);
                    Server.Transfer(Constants.DEPLISTINPERIOD_LIST_PAGE_URL);
                }
                else
                {
                    // сохраним неудачное сообщение в LogOuts
                    if (lDepListInPeriodID > 0) ModelsManager.InsertLogOut(ModelsManager.GetLogMessage(KROConstants.lgUpdateDepListInPeriod + " | " + FChangeDepListInPeriod.MounthName + " | " + FChangeDepListInPeriod.YearName, 2), KROFlag.flLogExchangeUsers, AuthenticationManager.GetAuthenticationUserModel(Session).ID);
                    else ModelsManager.InsertLogOut(ModelsManager.GetLogMessage(KROConstants.lgInsertDepListInPeriod + " | " + FChangeDepListInPeriod.MounthName + " | " + FChangeDepListInPeriod.YearName, 2), KROFlag.flLogExchangeUsers, AuthenticationManager.GetAuthenticationUserModel(Session).ID);
                    lblExecuteError.Visible = true;
                }
            }
            else
            {
                lblExecuteError.Text = KROConstants.msgUserUpdateError;
                lblExecuteError.Visible = true;
            }
        }

        protected void ButtonUndo_Click(object sender, EventArgs e)
        {
            InitFieldDepListInPeriod();
        }

        protected void btnGenLastDepartment_Click(object sender, EventArgs e)
        {
            FActualDepartmentIDInPeriodList = GetActualDepartmentIDInPeriodList();
            gvDepListInPeriodCheckList.DataSource = FActualDepartmentIDInPeriodList;
            gvDepListInPeriodCheckList.DataBind();
        }
    }
}