﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KRO.Models;
using KRO.Contents;

namespace KRO.Pages.Directorys
{
    public partial class ChangeDepartment : System.Web.UI.Page
    {
        public DepartmentLine FChangeDepartment
        {
            get { return (DepartmentLine)ViewState["CheckedDepartment"]; }
            set { ViewState["CheckedDepartment"] = value; }
        }
        protected void Page_Load(object sender, EventArgs e)
        {


            if (!Page.IsPostBack)
            {
                DepartmentList prevPage = PreviousPage as DepartmentList;
                if (prevPage != null)
                    FChangeDepartment = prevPage.CheckedDepartment;
                InitFieldDepartment();
            }
        }

        private void InitFieldDepartment()
        {
            if (FChangeDepartment == null) FChangeDepartment = new DepartmentLine();
            tbName.Text = FChangeDepartment.DepartmentName;
            tbCode.Text = FChangeDepartment.DepartmentCode;
            tbSort.Text = FChangeDepartment.DepartmentSort;
            cbOnlyPerformerFlag.Checked = FChangeDepartment.OnlyPerformerFlag;
        }

        protected void ButtonCancel_Click(object sender, EventArgs e)
        {
            Server.Transfer(Constants.DEPARTMENT_LIST_PAGE_URL);
        }
        protected void ButtonApply_Click(object sender, EventArgs e)
        {
            lblExecuteError.Visible = false;
            bool lResultExecute = false;
            if (FChangeDepartment == null) FChangeDepartment = new DepartmentLine();
            FChangeDepartment.DepartmentName = tbName.Text;
            FChangeDepartment.DepartmentCode = tbCode.Text;
            FChangeDepartment.DepartmentSort = tbSort.Text;
            //соберем флаги
            int lFlag = 0;
            if ((cbOnlyPerformerFlag != null) && (cbOnlyPerformerFlag.Checked)) { lFlag = lFlag |= KROFlag.flCheckRead; }
            FChangeDepartment.SetFlag(lFlag); 
            //конец сбора флагов
            if (FChangeDepartment.DepartmentID > 0) lResultExecute = ModelsManager.UpdateDepartmentCheck(FChangeDepartment);
            else lResultExecute = ModelsManager.InsertDepartment(FChangeDepartment);
            if (lResultExecute) Server.Transfer(Constants.DEPARTMENT_LIST_PAGE_URL);
            else lblExecuteError.Visible = true;
        }
    }
}