﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KRO.Models;
using KRO.Contents;

namespace KRO.Pages.Directorys
{
    public partial class ChangeMetricList : System.Web.UI.Page
    {
        public MetricLine FChangeMetric
        {
            get { return (MetricLine)ViewState["CheckedMetric"]; }
            set { ViewState["CheckedMetric"] = value; }
        }
        protected void Page_Load(object sender, EventArgs e)
        {


            if (!Page.IsPostBack)
            {   // получим списки
                ddlFarm.DataSource = ModelsManager.GetFarmList();
                ddlFarm.DataBind();
                ddlCategory.DataSource = ModelsManager.GetMetricCategoryList();
                ddlCategory.DataBind();
                MetricList prevPage = PreviousPage as MetricList;
                if (prevPage != null)
                    FChangeMetric = prevPage.CheckedMetric;
                InitFieldMetric();
            }
        }

        private void InitFieldMetric()
        {   

            if (FChangeMetric == null) FChangeMetric = new MetricLine();
            tbName.Text               = FChangeMetric.MetricName;
            tbSecondName.Text         = FChangeMetric.MetricSecondName;
            tbScreenCode.Text         = FChangeMetric.MetricScreenCode;
            tbCode.Text               = FChangeMetric.MetricCode;
            tbSort.Text               = FChangeMetric.MetricSort;
            ddlFarm.SelectedValue     = FChangeMetric.MetricFarmID.ToString();
            ddlCategory.SelectedValue = FChangeMetric.MetricCategoryID.ToString();
            //выставим флаги 
            if (FChangeMetric.FlagMetricWrite) rbParameter.SelectedIndex = 0;
            else
              if (FChangeMetric.FlagMetricCalculation) rbParameter.SelectedIndex = 1;
              else
                 if (FChangeMetric.FlagMetricTextRow) rbParameter.SelectedIndex = 2;
            //определим цвет
            if ((FChangeMetric.Flag & KROFlag.flMetricBrownColor) == KROFlag.flMetricBrownColor) rbColor.SelectedIndex = 0;
            if ((FChangeMetric.Flag & KROFlag.flMetricGreenColor) == KROFlag.flMetricGreenColor) rbColor.SelectedIndex = 1;
            if ((FChangeMetric.Flag & KROFlag.flMetricYellowColor) == KROFlag.flMetricYellowColor) rbColor.SelectedIndex = 2;
            if ((FChangeMetric.Flag & KROFlag.flMetricBlueColor) == KROFlag.flMetricBlueColor) rbColor.SelectedIndex = 3;
        }

        protected void ButtonCancel_Click(object sender, EventArgs e)
        {
            Server.Transfer(Constants.METRIC_LIST_PAGE_URL);
        }
        protected void ButtonApply_Click(object sender, EventArgs e)
        {
            lblExecuteError.Visible = false;
            bool lResultExecute = false;
            if (FChangeMetric == null) FChangeMetric = new MetricLine();
            FChangeMetric.MetricName = tbName.Text;
            FChangeMetric.MetricSecondName = tbSecondName.Text;
            FChangeMetric.MetricScreenCode = tbScreenCode.Text;
            FChangeMetric.MetricCode = tbCode.Text;
            FChangeMetric.MetricSort = tbSort.Text;
            FChangeMetric.MetricFarmID = Int32.Parse(ddlFarm.SelectedValue);
            FChangeMetric.MetricFarmName = ddlFarm.Text;
            FChangeMetric.MetricCategoryID = Int32.Parse(ddlCategory.SelectedValue);
            FChangeMetric.MetricCategoryName = ddlCategory.Text;
            //соберем флаги
            long lFlag = 0;

            if ((rbParameter != null) && (rbParameter.SelectedValue.Length>0)) lFlag = lFlag |= long.Parse(rbParameter.SelectedValue);
            //цвет показателя
            if ((rbColor != null) && (rbColor.SelectedValue.Length>0)) lFlag = lFlag |= long.Parse(rbColor.SelectedValue);
                
            FChangeMetric.SetFlag(lFlag);
            //конец сбора флагов
            if (FChangeMetric.MetricID > 0) lResultExecute = ModelsManager.UpdateMetricCheck(FChangeMetric);
            else lResultExecute = ModelsManager.InsertMetric(FChangeMetric);
            if (lResultExecute) Server.Transfer(Constants.METRIC_LIST_PAGE_URL);
            else lblExecuteError.Visible = true;
        }
    }
}