﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Drawing;
using KRO.Authentication;
using KRO.Models;
using KRO.Contents;


namespace KRO.Pages.Directorys
{
    public partial class ChangeMetricFunction : System.Web.UI.Page
    {
        public MetricFunctionInPeriodBaseLine FChangeMetricFunctionInPeriodBase
        {
            get { return (MetricFunctionInPeriodBaseLine)ViewState["CheckedMetricFunctionInPeriodBase"]; }
            set { ViewState["CheckedMetricFunctionInPeriodBase"] = value; }
        }
        List<MetricLine> FAllMetricList;
        List<MetricFunctionInPeriodLine> FOldMetricFunctionInPeriodList;
        List<MetricFunctionInPeriodLine> FActualMetricFunctionInPeriodList;
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                ChangeMetricListInPeriod prevPage = PreviousPage as ChangeMetricListInPeriod;
                if (prevPage != null)
                {
                    FChangeMetricFunctionInPeriodBase = prevPage.FChangeMetricFunctionInPeriodBase;
                }
                InitFieldMetricFunctionInPeriod();
            }
        }

        private void InitFieldMetricFunctionInPeriod()
        {
            if (FChangeMetricFunctionInPeriodBase == null) FChangeMetricFunctionInPeriodBase = new MetricFunctionInPeriodBaseLine();
            //получим данные
            lblBaseMounthName.Text = FChangeMetricFunctionInPeriodBase.MounthName;
            lblBaseYearName.Text = FChangeMetricFunctionInPeriodBase.YearName;

            lblBaseCalcMetricScreenCode.Text = FChangeMetricFunctionInPeriodBase.CalcMetricScreenCode;
            lblBaseCalcMetricName.Text = FChangeMetricFunctionInPeriodBase.CalcMetricName;
            lblBaseCalcMetriCode.Text = FChangeMetricFunctionInPeriodBase.CalcMetricCode;
            //конец блока получения данных

            // обновим таблицу выражений
            FActualMetricFunctionInPeriodList = GetActualMetricIDInFunctionList();
            gvMetricFunctionInPeriodCheckList.DataSource = FActualMetricFunctionInPeriodList;
            gvMetricFunctionInPeriodCheckList.DataBind();
        }
        private List<MetricFunctionInPeriodLine> GetActualMetricIDInFunctionList(bool AGetLastCheckedMetric = false)
        {
            DateTime lCheckDate = DateTime.Today;
            List<MetricFunctionInPeriodLine> lMetricFunctionInPeriodList = new List<MetricFunctionInPeriodLine>();
            if (FAllMetricList == null) FAllMetricList = ModelsManager.GetMetricList(true); //получим только вводимые показатели
            if (FChangeMetricFunctionInPeriodBase.ID > 0) // работаем только с уже выбранным периодом  в таблице MetricListInPeriod 
            {
                FOldMetricFunctionInPeriodList = ModelsManager.GetMetricFunctionInPeriodByMetricListInPeriodIDAndCalcMetricID(FChangeMetricFunctionInPeriodBase.ID, FChangeMetricFunctionInPeriodBase.CalcMetricID);
                if (FOldMetricFunctionInPeriodList.Count > 0) // что-то получили по старым данным
                {
                    foreach (MetricLine lMetricLine in FAllMetricList)
                    {
                        MetricFunctionInPeriodLine lMetricFunctionInPeriodLine = FOldMetricFunctionInPeriodList.Find(x => x.SumMetricID == (int)lMetricLine.MetricID);
                        if (lMetricFunctionInPeriodLine != null) lMetricFunctionInPeriodList.Add(lMetricFunctionInPeriodLine); // здесь приходит объект с checked = true и нужным DK
                        else lMetricFunctionInPeriodList.Add(new MetricFunctionInPeriodLine(-1,
                                                                                            FChangeMetricFunctionInPeriodBase.ID,
                                                                                            FChangeMetricFunctionInPeriodBase.CalcMetricID,
                                                                                            FChangeMetricFunctionInPeriodBase.CalcMetricFlag,
                                                                                            lMetricLine.MetricID,
                                                                                            lMetricLine.MetricName,
                                                                                            lMetricLine.MetricSort,
                                                                                            lMetricLine.MetricCode,
                                                                                            lMetricLine.MetricScreenCode,
                                                                                            lMetricLine.Flag));
                    }
                }
                else // если ни чего не получили тогда ищем последнии по дате
                {
                    // выбрали последние настройки если есть
                    lCheckDate = new DateTime(int.Parse(FChangeMetricFunctionInPeriodBase.YearName), FChangeMetricFunctionInPeriodBase.MounthID, 2);
                    FOldMetricFunctionInPeriodList = ModelsManager.GetMetricFunctionInPeriodListByActualDateAndCalcMetricID(lCheckDate, FChangeMetricFunctionInPeriodBase.CalcMetricID); // здесь приходит объект с checked = true и нужным DK
                    foreach (MetricLine lMetricLine in FAllMetricList)
                    {
                        MetricFunctionInPeriodLine lMetricFunctionInPeriodLine = FOldMetricFunctionInPeriodList.Find(x => x.SumMetricID == (int)lMetricLine.MetricID);
                        if ((lMetricFunctionInPeriodLine != null) && (AGetLastCheckedMetric)) //ишем функцию в предыдущем периоде только при прямом запросе пользователя
                            lMetricFunctionInPeriodList.Add(new MetricFunctionInPeriodLine(-1,
                                                                                            FChangeMetricFunctionInPeriodBase.ID,
                                                                                            FChangeMetricFunctionInPeriodBase.CalcMetricID,
                                                                                            FChangeMetricFunctionInPeriodBase.CalcMetricFlag,
                                                                                            lMetricLine.MetricID,
                                                                                            lMetricLine.MetricName,
                                                                                            lMetricLine.MetricSort,
                                                                                            lMetricLine.MetricCode,
                                                                                            lMetricLine.MetricScreenCode,
                                                                                            lMetricLine.Flag,
                                                                                            lMetricFunctionInPeriodLine.SumMetricDK,
                                                                                            true)); // если нашли значит выбранные показатель
                        else lMetricFunctionInPeriodList.Add(new MetricFunctionInPeriodLine(-1,
                                                                                            FChangeMetricFunctionInPeriodBase.ID,
                                                                                            FChangeMetricFunctionInPeriodBase.CalcMetricID,
                                                                                            FChangeMetricFunctionInPeriodBase.CalcMetricFlag,
                                                                                            lMetricLine.MetricID,
                                                                                            lMetricLine.MetricName,
                                                                                            lMetricLine.MetricSort,
                                                                                            lMetricLine.MetricCode,
                                                                                            lMetricLine.MetricScreenCode,
                                                                                            lMetricLine.Flag));
                    }
                }
            }
            return lMetricFunctionInPeriodList;
        }
        protected void gvMetricFunctionInPeriodCheckList_RowCreated(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.Header)
            {
                GridViewRow lRowHeader1 = new GridViewRow(0, 0, DataControlRowType.Header, DataControlRowState.Normal);
                TableHeaderCell lCellHeader = new TableHeaderCell();
                lCellHeader.Text = "№ п/п";
                lCellHeader.Width = 50;
                lCellHeader.RowSpan = 1;
                lRowHeader1.Controls.Add(lCellHeader);

                lCellHeader = new TableHeaderCell();
                lCellHeader.Text = "Наименование показателя";
                lCellHeader.Width = 300;
                lCellHeader.ColumnSpan = 1;
                lRowHeader1.Controls.Add(lCellHeader);

                lCellHeader = new TableHeaderCell();
                lCellHeader.Text = "Код";
                lCellHeader.Width = 100;
                lCellHeader.ColumnSpan = 1;
                lRowHeader1.Controls.Add(lCellHeader);

                lCellHeader = new TableHeaderCell();
                lCellHeader.Text = "Включен";
                lCellHeader.Width = 90;
                lCellHeader.ColumnSpan = 1;
                lRowHeader1.Controls.Add(lCellHeader);

                lCellHeader = new TableHeaderCell();
                lCellHeader.Text = "Вычитаемый";
                lCellHeader.Width = 90;
                lCellHeader.ColumnSpan = 1;
                lRowHeader1.Controls.Add(lCellHeader);

                lRowHeader1.CssClass = "ssHeaderSecond";
                gvMetricFunctionInPeriodCheckList.Controls[0].Controls.AddAt(0, lRowHeader1);
            }
        }
        protected void ButtonCancel_Click(object sender, EventArgs e)
        {
            Server.Transfer(Constants.CHANGE_METRICLISTINPERIOD_PAGE_URL);
        }
        protected void ButtonApply_Click(object sender, EventArgs e)
        {
            bool lAllParameterReady = true;
            lblExecuteError.Visible = false; //первоначально погасим сообщение если было уже включено
            if ((FChangeMetricFunctionInPeriodBase.ID > 0) && (FChangeMetricFunctionInPeriodBase.CalcMetricID>0)) // только при наличии периода к чему привязывать выражение и вычисляемого показателя
            {   // подготовим данные для сохранения
                if (FActualMetricFunctionInPeriodList == null) FActualMetricFunctionInPeriodList = GetActualMetricIDInFunctionList(); // получим список показателей
                if ((gvMetricFunctionInPeriodCheckList != null) && (gvMetricFunctionInPeriodCheckList.Rows.Count > 0)) // тлько при наличие записей в таблице
                {
                    int lSumMetricID;
                    bool lCheckedSumMetric;
                    bool lCheckedSumMetricDK;
                    CheckBox lCheckBoxSumMetric;
                    CheckBox lCheckBoxSumMetricDK;
                    Label lLabelSumMetricID;
                    MetricFunctionInPeriodLine lMetricFunctionInPeriodLine;
                    foreach (GridViewRow lMetricFunctionInPeriodCheckRow in gvMetricFunctionInPeriodCheckList.Rows)
                    {
                        if (lMetricFunctionInPeriodCheckRow.RowType == DataControlRowType.DataRow)
                        {
                            //обнулим значения
                            lSumMetricID      = 0;
                            lCheckedSumMetric = false;
                            lCheckedSumMetricDK = false;
                            //соберем выбранные показатели 
                            lLabelSumMetricID    = null;
                            lCheckBoxSumMetric   = null;
                            lCheckBoxSumMetricDK = null;
                            lMetricFunctionInPeriodLine = null;
                            try
                            {
                                //получили ID региона
                                lLabelSumMetricID = (Label)lMetricFunctionInPeriodCheckRow.FindControl("lblMetricID");
                                if ((lLabelSumMetricID != null) && (lLabelSumMetricID.Text.Length > 0)) lSumMetricID = Int32.Parse(lLabelSumMetricID.Text); else lSumMetricID = -1;
                                lCheckBoxSumMetric = (CheckBox)lMetricFunctionInPeriodCheckRow.FindControl("cbCheckMetric");
                                if ((lCheckBoxSumMetric != null) && (lCheckBoxSumMetric.Checked)) lCheckedSumMetric = true;
                                lCheckBoxSumMetricDK = (CheckBox)lMetricFunctionInPeriodCheckRow.FindControl("cbMetricDK");
                                if ((lCheckBoxSumMetricDK != null) && (lCheckBoxSumMetricDK.Checked)) lCheckedSumMetricDK = true;
                                //найдем объект
                                lMetricFunctionInPeriodLine = FActualMetricFunctionInPeriodList.Find(x => x.SumMetricID == (int)lSumMetricID);
                                //подменим данные
                                lMetricFunctionInPeriodLine.SumMetricIDCheckedInFunction = lCheckedSumMetric;
                                lMetricFunctionInPeriodLine.SetSumMetricIDIsNegative(lCheckedSumMetricDK);
                            }
                            catch { }                             
                        }
                    } // данные подготовили
                }
                else { lAllParameterReady = false; }
            }
            else { lAllParameterReady = false; }
            int lMetricFunctionInPeriodBaseID = FChangeMetricFunctionInPeriodBase.ID; //переменная необходима для проверки перед выводом в LogOut. а что собственно пытались сделать
            int lCalcMetricID = FChangeMetricFunctionInPeriodBase.CalcMetricID; //переменная необходима для проверки перед выводом в LogOut. а что собственно пытались сделать
            if (lAllParameterReady)
            {   //по новой используем переменную lAllParameterReady
                lAllParameterReady = false;
                //попытка сохранения результатов и соответствующая реакция
                try
                {
                    lAllParameterReady = ModelsManager.UpdateMetricFunctionListInPeriodCheck(FChangeMetricFunctionInPeriodBase, FActualMetricFunctionInPeriodList);
                    if (!lAllParameterReady) lblExecuteError.Text = KROConstants.msgUserUpdateError; //восстановим сообщение мало-ли до этого менялось
                }
                catch (Exception exp)
                {   //определим что за байда приключилась
                    if (exp.Message.IndexOf(KROConstants.fndExcpMetricFunctionInPeriodIndexError) > -1) lblExecuteError.Text = KROConstants.msgMetricFunctionInPeriodIndexError;
                    else lblExecuteError.Text = KROConstants.msgUserUpdateError;
                }
                // обработка результатов сохранения
                if (lAllParameterReady)
                {
                    // сохраним удачное сообщение в LogOuts
                    ModelsManager.InsertLogOut(ModelsManager.GetLogMessage(KROConstants.lgInsertMetricFunctionInPeriod + " | " + FChangeMetricFunctionInPeriodBase.MounthName + " | " + FChangeMetricFunctionInPeriodBase.YearName + " | " + FChangeMetricFunctionInPeriodBase.CalcMetricID, 3), KROFlag.flLogExchangeUsers, AuthenticationManager.GetAuthenticationUserModel(Session).ID);
                    Server.Transfer(Constants.CHANGE_METRICLISTINPERIOD_PAGE_URL);
                }
                else
                {
                    // сохраним неудачное сообщение в LogOuts
                    ModelsManager.InsertLogOut(ModelsManager.GetLogMessage(KROConstants.lgInsertMetricFunctionInPeriod + " | " + FChangeMetricFunctionInPeriodBase.MounthName + " | " + FChangeMetricFunctionInPeriodBase.YearName + " | " + FChangeMetricFunctionInPeriodBase.CalcMetricID, 2), KROFlag.flLogExchangeUsers, AuthenticationManager.GetAuthenticationUserModel(Session).ID);
                    lblExecuteError.Visible = true;
                }
            }
            else
            {
                lblExecuteError.Text = KROConstants.msgUserUpdateError;
                lblExecuteError.Visible = true;
            }
        }

        protected void ButtonUndo_Click(object sender, EventArgs e)
        {
            InitFieldMetricFunctionInPeriod();
        }

        protected void btnGenLastMetric_Click(object sender, EventArgs e)
        {
            FActualMetricFunctionInPeriodList = GetActualMetricIDInFunctionList(true);
            gvMetricFunctionInPeriodCheckList.DataSource = FActualMetricFunctionInPeriodList;
            gvMetricFunctionInPeriodCheckList.DataBind();
        }
    }
}