﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Drawing;
using KRO.Authentication;
using KRO.Models;
using KRO.Contents;

namespace KRO.Pages.Directorys
{
    public partial class ChangeMetricListInPeriod : System.Web.UI.Page
    {
        public MetricListInPeriodLine FChangeMetricListInPeriod
        {
            get { return (MetricListInPeriodLine)ViewState["CheckedMetricListInPeriod"]; }
            set { ViewState["CheckedMetricListInPeriod"] = value; }
        }
        public MetricFunctionInPeriodBaseLine FChangeMetricFunctionInPeriodBase
        {
            get { return (MetricFunctionInPeriodBaseLine)ViewState["CheckedMetricFunctionInPeriodBase"]; }
            set { ViewState["CheckedMetricFunctionInPeriodBase"] = value; }
        }
        List<MetricLine> FAllMetricList;
        List<MetricIDInPeriodLine> FOldMetricIDInPeriodList;
        List<MetricIDInPeriodLine> FActualMetricIDInPeriodList;
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                FChangeMetricListInPeriod = ModelsManager.GetChangeMetricListInPeriodLineFromSession(Session);
                InitFieldMetricListInPeriod();
            }
        }

        private void InitFieldMetricListInPeriod()
        {
            if (FChangeMetricListInPeriod == null) FChangeMetricListInPeriod = new MetricListInPeriodLine();
            //получим списки
            ddlMounth.DataSource = ModelsManager.GetMounthList();
            ddlMounth.DataBind();
            List<YearLine> lYearList = ModelsManager.GetYearList(false);
            ddlYear.DataSource = lYearList;
            ddlYear.DataBind();
            //конец блока получения списков
            if (FChangeMetricListInPeriod.ID > 0)
            {
                ddlMounth.SelectedValue = FChangeMetricListInPeriod.MounthID.ToString();
                ddlYear.SelectedValue = FChangeMetricListInPeriod.YearID.ToString();
            }
            else
            {
                try
                {
                    DateTime lNow = DateTime.Today;
                    int lMounth = lNow.Month;
                    int lYear = lNow.Year;
                    ddlMounth.SelectedValue = lMounth.ToString();
                    ddlYear.SelectedValue = lYearList.Find(Item => Item.YearName == lYear.ToString()).YearID.ToString();
                }
                catch
                {
                    ddlMounth.SelectedValue = FChangeMetricListInPeriod.MounthID.ToString();
                    ddlYear.SelectedValue = FChangeMetricListInPeriod.YearID.ToString();
                }
            }
            // обновим таблицу показателей
            FActualMetricIDInPeriodList = GetActualMetricIDInPeriodList();
            gvMetricListInPeriodCheckList.DataSource = FActualMetricIDInPeriodList;
            gvMetricListInPeriodCheckList.DataBind();
        }
        private List<MetricIDInPeriodLine> GetActualMetricIDInPeriodList()
        {
            DateTime lCheckDate = DateTime.Today;
            List<MetricIDInPeriodLine> lMetricIDInPeriodList = new List<MetricIDInPeriodLine>();
            if (FAllMetricList == null) FAllMetricList = ModelsManager.GetMetricList();
            if (FChangeMetricListInPeriod.ID > 0)
            {
                FOldMetricIDInPeriodList = ModelsManager.GetMetricIDInPeriodByMetricListInPeriodID(FChangeMetricListInPeriod.ID);
                if (FOldMetricIDInPeriodList.Count > 0) // что-то получили по старым данным
                {
                    foreach (MetricLine lMetricLine in FAllMetricList)
                    {
                        MetricIDInPeriodLine lMetricIDInPeriodLine = FOldMetricIDInPeriodList.Find(x => x.MetricID == (int)lMetricLine.MetricID);
                        if (lMetricIDInPeriodLine != null) lMetricIDInPeriodList.Add(lMetricIDInPeriodLine);
                        else lMetricIDInPeriodList.Add(new MetricIDInPeriodLine(-1,
                                                                                        FChangeMetricListInPeriod.ID,
                                                                                        lMetricLine.MetricID,
                                                                                        lMetricLine.MetricName,
                                                                                        lMetricLine.MetricSort,
                                                                                        lMetricLine.MetricCode,
                                                                                        lMetricLine.MetricScreenCode,
                                                                                        lMetricLine.Flag,
                                                                                        0));
                    }
                }
                else // если ни чего не получили тогда ищем последнии по дате
                {
                    // выбрали последние настройки если есть
                    lCheckDate = new DateTime(int.Parse(ddlYear.SelectedItem.ToString()), ddlMounth.SelectedIndex + 1, 2);
                    FOldMetricIDInPeriodList = ModelsManager.GetMetricIDInPeriodListByActualDate(lCheckDate);
                    foreach (MetricLine lMetricLine in FAllMetricList)
                    {
                        MetricIDInPeriodLine lMetricIDInPeriodLine = FOldMetricIDInPeriodList.Find(x => x.MetricID == (int)lMetricLine.MetricID);
                        if (lMetricIDInPeriodLine != null) lMetricIDInPeriodList.Add(new MetricIDInPeriodLine(-1,
                                                                                              -1,
                                                                                              lMetricLine.MetricID,
                                                                                              lMetricLine.MetricName,
                                                                                              lMetricLine.MetricSort,
                                                                                              lMetricLine.MetricCode,
                                                                                              lMetricLine.MetricScreenCode,
                                                                                              lMetricLine.Flag,
                                                                                              lMetricIDInPeriodLine.Flag));
                        else lMetricIDInPeriodList.Add(new MetricIDInPeriodLine(-1,
                                                                                              -1,
                                                                                              lMetricLine.MetricID,
                                                                                              lMetricLine.MetricName,
                                                                                              lMetricLine.MetricSort,
                                                                                              lMetricLine.MetricCode,
                                                                                              lMetricLine.MetricScreenCode, 
                                                                                              lMetricLine.Flag,
                                                                                              0));
                    }
                }
            }
            else // новая запись пытаемся создать полный список со старыми наименованиями.
            {
                // выбрали последние настройки если есть
                lCheckDate = new DateTime(int.Parse(ddlYear.SelectedItem.ToString()), ddlMounth.SelectedIndex + 1, 2);
                FOldMetricIDInPeriodList = ModelsManager.GetMetricIDInPeriodListByActualDate(lCheckDate);
                foreach (MetricLine lMetricLine in FAllMetricList)
                {
                    MetricIDInPeriodLine lMetricIDInPeriodLine = FOldMetricIDInPeriodList.Find(x => x.MetricID == (int)lMetricLine.MetricID);
                    if (lMetricIDInPeriodLine != null) lMetricIDInPeriodList.Add(new MetricIDInPeriodLine(-1,
                                                                                        -1,
                                                                                        lMetricLine.MetricID,
                                                                                        lMetricLine.MetricName,
                                                                                        lMetricLine.MetricSort,
                                                                                        lMetricLine.MetricCode,
                                                                                        lMetricLine.MetricScreenCode,
                                                                                        lMetricLine.Flag,
                                                                                        lMetricIDInPeriodLine.Flag));
                    else lMetricIDInPeriodList.Add(new MetricIDInPeriodLine(-1,
                                                                                        -1,
                                                                                        lMetricLine.MetricID,
                                                                                        lMetricLine.MetricName,
                                                                                        lMetricLine.MetricSort,
                                                                                        lMetricLine.MetricCode,
                                                                                        lMetricLine.MetricScreenCode,
                                                                                        lMetricLine.Flag,
                                                                                        0));
                }
            }
            return lMetricIDInPeriodList;
        }
        protected void gvMetricListInPeriodCheckList_RowCreated(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.Header)
            {
                GridViewRow lRowHeader1 = new GridViewRow(0, 0, DataControlRowType.Header, DataControlRowState.Normal);
                TableHeaderCell lCellHeader = new TableHeaderCell();
                lCellHeader.Text = "№ п/п";
                lCellHeader.Width = 50;
                lCellHeader.RowSpan = 1;
                lRowHeader1.Controls.Add(lCellHeader);

                lCellHeader = new TableHeaderCell();
                lCellHeader.Text = "Наименование показателя";
                lCellHeader.Width = 300;
                lCellHeader.ColumnSpan = 1;
                lRowHeader1.Controls.Add(lCellHeader);

                lCellHeader = new TableHeaderCell();
                lCellHeader.Text = "Код";
                lCellHeader.Width = 100;
                lCellHeader.ColumnSpan = 1;
                lRowHeader1.Controls.Add(lCellHeader);

                lCellHeader = new TableHeaderCell();
                lCellHeader.Text = "Вычисляемый";
                lCellHeader.Width = 90;
                lCellHeader.ColumnSpan = 1;
                lRowHeader1.Controls.Add(lCellHeader);

                lCellHeader = new TableHeaderCell();
                lCellHeader.Text = "Включен";
                lCellHeader.Width = 90;
                lCellHeader.ColumnSpan = 1;
                lRowHeader1.Controls.Add(lCellHeader);

                lCellHeader = new TableHeaderCell();
                lCellHeader.Text = "Формула";
                lCellHeader.Width = 50;
                lCellHeader.ColumnSpan = 1;
                lRowHeader1.Controls.Add(lCellHeader);

                lRowHeader1.CssClass = "ssHeaderSecond";
                gvMetricListInPeriodCheckList.Controls[0].Controls.AddAt(0, lRowHeader1);
            }
        }
        protected void ButtonCancel_Click(object sender, EventArgs e)
        {
            Response.Redirect(Constants.METRICLISTINPERIOD_LIST_PAGE_URL);
        }
        protected void ButtonApply_Click(object sender, EventArgs e)
        {
            bool lAllParameterReady = true;
            lblExecuteError.Visible = false; //первоначально погасим сообщение если было уже включено
            //соберем данные
            FChangeMetricListInPeriod.MounthID = Int32.Parse(ddlMounth.SelectedValue);
            FChangeMetricListInPeriod.MounthName = ddlMounth.Text;
            FChangeMetricListInPeriod.YearID = Int32.Parse(ddlYear.SelectedValue);
            FChangeMetricListInPeriod.YearName = ddlYear.Text;
            if ((FChangeMetricListInPeriod.MounthID > 0) && (FChangeMetricListInPeriod.YearID > 0)) //получили данные периода
            { 
                if (FActualMetricIDInPeriodList == null) FActualMetricIDInPeriodList = GetActualMetricIDInPeriodList(); // получим список показателей
                if ((gvMetricListInPeriodCheckList != null) && (gvMetricListInPeriodCheckList.Rows.Count > 0))
                {
                    int lMetricID;
                    bool lCheckedMetric;
                    CheckBox lCheckBoxMetric;
                    Label lLabelMetricID;
                    MetricIDInPeriodLine lMetricIDInPeriodLine;
                    foreach (GridViewRow lMetricListInPeriodCheckRow in gvMetricListInPeriodCheckList.Rows)
                    {
                        if (lMetricListInPeriodCheckRow.RowType == DataControlRowType.DataRow)
                        {
                            //обнулим значения
                            lMetricID = 0;
                            lCheckedMetric = false;
                            //соберем выбранные показатели 
                            lCheckBoxMetric = null;
                            lLabelMetricID = null;
                            lMetricIDInPeriodLine = null;
                            try
                            {
                                //получили ID показателя
                                lLabelMetricID = (Label)lMetricListInPeriodCheckRow.FindControl("lblMetricID");
                                if ((lLabelMetricID != null) && (lLabelMetricID.Text.Length > 0)) lMetricID = Int32.Parse(lLabelMetricID.Text); else lMetricID = -1;
                                lCheckBoxMetric = (CheckBox)lMetricListInPeriodCheckRow.FindControl("cbCheckMetric");
                                if ((lCheckBoxMetric != null) && (lCheckBoxMetric.Checked)) lCheckedMetric = true;
                                //найдем объект
                                lMetricIDInPeriodLine = FActualMetricIDInPeriodList.Find(x => x.MetricID == (int)lMetricID);
                                //подменим данные
                                lMetricIDInPeriodLine.SetMetricIDCheckedInPeriod(lCheckedMetric);
                            }
                            catch { }                             
                        }
                    }
                }
                else { lAllParameterReady = false; }
            }
            else { lAllParameterReady = false; }
            int lMetricListInPeriodID = FChangeMetricListInPeriod.ID; //переменная необходима для проверки перед выводом в LogOut. а что собственно пытались сделать
            if (lAllParameterReady)
            {
                //по новой используем переменную lAllParameterReady
                lAllParameterReady = false;
                //попытка сохранения результатов и соответствующая реакция
                try
                {
                    lblExecuteError.Text = KROConstants.msgUserUpdateError; //восстановим сообщение мало-ли до этого менялось                
                    if (FChangeMetricListInPeriod.ID > 0) lAllParameterReady = ModelsManager.UpdateMetricListInPeriodCheck(FChangeMetricListInPeriod, FActualMetricIDInPeriodList);
                    else
                    {  //необходима проверка а нет ли уже отчетов за указанным периодом (выолняем пока только перед новой вставкой, потом посмотрим может и на изменение надо протянуть)
                        if (ModelsManager.GetAlreadyExistFactDataLastPeriod(FChangeMetricListInPeriod.MounthID, FChangeMetricListInPeriod.YearID))
                        { // уже есть реальные данные в более поздних отчетах необходимо выдавать предупреждение и выходить из процедуры
                            lblExecuteError.Text = KROConstants.msgFactDataAlreadyExistInLastPeriod;
                            lblExecuteError.Visible = true;
                            return;
                        }
                        try
                        {   //перед вставкой попробуем найти старые функции
                            List<MetricFunctionLine> lFullListOldMetricFunction = ModelsManager.GetMetricFunctionListByMetricListInPeriodID(FOldMetricIDInPeriodList.First<MetricIDInPeriodLine>().MetricListInPeriodID);
                            lAllParameterReady = ModelsManager.InsertMetricListInPeriod(FChangeMetricListInPeriod, FActualMetricIDInPeriodList, lFullListOldMetricFunction);
                        }
                        catch (Exception expinsert) { 
                            FChangeMetricListInPeriod.SetID(-1);
                            throw expinsert;
                        }
                    }
                }
                catch (Exception exp)
                {   //определим что за байда приключилась
                    if (exp.Message.IndexOf(KROConstants.fndExcpMetricListInPeriodIndexError) > -1) lblExecuteError.Text = KROConstants.msgMetricListInPeriodIndexError;
                    else lblExecuteError.Text = KROConstants.msgUserUpdateError;
                }
                // обработка результатов сохранения
                if (lAllParameterReady)
                {
                    // сохраним удачное сообщение в LogOuts
                    if (lMetricListInPeriodID > 0) ModelsManager.InsertLogOut(ModelsManager.GetLogMessage(KROConstants.lgUpdateMetricListInPeriod + " | " + FChangeMetricListInPeriod.MounthName + " | " + FChangeMetricListInPeriod.YearName, 3), KROFlag.flLogExchangeUsers, AuthenticationManager.GetAuthenticationUserModel(Session).ID);
                    else ModelsManager.InsertLogOut(ModelsManager.GetLogMessage(KROConstants.lgInsertMetricListInPeriod + " | " + FChangeMetricListInPeriod.MounthName + " | " + FChangeMetricListInPeriod.YearName, 4), KROFlag.flLogExchangeUsers, AuthenticationManager.GetAuthenticationUserModel(Session).ID);
                }
                else
                {
                    // сохраним неудачное сообщение в LogOuts
                    if (lMetricListInPeriodID > 0) ModelsManager.InsertLogOut(ModelsManager.GetLogMessage(KROConstants.lgUpdateMetricListInPeriod + " | " + FChangeMetricListInPeriod.MounthName + " | " + FChangeMetricListInPeriod.YearName, 2), KROFlag.flLogExchangeUsers, AuthenticationManager.GetAuthenticationUserModel(Session).ID);
                    else ModelsManager.InsertLogOut(ModelsManager.GetLogMessage(KROConstants.lgInsertMetricListInPeriod + " | " + FChangeMetricListInPeriod.MounthName + " | " + FChangeMetricListInPeriod.YearName, 2), KROFlag.flLogExchangeUsers, AuthenticationManager.GetAuthenticationUserModel(Session).ID);
                    lblExecuteError.Visible = true;
                }
            }
            else
            {
                lblExecuteError.Text = KROConstants.msgUserUpdateError; 
                lblExecuteError.Visible = true;
            }
            // обновим таблицу дирекций
            FActualMetricIDInPeriodList = GetActualMetricIDInPeriodList();
            gvMetricListInPeriodCheckList.DataSource = FActualMetricIDInPeriodList;
            gvMetricListInPeriodCheckList.DataBind();
        }

        protected void ButtonUndo_Click(object sender, EventArgs e)
        {
            InitFieldMetricListInPeriod();
        }

        protected void btnGenLastMetric_Click(object sender, EventArgs e)
        {
            FActualMetricIDInPeriodList = GetActualMetricIDInPeriodList();
            gvMetricListInPeriodCheckList.DataSource = FActualMetricIDInPeriodList;
            gvMetricListInPeriodCheckList.DataBind();
        }
        //формулы 
        protected void gvMetricListInPeriodCheckList_RowDataBound(object sender, GridViewRowEventArgs e)
        {  
            if (e.Row.RowType == DataControlRowType.DataRow)
            {
                int lColumnCount = e.Row.Cells.Count;
                try
                {  
                    if ((FChangeMetricListInPeriod.ID<=0) ||
                        (e.Row.DataItem == null) ||
                        !(((MetricIDInPeriodLine)e.Row.DataItem).FlagMetricCalculated) ||
                        !(((MetricIDInPeriodLine)e.Row.DataItem).MetricIDCheckedInPeriod))
                    {
                        ImageButton lImage = (ImageButton)e.Row.Cells[lColumnCount - 1].Controls[0];
                        lImage.Attributes["style"] += "display:none;";
                    }
                }
                catch { }
            }
        }
        protected void gvMetricListInPeriodCheckList_SelectedIndexChanged(object sender, EventArgs e)
        {
            bool lPrepearCheckedCalcMetric = false;
            lblExecuteError.Visible = false; //первоначально погасим сообщение если было уже включено
            if (FChangeMetricListInPeriod.ID > 0)
            {
                GridView lGridView = (GridView)sender;
                if (lGridView.SelectedIndex >= 0)
                {
                   if (FActualMetricIDInPeriodList == null) FActualMetricIDInPeriodList = GetActualMetricIDInPeriodList(); // получим список показателей
                   MetricIDInPeriodLine lCheckedCalcMetricID = (MetricIDInPeriodLine) FActualMetricIDInPeriodList.Find(x => x.MetricID == (int)lGridView.SelectedDataKey.Value);
                   if (lCheckedCalcMetricID != null)
                   {
                       FChangeMetricFunctionInPeriodBase = new MetricFunctionInPeriodBaseLine(
                                    FChangeMetricListInPeriod.ID, FChangeMetricListInPeriod.MounthID,
                                    FChangeMetricListInPeriod.MounthName, FChangeMetricListInPeriod.YearID,
                                    FChangeMetricListInPeriod.YearName, FChangeMetricListInPeriod.DateIn,
                                    lCheckedCalcMetricID.MetricID, lCheckedCalcMetricID.MetricName,
                                    lCheckedCalcMetricID.MetricSort, lCheckedCalcMetricID.MetricCode,
                                    lCheckedCalcMetricID.MetricScreenCode, lCheckedCalcMetricID.MetricFlag);
                       if (FChangeMetricFunctionInPeriodBase != null) lPrepearCheckedCalcMetric = true;
                   }
                } 
            }
           if (lPrepearCheckedCalcMetric) Server.Transfer(Constants.CHANGE_METRICFUNCTIONINPERIOD_PAGE_URL);
           else
           {
               lblExecuteError.Text = KROConstants.msgMetricFunctionPrepearError;
               lblExecuteError.Visible = true;
           }               
        }
    }
}