﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KRO.Models;

namespace KRO.Pages.Directorys
{
    public partial class ChangeRegion : System.Web.UI.Page
    {
        public RegionLine FChangeRegion
        {
            get { return (RegionLine)ViewState["CheckedRegion"]; }
            set { ViewState["CheckedRegion"] = value; }
        }
        protected void Page_Load(object sender, EventArgs e)
        {


            if (!Page.IsPostBack)
            {
                RegionList prevPage = PreviousPage as RegionList;
                if (prevPage != null)
                    FChangeRegion = prevPage.CheckedRegion;
                InitFieldRegion();
            }
        }

        private void InitFieldRegion()
        {
            if (FChangeRegion == null) FChangeRegion = new RegionLine();
            tbName.Text = FChangeRegion.RegionName;
            tbCode.Text = FChangeRegion.RegionCode;
            tbSort.Text = FChangeRegion.RegionSort;
        }

        protected void ButtonCancel_Click(object sender, EventArgs e)
        {
            Server.Transfer(Constants.REGION_LIST_PAGE_URL);
        }
        protected void ButtonApply_Click(object sender, EventArgs e)
        {
            lblExecuteError.Visible = false;
            bool lResultExecute = false;
            if (FChangeRegion == null) FChangeRegion = new RegionLine();
            FChangeRegion.RegionName = tbName.Text;
            FChangeRegion.RegionCode = tbCode.Text;
            FChangeRegion.RegionSort = tbSort.Text;

            if (FChangeRegion.RegionID > 0) lResultExecute = ModelsManager.UpdateRegionCheck(FChangeRegion);
            else lResultExecute = ModelsManager.InsertRegion(FChangeRegion);
            if (lResultExecute) Server.Transfer(Constants.REGION_LIST_PAGE_URL);
            else lblExecuteError.Visible = true;
        }
    }
}