﻿using System;
using System.Collections.Generic;
using System.Web.UI.WebControls;
using System.Drawing;
using KRO.Models;
using KRO.Authentication;
using KRO.Contents;

namespace KRO.Pages.Directorys
{
    public partial class ChangeReportParameterBlock : System.Web.UI.Page
    {
        private int FUserCheckRule;
        private User FActiveUser;
        private bool FCreatedHeader;
        private static List<BlockReportParameterHistoryLine> FBlockReportParameterHistoryLine = new List<BlockReportParameterHistoryLine>();
        private static List<BlockReportParameterHistoryLine> FBlockReportParameterHistoryLineEmty = new List<BlockReportParameterHistoryLine>();
        public ReportsParameterLine CheckedReportsParameterLine
        {
            get { return (ReportsParameterLine)ViewState["ReportsParameterLine"]; }
            set { ViewState["ReportsParameterLine"] = value; }
        }
        protected void Page_Load(object sender, EventArgs e)
        {
            //определим тип подъема формы               
            GetUserFlag();
            FCreatedHeader = false;
            if (!Page.IsPostBack)
            {
                CheckedReportsParameterLine = ModelsManager.GetChangeReportParameterLineBlockFromSession(Session);
                FBlockReportParameterHistoryLine = ModelsManager.GetBlockReportParameterHistoryList(CheckedReportsParameterLine.ReportParameterID);
                gvBlokReportsParameterHistoryList.SelectedIndex = -1;
                gvBlokReportsParameterHistoryList.DataSource = FBlockReportParameterHistoryLine;
                gvBlokReportsParameterHistoryList.DataBind();
                gvGridBlokReportsParameterHistoryHeader.DataSource = FBlockReportParameterHistoryLineEmty;
                gvGridBlokReportsParameterHistoryHeader.DataBind();
                FCreatedHeader = true;
            }
            if (!FCreatedHeader)
            {
                gvGridBlokReportsParameterHistoryHeader_DataBound(gvBlokReportsParameterHistoryList, null);
            }
            Init_Button();
        }
        protected void Init_Button()
        {   //в этой процедуре настроим наименования, видимость и события кнопок необходимых пользователю
            if ((FActiveUser == null) || (FActiveUser.ID <= 0) || (CheckedReportsParameterLine == null)) //нет аутентификации ничего не показываем
            {
                btnOne.Visible = false;
                btnTwo.Visible = false;
                btnThree.Visible = false;
                btnFour.Visible = false;
                btnFive.Visible = false;
                return;
            }
            CheckedReportsParameterLine = ModelsManager.GetOneReportParameterByID(CheckedReportsParameterLine.ReportParameterID);
            lblMonth.Text = CheckedReportsParameterLine.MonthName;
            lblYear.Text = CheckedReportsParameterLine.YearName;
            lblType.Text = CheckedReportsParameterLine.TypeReportName;
            lblReportType.Text = CheckedReportsParameterLine.ViewType;
            lblDepartment.Text = CheckedReportsParameterLine.DepartmentName;
            string lBlockText = ""; 
            if (CheckedReportsParameterLine.ReportIsCheckRegion)
            {
                lBlockText = lBlockText + KROConstants.lgReportCheckRegion;

                if (CheckedReportsParameterLine.ReportIsCheckFilial)
                    lBlockText = lBlockText + ", " + KROConstants.lgReportCheckFilial;
                if (CheckedReportsParameterLine.ReportIsCheckEconomic)
                    lBlockText = lBlockText +", "+ KROConstants.lgReportCheckEconomic;
            }
            else
            {
                if (CheckedReportsParameterLine.ReportIsCheckFilial)
                {
                    lBlockText = lBlockText + KROConstants.lgReportCheckFilial;
                    if (CheckedReportsParameterLine.ReportIsCheckEconomic)
                        lBlockText = lBlockText + ", " + KROConstants.lgReportCheckEconomic;
                }
                else
                {
                    if (CheckedReportsParameterLine.ReportIsCheckEconomic)
                        lBlockText = lBlockText + KROConstants.lgReportCheckEconomic;
                }
            }
            if (lBlockText.Length > 0)
            {
                lblCheck.Text = KROConstants.lgReportCheckTitle + lBlockText;
            }
            else
            {
                lblCheck.Visible = false;
            }
            // пользователь есть начинаем настройку кнопок по аналогии 
            // с процедурой AuthenticationManager.IsPageProtectedChecked
            // сначала роли потом у каждой флаги пользователя
            if (AuthenticationManager.IsAdmin(FActiveUser)) // только администраторы
            {
                btnOne.Visible = false;
                btnTwo.Visible = false;
                btnThree.Visible = false;
                btnFour.Visible = false;
                btnFive.Visible = false;
            }
            else 
            {
                if ((FActiveUser.UserFlag & KROFlag.flUserRegionDirection) == KROFlag.flUserRegionDirection)
                {
                    //пользователь региональной дирекции
                    btnOne.Text = Constants.CHANGE_REPORTPARAMETER_BLOCK_CHECK_REGION;
                    btnOne.Visible = true;
                    btnTwo.Text = Constants.CHANGE_REPORTPARAMETER_BLOCK_UN_CHECK_REGION;
                    btnTwo.Visible = true;
                   /* if  (CheckedReportsParameterLine.ReportIsCheckRegion)
                    {
                        //установлена региональная блокировка
                        btnTwo.Text = Constants.CHANGE_REPORTPARAMETER_BLOCK_UN_CHECK_REGION;
                        btnTwo.Visible = true;
                        btnOne.Visible = false;
                    }
                    else
                    {
                        // не установлена региональная блокировка
                        btnOne.Text = Constants.CHANGE_REPORTPARAMETER_BLOCK_CHECK_REGION;
                        btnOne.Visible = true;
                        btnTwo.Visible = false;
                    }*/

                }
                else
                {
                    btnOne.Visible = false;
                    btnTwo.Visible = false;  
                }
                if ((FActiveUser.UserFlag & KROFlag.flUserFilialDepartment) == KROFlag.flUserFilialDepartment)
                {   //сообщение о блокировках дирекций
                    if (CheckedReportsParameterLine.ReportIsCheckRegion)
                    {
                        List<RegionLine> lUnCheckRegionList = ModelsManager.GetReportUnBlockRegionList(CheckedReportsParameterLine.ReportParameterID);
                        if (lUnCheckRegionList.Count > 0)
                        {
                            lBlockText = "";// KROConstants.lgReportUnCheckTitle;
                            foreach (var lRegionLine in lUnCheckRegionList)
                            {
                                lBlockText = lBlockText + ", " + lRegionLine.RegionName;
                            }
                            if (lBlockText.Length > 0)
                            {
                                lBlockText = lBlockText.Remove(0, 1);
                                lblUnCheck.Text = KROConstants.lgReportUnCheckTitle + lBlockText;
                                lblUnCheck.Visible = true;
                            }
                            else lblUnCheck.Visible = false;
                        }
                        else lblUnCheck.Visible = false;
                    }
                    //пользователь филиала или РЦКУ
                    if (CheckedReportsParameterLine.ReportIsCheckFilial)
                    {
                        //установлена филиальная блокировка
                        btnFour.Text = Constants.CHANGE_REPORTPARAMETER_BLOCK_UN_CHECK_DEPARTMENT;
                        btnFour.Visible = true;
                        btnThree.Visible = false;
                    }
                    else
                    {
                        // не установлена филиальная блокировка
                        btnThree.Text = Constants.CHANGE_REPORTPARAMETER_BLOCK_CHECK_DEPARTMENT;
                        btnThree.Visible = true;
                        btnFour.Visible = false;
                    }
                }
                else
                {
                    btnThree.Visible = false;
                    btnFour.Visible = false;
                }
                if ((FActiveUser.UserFlag & KROFlag.flUserEconomicDepartment) == KROFlag.flUserEconomicDepartment)
                {
                    // сообщение
                    lBlockText = "";
                    if (!CheckedReportsParameterLine.ReportIsCheckRegion)
                        lBlockText = lBlockText + ", " + KROConstants.lgReportCheckRegion;
                    if (!CheckedReportsParameterLine.ReportIsCheckFilial)
                        lBlockText = lBlockText + ", " + KROConstants.lgReportCheckFilial;
                    if (lBlockText.Length > 0)
                    {
                        lBlockText = lBlockText.Remove(0, 1);
                        lblUnCheck.Text = KROConstants.lgReportUnCheckFullTitle + lBlockText;
                        lblUnCheck.Visible = true;
                    }
                    else lblUnCheck.Visible = false;
                    //пользователь ЦА
                    if (CheckedReportsParameterLine.ReportIsCheckEconomic)
                        btnFive.Text = Constants.CHANGE_REPORTPARAMETER_BLOCK_UN_CHECK_ECONOMIC;
                    else btnFive.Text = Constants.CHANGE_REPORTPARAMETER_BLOCK_CHECK_ECONOMIC;
                    btnFive.Click += ButtonCheckEconomic_Click;
                }
                else
                {
                    btnFive.Visible = false;
                }
            }
        }
        protected void GetUserFlag()
        {   // здесь получаем все доступные права пользователя
            FActiveUser = AuthenticationManager.GetAuthenticationUserModel(Session); 
            if ((FActiveUser.UserFlag & KROFlag.flUserAddNewReportParameter) == KROFlag.flUserAddNewReportParameter)
            { FUserCheckRule = KROConstants.FORM_USERS_FOR_MANAGER; }
            else { FUserCheckRule = 0; }
        }
        protected void gvGridBlokReportsParameterHistoryHeader_DataBound(object sender, EventArgs e)
        {
            GridViewRow lRowHeader1 = new GridViewRow(0, 0, DataControlRowType.Header, DataControlRowState.Normal);
            TableHeaderCell lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "История изменений состояния отчета";
            lCellHeader.ColumnSpan = 5;
            lCellHeader.Width = 1050;
            lRowHeader1.Controls.Add(lCellHeader);

            lRowHeader1.CssClass = "ssHeader";
            GridViewRow lRowHeader2 = new GridViewRow(0, 0, DataControlRowType.Header, DataControlRowState.Normal);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Дата";
            lCellHeader.Width = 100;
            lRowHeader2.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Операция";
            lCellHeader.Width = 250;
            lRowHeader2.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Сотрудник";
            lCellHeader.Width = 300;
            lRowHeader2.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Должность";
            lCellHeader.Width = 200;
            lRowHeader2.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Департамент";
            lCellHeader.Width = 200;
            lRowHeader2.Controls.Add(lCellHeader);

            lRowHeader2.CssClass = "ssHeader";
            gvGridBlokReportsParameterHistoryHeader.HeaderRow.Parent.Controls.AddAt(0, lRowHeader1); 
            gvGridBlokReportsParameterHistoryHeader.HeaderRow.Parent.Controls.AddAt(1, lRowHeader2);
        }
        protected void ButtonCheckRegion_Click(object sender, EventArgs e)
        {
            if (lblReportError.Visible) lblReportError.Visible = false;
            if ((CheckedReportsParameterLine != null) && (CheckedReportsParameterLine.ReportParameterID > 0))
            {
                CheckedReportsParameterLine.SetReportIsCheckRegion(); //инверсия флага
                if (ModelsManager.UpdateOnlyFlagReportsParameter(Session, CheckedReportsParameterLine, KROConstants.lgReportIsCheckRegion))
                {
                    FBlockReportParameterHistoryLine =
                        ModelsManager.GetBlockReportParameterHistoryList(CheckedReportsParameterLine.ReportParameterID);
                    gvBlokReportsParameterHistoryList.DataSource = FBlockReportParameterHistoryLine;
                    gvBlokReportsParameterHistoryList.DataBind();
                    Init_Button();
                }
                else lblReportError.Visible = true;
            }
            else lblReportError.Visible = true;
        }
        protected void ButtonUnCheckRegion_Click(object sender, EventArgs e)
        {
            if (lblReportError.Visible) lblReportError.Visible = false;
            if ((CheckedReportsParameterLine != null) && (CheckedReportsParameterLine.ReportParameterID > 0))
            {
                CheckedReportsParameterLine.SetReportIsUnCheckRegion(); //инверсия флага
                if (ModelsManager.UpdateOnlyFlagReportsParameter(Session, CheckedReportsParameterLine, KROConstants.lgReportIsUnCheckRegion))
                {
                    FBlockReportParameterHistoryLine =
                        ModelsManager.GetBlockReportParameterHistoryList(CheckedReportsParameterLine.ReportParameterID);
                    gvBlokReportsParameterHistoryList.DataSource = FBlockReportParameterHistoryLine;
                    gvBlokReportsParameterHistoryList.DataBind();
                    Init_Button();
                }
                else lblReportError.Visible = true;
            }
            else lblReportError.Visible = true;
        }
        protected void ButtonCheckFilial_Click(object sender, EventArgs e)
        {
            if (lblReportError.Visible) lblReportError.Visible = false;
            if ((CheckedReportsParameterLine !=null) && (CheckedReportsParameterLine.ReportParameterID > 0))
            {
                CheckedReportsParameterLine.SetReportIsCheckFilial();
                if (ModelsManager.UpdateOnlyFlagReportsParameter(Session, CheckedReportsParameterLine, KROConstants.lgReportIsCheckFilial))
                {
                    FBlockReportParameterHistoryLine =
                        ModelsManager.GetBlockReportParameterHistoryList(CheckedReportsParameterLine.ReportParameterID);
                    gvBlokReportsParameterHistoryList.DataSource = FBlockReportParameterHistoryLine;
                    gvBlokReportsParameterHistoryList.DataBind();
                    Init_Button();
                }
                else lblReportError.Visible = true;
            }
            else lblReportError.Visible = true;
        }
        protected void ButtonUnCheckFilial_Click(object sender, EventArgs e)
        {
            if (lblReportError.Visible) lblReportError.Visible = false;
            if ((CheckedReportsParameterLine != null) && (CheckedReportsParameterLine.ReportParameterID > 0))
            {
                CheckedReportsParameterLine.SetReportIsUnCheckFilial();
                if (ModelsManager.UpdateOnlyFlagReportsParameter(Session, CheckedReportsParameterLine, KROConstants.lgReportIsUnCheckFilial))
                {
                    FBlockReportParameterHistoryLine =
                        ModelsManager.GetBlockReportParameterHistoryList(CheckedReportsParameterLine.ReportParameterID);
                    gvBlokReportsParameterHistoryList.DataSource = FBlockReportParameterHistoryLine;
                    gvBlokReportsParameterHistoryList.DataBind();
                    Init_Button();
                }
                else lblReportError.Visible = true;
            }
            else lblReportError.Visible = true;
        }
        protected void ButtonCheckEconomic_Click(object sender, EventArgs e)
        {
            var lLogMessage = "";
            if (lblReportError.Visible) lblReportError.Visible = false;
            if ((CheckedReportsParameterLine != null) && (CheckedReportsParameterLine.ReportParameterID > 0))
            {
                if (!CheckedReportsParameterLine.ReportIsCheckEconomic)
                {
                    CheckedReportsParameterLine.SetReportIsCheckEconomic();
                    lLogMessage = KROConstants.lgReportIsCheckEconomic;
                }
                else
                {
                    CheckedReportsParameterLine.SetReportIsUnCheckEconomic();
                    lLogMessage = KROConstants.lgReportIsUnCheckEconomic;
                }
                if (ModelsManager.UpdateOnlyFlagReportsParameter(Session, CheckedReportsParameterLine, lLogMessage))
                {
                    FBlockReportParameterHistoryLine =
                        ModelsManager.GetBlockReportParameterHistoryList(CheckedReportsParameterLine.ReportParameterID);
                    gvBlokReportsParameterHistoryList.DataSource = FBlockReportParameterHistoryLine;
                    gvBlokReportsParameterHistoryList.DataBind();
                    Init_Button();
                }
                else lblReportError.Visible = true;
            }
            else lblReportError.Visible = true;
        }
        protected void ButtonExit_Click(object sender, EventArgs e)
        {
            Response.Redirect(Constants.REPORTS_PARAMETER_LIST_PAGE_URL);
        }
    }
}