﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using KRO.Contents;
using KRO.Authentication;
using KRO.Models;

namespace KRO.Pages.Directorys
{
    public partial class DepIncludeRegionList : System.Web.UI.Page
    {
        bool FCreatedHeader;
        private static List<DepIncludeRegionLine> FDepIncludeRegionLine = new List<DepIncludeRegionLine>();
        private static List<DepIncludeRegionLine> FDepIncludeRegionLineHeaderEmty = new List<DepIncludeRegionLine>();
        public DepIncludeRegionLine CheckedDepIncludeRegion
        {
            get { return (DepIncludeRegionLine)ViewState["CheckedDepIncludeRegion"]; }
            set { ViewState["CheckedDepIncludeRegion"] = value; }
        }
        protected void Page_Load(object sender, EventArgs e)
        {
            FCreatedHeader = false;
            if (!Page.IsPostBack)
            {
                PrepearGridData(cbOnlyActualDate.Checked);
                if (FDepIncludeRegionLine.Count == 0) gvDepIncludeRegionsList.Attributes["style"] += "border-style:none;";
                gvDepIncludeRegionListHeader.DataSource = FDepIncludeRegionLineHeaderEmty;
                gvDepIncludeRegionListHeader.DataBind();
                FCreatedHeader = true;
            }
            if (!FCreatedHeader)
            {
                gvDepIncludeRegionListHeader_DataBound(gvDepIncludeRegionListHeader, null);
            }
        }
        protected void gvDepIncludeRegionListHeader_DataBound(object sender, EventArgs e)
        {
            GridViewRow lRowHeader = new GridViewRow(0, 0, DataControlRowType.Header, DataControlRowState.Normal);
            TableHeaderCell lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Филиал";
            lCellHeader.Width = 300;
            lRowHeader.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Код";
            lCellHeader.Width = 100;
            lRowHeader.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Год";
            lCellHeader.Width = 80;
            lRowHeader.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Месяц";
            lCellHeader.Width = 100;
            lRowHeader.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            ImageButton lImageButton = new ImageButton();
            lImageButton.Enabled = false;
            lImageButton.ImageUrl = KROConstants.IMAGE_EMTY_32;
            lImageButton.ID = "NewDepIncludeRegion";

            lImageButton.Visible = true;
            lCellHeader.Width = 32;
            lImageButton.Enabled = true;
            lImageButton.ImageUrl = KROConstants.IMAGE_NEW_RECORD;
            lImageButton.Click += lImageButton_Click;

            lCellHeader.Controls.Add(lImageButton);
            lRowHeader.Controls.Add(lCellHeader);

            lRowHeader.CssClass = "ssHeader";
            if (gvDepIncludeRegionListHeader.HeaderRow != null)
            {
                gvDepIncludeRegionListHeader.HeaderRow.Parent.Controls.AddAt(0, lRowHeader);
            }
        }
        protected void lImageButton_Click(object sender, EventArgs e)
        {
            CheckedDepIncludeRegion = new DepIncludeRegionLine();
            Server.Transfer(Constants.CHANGE_DEPINCLUDEREGION_PAGE_URL);
        }
        protected void gvDepIncludeRegionsList_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow)
            {
                int lColumnCount = e.Row.Cells.Count;
                if (e.Row.RowIndex % 2 == 0) ChangeColorCells(e, lColumnCount, "background:#f7f9fc;", "#f7f9fc");
            }
        }
        protected void ChangeColorCells(GridViewRowEventArgs e, int AEndColumnindex, string AAttributeColor, string AColor)
        {
            for (int columnIndex = 0; columnIndex < AEndColumnindex + 1; columnIndex++)
            {
                try
                {
                    if (columnIndex <= AEndColumnindex)
                    {
                        e.Row.Cells[columnIndex].Attributes["style"] += AAttributeColor;
                        TextBox lTextBox = (TextBox)e.Row.Cells[columnIndex].Controls[3];
                        lTextBox.BackColor = ColorTranslator.FromHtml(AColor);
                    }
                    else { e.Row.Cells[columnIndex].Attributes["style"] += AAttributeColor; }
                }
                catch { }
            }
        }
        protected void CheckedDepIncludeRegionLink_Click(object sender, EventArgs e)
        {
            Response.Redirect(Constants.CHANGE_DEPINCLUDEREGION_PAGE_URL);
        }
        protected void gvDepIncludeRegionsList_SelectedIndexChanged(object sender, EventArgs e)
        {
            GridView lGridView = (GridView)sender;
            if (lGridView.SelectedIndex >= 0)
            {
                CheckedDepIncludeRegion = (DepIncludeRegionLine)FDepIncludeRegionLine.Find(x => x.ID == (int)lGridView.SelectedDataKey.Value);
            }
            else { CheckedDepIncludeRegion = new DepIncludeRegionLine(); }
            Server.Transfer(Constants.CHANGE_DEPINCLUDEREGION_PAGE_URL); //редактирование данных пользователя
        }

        protected void cbOnlyActualDate_CheckedChanged(object sender, EventArgs e)
        {
            PrepearGridData(cbOnlyActualDate.Checked);
        }
        protected void PrepearGridData(bool AOnlyActualdate = false)
        {
            if (AOnlyActualdate) FDepIncludeRegionLine = ModelsManager.GetDepIncludeRegionByActualDate(DateTime.Today);
            else FDepIncludeRegionLine = ModelsManager.GetDepIncludeRegionList();
            gvDepIncludeRegionsList.SelectedIndex = -1;
            gvDepIncludeRegionsList.DataSource = FDepIncludeRegionLine;
            gvDepIncludeRegionsList.DataBind();
        }
    }
}