﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Drawing;
using KRO.Contents;
using KRO.Authentication;
using KRO.Models;

namespace KRO.Pages.Directorys
{
    public partial class DepListInPeriodList : System.Web.UI.Page
    {
        bool FCreatedHeader;
        private static List<DepListInPeriodLine> FDepListInPeriodLine = new List<DepListInPeriodLine>();
        private static List<DepListInPeriodLine> FDepListInPeriodLineHeaderEmty = new List<DepListInPeriodLine>();
        public DepListInPeriodLine CheckedDepListInPeriod
        {
            get { return (DepListInPeriodLine)ViewState["CheckedDepListInPeriod"]; }
            set { ViewState["CheckedDepListInPeriod"] = value; }
        }
        protected void Page_Load(object sender, EventArgs e)
        {
            FCreatedHeader = false;
            if (!Page.IsPostBack)
            {
                PrepearGridData(cbOnlyActualDate.Checked);
                if (FDepListInPeriodLine.Count == 0) gvDepListInPeriodsList.Attributes["style"] += "border-style:none;";
                gvDepListInPeriodListHeader.DataSource = FDepListInPeriodLineHeaderEmty;
                gvDepListInPeriodListHeader.DataBind();
                FCreatedHeader = true;
            }
            if (!FCreatedHeader)
            {
                gvDepListInPeriodListHeader_DataBound(gvDepListInPeriodListHeader, null);
            }
        }
        protected void gvDepListInPeriodListHeader_DataBound(object sender, EventArgs e)
        {
            GridViewRow lRowHeader = new GridViewRow(0, 0, DataControlRowType.Header, DataControlRowState.Normal);
            TableHeaderCell lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Наименование";
            lCellHeader.Width = 350;
            lRowHeader.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Год";
            lCellHeader.Width = 90;
            lRowHeader.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Месяц";
            lCellHeader.Width = 110;
            lRowHeader.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            ImageButton lImageButton = new ImageButton();
            lImageButton.Enabled = false;
            lImageButton.ImageUrl = KROConstants.IMAGE_EMTY_32;
            lImageButton.ID = "NewDepListInPeriod";

            lImageButton.Visible = true;
            lCellHeader.Width = 32;
            lImageButton.Enabled = true;
            lImageButton.ImageUrl = KROConstants.IMAGE_NEW_RECORD;
            lImageButton.Click += lImageButton_Click;

            lCellHeader.Controls.Add(lImageButton);
            lRowHeader.Controls.Add(lCellHeader);

            lRowHeader.CssClass = "ssHeader";
            if (gvDepListInPeriodListHeader.HeaderRow != null)
            {
                gvDepListInPeriodListHeader.HeaderRow.Parent.Controls.AddAt(0, lRowHeader);
            }
        }
        protected void lImageButton_Click(object sender, EventArgs e)
        {
            CheckedDepListInPeriod = new DepListInPeriodLine();
            Server.Transfer(Constants.CHANGE_DEPLISTINPERIOD_PAGE_URL);
        }
        protected void gvDepListInPeriodsList_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow)
            {
                int lColumnCount = e.Row.Cells.Count;
                if (e.Row.RowIndex % 2 == 0) ChangeColorCells(e, lColumnCount, "background:#f7f9fc;", "#f7f9fc");
            }
        }
        protected void ChangeColorCells(GridViewRowEventArgs e, int AEndColumnindex, string AAttributeColor, string AColor)
        {
            for (int columnIndex = 0; columnIndex < AEndColumnindex + 1; columnIndex++)
            {
                try
                {
                    if (columnIndex <= AEndColumnindex)
                    {
                        e.Row.Cells[columnIndex].Attributes["style"] += AAttributeColor;
                        TextBox lTextBox = (TextBox)e.Row.Cells[columnIndex].Controls[3];
                        lTextBox.BackColor = ColorTranslator.FromHtml(AColor);
                    }
                    else { e.Row.Cells[columnIndex].Attributes["style"] += AAttributeColor; }
                }
                catch { }
            }
        }
        protected void CheckedDepListInPeriodLink_Click(object sender, EventArgs e)
        {
            Response.Redirect(Constants.CHANGE_DEPLISTINPERIOD_PAGE_URL);
        }
        protected void gvDepListInPeriodsList_SelectedIndexChanged(object sender, EventArgs e)
        {
            GridView lGridView = (GridView)sender;
            if (lGridView.SelectedIndex >= 0)
            {
                CheckedDepListInPeriod = (DepListInPeriodLine)FDepListInPeriodLine.Find(x => x.ID == (int)lGridView.SelectedDataKey.Value);
            }
            else { CheckedDepListInPeriod = new DepListInPeriodLine(); }
            Server.Transfer(Constants.CHANGE_DEPLISTINPERIOD_PAGE_URL); //редактирование данных пользователя
        }

        protected void cbOnlyActualDate_CheckedChanged(object sender, EventArgs e)
        {
            PrepearGridData(cbOnlyActualDate.Checked);
        }
        protected void PrepearGridData(bool AOnlyActualdate = false)
        {
            if (AOnlyActualdate) FDepListInPeriodLine = ModelsManager.GetDepListInPeriodListByActualDate(DateTime.Today);
            else FDepListInPeriodLine = ModelsManager.GetDepListInPeriodList();
            gvDepListInPeriodsList.SelectedIndex = -1;
            gvDepListInPeriodsList.DataSource = FDepListInPeriodLine;
            gvDepListInPeriodsList.DataBind();
        }
    }
}