﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using KRO.Contents;
using KRO.Authentication;
using KRO.Models;


namespace KRO.Pages.Directorys
{
    public partial class DepartmentList : System.Web.UI.Page
    {
        bool FCreatedHeader;
        private static List<DepartmentLine> FDepartmentLine = new List<DepartmentLine>();
        private static List<DepartmentLine> FDepartmentLineHeaderEmty = new List<DepartmentLine>();
        public DepartmentLine CheckedDepartment
        {
            get { return (DepartmentLine)ViewState["CheckedDepartment"]; }
            set { ViewState["CheckedDepartment"] = value; }
        }
        protected void Page_Load(object sender, EventArgs e)
        {
            FCreatedHeader = false;
            if (!Page.IsPostBack)
            {
                FDepartmentLine = ModelsManager.GetDepartmentList();
                gvDepartmentsList.SelectedIndex = -1;
                gvDepartmentsList.DataSource = FDepartmentLine;
                gvDepartmentsList.DataBind();
                gvDepartmentListHeader.DataSource = FDepartmentLineHeaderEmty;
                gvDepartmentListHeader.DataBind();
                FCreatedHeader = true;
            }
            if (!FCreatedHeader)
            {
                gvDepartmentListHeader_DataBound(gvDepartmentListHeader, null);
            }
        }
        protected void gvDepartmentListHeader_DataBound(object sender, EventArgs e)
        {
            GridViewRow lRowHeader = new GridViewRow(0, 0, DataControlRowType.Header, DataControlRowState.Normal);
            TableHeaderCell lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Наименование";
            lCellHeader.Width = 400;
            lRowHeader.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Код";
            lCellHeader.Width = 100;
            lRowHeader.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Сортировка";
            lCellHeader.Width = 100;
            lRowHeader.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            ImageButton lImageButton = new ImageButton();
            lImageButton.Enabled = false;
            lImageButton.ImageUrl = KROConstants.IMAGE_EMTY_32;
            lImageButton.ID = "NewDepartment";

            lImageButton.Visible = true;
            lCellHeader.Width = 32;
            lImageButton.Enabled = true;
            lImageButton.ImageUrl = KROConstants.IMAGE_NEW_RECORD;
            lImageButton.Click += lImageButton_Click;

            lCellHeader.Controls.Add(lImageButton);
            lRowHeader.Controls.Add(lCellHeader);

            lRowHeader.CssClass = "ssHeader";
            if (gvDepartmentListHeader.HeaderRow != null)
            {
                gvDepartmentListHeader.HeaderRow.Parent.Controls.AddAt(0, lRowHeader);
            }
        }
        protected void lImageButton_Click(object sender, EventArgs e)
        {
            CheckedDepartment = new DepartmentLine();
            Server.Transfer(Constants.CHANGE_DEPARTMENT_PAGE_URL);
        }
        protected void gvDepartmentsList_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow)
            {
                int lColumnCount = e.Row.Cells.Count;
                if (e.Row.RowIndex % 2 == 0) ChangeColorCells(e, lColumnCount, "background:#f7f9fc;", "#f7f9fc");
            }
        }
        protected void ChangeColorCells(GridViewRowEventArgs e, int AEndColumnindex, string AAttributeColor, string AColor)
        {
            for (int columnIndex = 0; columnIndex < AEndColumnindex + 1; columnIndex++)
            {
                try
                {
                    if (columnIndex <= AEndColumnindex)
                    {
                        e.Row.Cells[columnIndex].Attributes["style"] += AAttributeColor;
                        TextBox lTextBox = (TextBox)e.Row.Cells[columnIndex].Controls[3];
                        lTextBox.BackColor = ColorTranslator.FromHtml(AColor);
                    }
                    else { e.Row.Cells[columnIndex].Attributes["style"] += AAttributeColor; }
                }
                catch { }
            }
        }
        protected void CheckedDepartmentLink_Click(object sender, EventArgs e)
        {
            Response.Redirect(Constants.CHANGE_DEPARTMENT_PAGE_URL);
        }
        protected void gvDepartmentsList_SelectedIndexChanged(object sender, EventArgs e)
        {
            GridView lGridView = (GridView)sender;
            if (lGridView.SelectedIndex >= 0)
            {
                CheckedDepartment = (DepartmentLine)FDepartmentLine.Find(x => x.DepartmentID == (int)lGridView.SelectedDataKey.Value);
            }
            else { CheckedDepartment = new DepartmentLine(); }
            Server.Transfer(Constants.CHANGE_DEPARTMENT_PAGE_URL); //редактирование данных пользователя
        }
    }
}