﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KRO.Models;
using KRO.Authentication;
using KRO.Contents;

namespace KRO.Pages.Directorys
{
    public partial class GetReportParameterForRKCU : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                List<MounthLine> lMonthList = ModelsManager.GetMounthList();
                ddMounth.DataSource = lMonthList;
                ddMounth.DataBind();
                List<YearLine> lYearList = ModelsManager.GetYearList();
                ddYear.DataSource = ModelsManager.GetYearList();
                ddYear.DataBind();
                InitFieldUser(lMonthList,lYearList);
            }
        }
        private void InitFieldUser(List<MounthLine> AMonthList, List<YearLine> AYearList)
        {
            DateTime lNow = DateTime.Now;
            MounthLine lFindMonthLine = AMonthList.Find(Line => Line.MounthID == lNow.Month);
            if (lFindMonthLine != null)
                ddMounth.SelectedValue = lFindMonthLine.MounthID.ToString();
            YearLine lFindYearLine = AYearList.Find(Line => Line.YearName.Equals(lNow.Year.ToString()));
            if (lFindYearLine != null)
                ddYear.SelectedValue = lFindYearLine.YearID.ToString();
        }
        protected void ButtonCancel_Click(object sender, EventArgs e)
        {
            Response.Redirect(Constants.NAVIGATION_LIST_PAGE_URL);	
        }
        protected void ButtonApply_Click(object sender, EventArgs e)
        {
            lblExecuteError.Visible = false;
            User lUser = AuthenticationManager.GetAuthenticationUserModel(Session);
            if (lUser != null)
            {
                string lReportURl = GetReportStringByUserID(lUser);
                if (lReportURl.Length > 0) Response.Redirect(lReportURl);
                else lblExecuteError.Visible = true;
            }
            else lblExecuteError.Visible = true;
        }
        protected string GetReportStringByUserID(User AUser)
        {
            string lResult = "";
            try
            {
                int lMonthID = Int32.Parse(ddMounth.SelectedValue);
                int lYearID = Int32.Parse(ddYear.SelectedValue);
                if  ((lMonthID >0) && (lYearID>0)) {
                    List<DepartmentLine> lReportDepartmentList = ModelsManager.GetDepartmentListForRKCUReport(AUser.ID,lMonthID,lYearID);
                    if ((lReportDepartmentList != null) && (lReportDepartmentList.Count > 0))
                    {
                        foreach (DepartmentLine lDepartmentLine in lReportDepartmentList)
                        {
                            lResult = lResult + "," + lDepartmentLine.DepartmentID.ToString();
                        }
                        if (lResult.Length>0) lResult = lResult.Remove(0,1);
                    }
                    if (lResult.Length>0) {
                        //формируем окончательную строку
                        lResult = KROConstants.REPORTSERVER_URL +
                                  KROConstants.REPORTSERVER_REPORTNAME + "&" +
                                  KROConstants.REPORTSERVER_ALLDATAONLYACTIVE_YEAR + "=" +
                                  lYearID.ToString() + "&" +
                                  KROConstants.REPORTSERVER_ALLDATAONLYACTIVE_MONTH + "=" +
                                  lMonthID.ToString() + "&" +
                                  KROConstants.REPORTSERVER_ALLDATAONLYACTIVE_ACTIVE_DEPARTMENT_LIST + "=" +
                                  lResult;
                    }
                }
            }
            catch (Exception exp) { lResult = ""; }
            return lResult;
        }
    }
}