﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using KRO.Contents;
using KRO.Authentication;
using KRO.Models;

namespace KRO.Pages.Directorys
{
    public partial class MetricList : System.Web.UI.Page
    {
        bool FCreatedHeader;
        private static List<MetricLine> FMetricLine = new List<MetricLine>();
        private static List<MetricLine> FMetricLineHeaderEmty = new List<MetricLine>();
        public MetricLine CheckedMetric
        {
            get { return (MetricLine)ViewState["CheckedMetric"]; }
            set { ViewState["CheckedMetric"] = value; }
        }
        protected void Page_Load(object sender, EventArgs e)
        {
            FCreatedHeader = false;
            if (!Page.IsPostBack)
            {
                FMetricLine = ModelsManager.GetMetricList();
                gvMetricsList.SelectedIndex = -1;
                gvMetricsList.DataSource = FMetricLine;
                gvMetricsList.DataBind();
                gvMetricListHeader.DataSource = FMetricLineHeaderEmty;
                gvMetricListHeader.DataBind();
                FCreatedHeader = true;
            }
            if (!FCreatedHeader)
            {
                gvMetricListHeader_DataBound(gvMetricListHeader, null);
            }
        }
        protected void gvMetricListHeader_DataBound(object sender, EventArgs e)
        {
            GridViewRow lRowHeader1 = new GridViewRow(0, 0, DataControlRowType.Header, DataControlRowState.Normal);
            TableHeaderCell lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "№ п/п";
            lCellHeader.RowSpan = 2;
            lCellHeader.Width = 50;
            lRowHeader1.Controls.Add(lCellHeader);


            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Наименование показателя";
            lCellHeader.RowSpan = 2;
            lCellHeader.Width = 400;
            lRowHeader1.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Код";
            lCellHeader.RowSpan = 2;
            lCellHeader.Width = 50;
            lRowHeader1.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Сортировка";
            lCellHeader.RowSpan = 2;
            lCellHeader.Width = 80;
            lRowHeader1.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Хозяйство";
            lCellHeader.RowSpan = 2;
            lCellHeader.Width = 200;
            lRowHeader1.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Катег.";
            lCellHeader.RowSpan = 2;
            lCellHeader.Width = 50;
            lRowHeader1.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.ColumnSpan = 3;
            lCellHeader.Text = "Параметры показателя";
            lCellHeader.Width = 150;
            lRowHeader1.Controls.Add(lCellHeader);

            /*=============кнопки=============*/

            lCellHeader = new TableHeaderCell();
            ImageButton lImageButton = new ImageButton();
            lImageButton.Enabled = false;
            lImageButton.ImageUrl = KROConstants.IMAGE_EMTY_32;
            lImageButton.ID = "NewMetric";

            lImageButton.Visible = true;
            lCellHeader.Width = 32;
            lCellHeader.RowSpan = 2;
            lImageButton.Enabled = true;
            lImageButton.ImageUrl = KROConstants.IMAGE_NEW_RECORD;
            lImageButton.Click += lImageButton_Click;

            lCellHeader.Controls.Add(lImageButton);
            lRowHeader1.Controls.Add(lCellHeader);

            lRowHeader1.CssClass = "ssHeader";
            GridViewRow lRowHeader2 = new GridViewRow(0, 0, DataControlRowType.Header, DataControlRowState.Normal);
            Label lTitleLabel;

            lCellHeader = new TableHeaderCell();
            lCellHeader.Width = 50;
            lTitleLabel = new Label();
            lTitleLabel.Width = 50;
            lTitleLabel.Text = "Вводимый";
            lTitleLabel.ToolTip = "Вводимый";
            lTitleLabel.CssClass = "ssRowLabelOverflow";
            lCellHeader.Controls.Add(lTitleLabel);
            lRowHeader2.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Width = 50;
            lTitleLabel = new Label();
            lTitleLabel.Width = 50;
            lTitleLabel.Text = "Вычисляемый";
            lTitleLabel.ToolTip = "Вычисляемый";
            lTitleLabel.CssClass = "ssRowLabelOverflow";
            lCellHeader.Controls.Add(lTitleLabel);
            lRowHeader2.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Width = 50;
            lTitleLabel = new Label();
            lTitleLabel.Width = 50;
            lTitleLabel.Text = "Текстовый";
            lTitleLabel.ToolTip = "Текстовый";
            lTitleLabel.CssClass = "ssRowLabelOverflow";
            lCellHeader.Controls.Add(lTitleLabel);
            lRowHeader2.Controls.Add(lCellHeader);

            lRowHeader2.CssClass = "ssHeaderSecond";

            if (gvMetricListHeader.HeaderRow != null)
            {
                gvMetricListHeader.HeaderRow.Parent.Controls.AddAt(0, lRowHeader2);
                gvMetricListHeader.HeaderRow.Parent.Controls.AddAt(0, lRowHeader1);
            }
        }
        protected void lImageButton_Click(object sender, EventArgs e)
        {
            CheckedMetric = new MetricLine();
            Server.Transfer(Constants.CHANGE_METRIC_PAGE_URL);
        }
        protected void ChangeColorCells(GridViewRowEventArgs e, int AEndColumnindex, string AAttributeColor, string AColor)
        {
            for (int columnIndex = 0; columnIndex < AEndColumnindex + 1; columnIndex++)
            {
                try
                {
                    if (columnIndex <= AEndColumnindex)
                    {
                        e.Row.Cells[columnIndex].Attributes["style"] += AAttributeColor;
                        TextBox lTextBox = (TextBox)e.Row.Cells[columnIndex].Controls[3];
                        lTextBox.BackColor = ColorTranslator.FromHtml(AColor);
                    }
                    else { e.Row.Cells[columnIndex].Attributes["style"] += AAttributeColor; }
                }
                catch { }
            }
        }
        protected void CheckedMetricLink_Click(object sender, EventArgs e)
        {
            Response.Redirect(Constants.CHANGE_METRIC_PAGE_URL);
        }
        protected void gvMetricsList_SelectedIndexChanged(object sender, EventArgs e)
        {
            GridView lGridView = (GridView)sender;
            if (lGridView.SelectedIndex >= 0)
            {
                CheckedMetric = (MetricLine)FMetricLine.Find(x => x.MetricID == (int)lGridView.SelectedDataKey.Value);
            }
            else { CheckedMetric = new MetricLine(); }
            Server.Transfer(Constants.CHANGE_METRIC_PAGE_URL); //редактирование данных пользователя
        }
    }
}