﻿using System;
using System.Web.UI.WebControls;
using KRO.Authentication;
using KRO.Contents;

namespace KRO.Pages
{
	public partial class MasterPage : System.Web.UI.MasterPage
	{
        public User FActiveUser { get; set; }
		protected void Page_Load(object sender, EventArgs e)
		{
            CheckAuthentication();
            //long lUserFlag = 0;
            // if (FActiveUser != null) lUserFlag = FActiveUser.UserFlag;

            //if (AuthenticationManager.IsUserAuthenticated(Request, out lUserName, lUserPassword, out lUserFlag, out lUserID))
            //{
            //AddNavigation();
            //}
            ProtectAdminPages(FActiveUser);
            if (!Request.Url.ToString().Contains(Constants.LOGIN_PAGE_NAME, StringComparison.InvariantCultureIgnoreCase))
                lbNavigation.Visible = true;
		}

	    private void CheckAuthentication()
		{
			if (!RequestContains(Constants.LOGIN_PAGE_SHORT_NAME))
            {
                User lUser = null;
                if (AuthenticationManager.IsUserAuthenticated(Session, out lUser))
				{
                     FActiveUser = lUser;
                     if (FActiveUser.ID > 0)
                    {
                        lblName.Text = FActiveUser.Name;
                        lbLogout.Visible = true;
                    }
				}
				else
                {
                    FActiveUser = lUser;
					Response.Redirect(Constants.LOGIN_PAGE_URL);
				}
			}
		}

        private void ProtectAdminPages(User AActiveUser)
		{
            if (AuthenticationManager.IsPageProtectedChecked(AActiveUser, Request.Url.ToString()))
            {
                Response.Redirect(Constants.LOGIN_PAGE_URL);
            }
		}

        /// <summary>
        /// процедура добавления страницы к панели навигации (пка выведена т.к. панель навигации заменена кнопками,
        /// скорее всего панель создаваться будет при развитии проекта на финальной стадии)
        /// </summary>
		private void AddNavigation()
		{
			HyperLink lbTemplates = new HyperLink
			{
				ID = "lbMetricList",
                Text = "Редактирование",
				NavigateUrl = Constants.METRICS_LIST_PAGE_URL,
				CssClass = RequestContains(Constants.METRICS_LIST_PAGE_SHORT_NAME) ? "navigationLinkSelected" : "navigationLink"
			};

			navigation.Controls.Add(lbTemplates);

            if (AuthenticationManager.IsAdmin(FActiveUser))
			{
				HyperLink lbPackages = new HyperLink
				{
					ID = "lbManageUsers",
                    Text = "Пользователи",
					NavigateUrl = Constants.USERS_PAGE_URL, 
					CssClass = RequestContains(Constants.USERS_PAGE_SHORT_NAME) ? "navigationLinkSelected" : "navigationLink"
				};

				navigation.Controls.Add(lbPackages);
			}
		}

		private bool RequestContains(string pageName)
		{
			string request = Request.Url.ToString();
			string requestPageName = request.Substring(0, request.IndexOf(".aspx"));
			return requestPageName.Contains(pageName, StringComparison.InvariantCultureIgnoreCase);
		}
		protected void lbLogout_Click(object sender, EventArgs e)
		{
			AuthenticationManager.LogoutUser(Response,Session);
		}
        protected void lbNavigation_Click(object sender, EventArgs e)
        {
            Response.Redirect(Constants.NAVIGATION_LIST_PAGE_URL);	
		}
	}
}