﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KRO.Models;
using System.Web.Configuration;
using System.Data;
using System.Data.SqlClient;
using KRO.Contents;
using System.Reflection;
using System.Text.RegularExpressions;
using System.Web.Services;
using System.Drawing;
using System.Globalization;
using System.Linq;
using KRO.Authentication;

namespace KRO.Pages
{
    public partial class MetricsList : System.Web.UI.Page
    {
        private static List<DinamicMetricReportLine> FMetricReportLineHeaderEmty = new List<DinamicMetricReportLine>(); //только для grid header всегда пустой
		private static object Locker = new object();

        public ReportsParameterLine CheckedReportsParameterLine
        {
            get { return (ReportsParameterLine)ViewState["ReportsParameterLine"]; }
            set { ViewState["ReportsParameterLine"] = value; }
        }
       
		//для построения грида
		private List<RegionLine> FDinamicRegionReportList;
		private List<RegionLine> FCheckedDinamicRegionReportList;
		private List<RegionLine> FCheckedDinamicRegionBlockReportList;
        private DataTable FDateTable;

	    protected void Page_Load(object sender, EventArgs e)
	    {
            btnPrintReport.Click +=btnPrintReport_Click;
            btnCheckReport.Click += btnCheckReport_Click;
		    if (!Page.IsPostBack)
            {   // получим список доступных региональных дирекций
				CheckedReportsParameterLine = ModelsManager.GetChangeReportParameterLineFromSession(Session);
                User lUserID = AuthenticationManager.GetAuthenticationUserModel(Session);
                FDinamicRegionReportList = ModelsManager.GetReportRegionList(CheckedReportsParameterLine.ReportParameterID, lUserID.ID);
                FCheckedDinamicRegionBlockReportList = ModelsManager.GetReportBlockRegionList(CheckedReportsParameterLine.ReportParameterID);
                cblRegion.DataSource = FDinamicRegionReportList;
                cblRegion.DataBind();

                foreach (ListItem listitem in cblRegion.Items) // выберем все
                {
                    listitem.Selected = true;
                }
                
            }
	        setCheckedDinamicRegionReportList();
            // получили список доступных региональных дирекций
            // получим список доступных показателей
            GetDinamicMetricReportList();
            // получили список доступных показателей

            gvMetricsListHeader.DataSource = FMetricReportLineHeaderEmty;
            gvMetricsListHeader.DataBind();
	    }

        protected void setCheckedDinamicRegionReportList()
        {
            try
            {
                lblSelectesRegion.Text = "";
                //подготовим динамически отображаемый список регионов
                if (FCheckedDinamicRegionReportList == null)
                    FCheckedDinamicRegionReportList = new List<RegionLine>();
                else
                    FCheckedDinamicRegionReportList.Clear();

                foreach (ListItem listitem in cblRegion.Items) // выберем все
                {
                    if (listitem.Selected == true)
                    {
                        if ((FDinamicRegionReportList != null) && (FDinamicRegionReportList.Count > 0))
                        {
                            RegionLine lCheckedRegionLine = null;
                            lCheckedRegionLine =
                                FDinamicRegionReportList.Find(line => line.RegionName.Equals(listitem.Text));
                            if (lCheckedRegionLine != null)
                            {
                                FCheckedDinamicRegionReportList.Add(lCheckedRegionLine);
                                lblSelectesRegion.Text = lblSelectesRegion.Text + ", " + listitem.Text;
                            }
                        }
                    }
                }
                if (lblSelectesRegion.Text.Length > 0)
                {
                    lblSelectesRegion.Text = lblSelectesRegion.Text.Remove(0, 1);
                }
            }
            catch (Exception) { FCheckedDinamicRegionReportList = new List<RegionLine>(); }
        }

        protected void GetDinamicMetricReportList()
        {   
            /*string lStartTime = DateTime.Now.ToString(); //для оптимизации
            string lEndTime;*/
            if (FCheckedDinamicRegionReportList != null)
            {
				List<DinamicMetricReportLine> lDinamicMetricReportList = ModelsManager.GetMetricReportListFull(CheckedReportsParameterLine, FCheckedDinamicRegionReportList);
				Session["FDinamicMetricReportList"] = lDinamicMetricReportList;
				List<MetricFunctionLine> lDinamicMetricFunctionList = ModelsManager.GetMetricFunctionListByReportParameterID(CheckedReportsParameterLine.ReportParameterID);
				Session["FDinamicMetricFunctionList"] = lDinamicMetricFunctionList;

	            CreateDataTable(lDinamicMetricReportList, FCheckedDinamicRegionReportList);
                if (FDateTable != null)
                {
                    GridViewMetricsList.DataSource = FDateTable;
                    GridViewMetricsList.DataBind();

                    gvMetricsListFixedColumn.DataSource = FDateTable;
                    gvMetricsListFixedColumn.DataBind();

                    gvMetricsListHeaderFixedColumn.DataSource = FDateTable;
                    gvMetricsListHeaderFixedColumn.DataBind();
                }
            }
            else
            {
	            Session["FDinamicMetricReportList"] = new List<DinamicMetricReportLine>();
	            Session["FDinamicMetricFunctionList"] = new List<MetricFunctionLine>();
            }
             /*lEndTime = DateTime.Now.ToString(); // для оптимизации пока 10 сек отрабатывает процедура на пустой таблице Fact
             lEndTime = lStartTime + "  |  " + lEndTime;*/
        }
        protected void CreateDataTable(List<DinamicMetricReportLine> ADinamicMetricReportLine, List<RegionLine> ADinamicRegionLine)
        {   
            //создание таблицы с данными
            FDateTable = new DataTable();
            GridViewMetricsList.Columns.Clear();

            DataColumn lDataColumn = new DataColumn("MetricID", typeof(System.Int64));
            lDataColumn.Unique = true;
            FDateTable.Columns.Add(lDataColumn);
            GridViewMetricsList.Columns.Add(GetGridDataColumn("MetricID", "MetricID", "ssRowLabelHiddenID", 40, true));

            lDataColumn = new DataColumn("MetricScreenCode", typeof(System.String));
            FDateTable.Columns.Add(lDataColumn);
            GridViewMetricsList.Columns.Add(GetGridDataColumn("MetricScreenCode", "№ п/п", "ssRowLabel", 40, true));

            lDataColumn = new DataColumn("MetricName", typeof(System.String));
            FDateTable.Columns.Add(lDataColumn);
            GridViewMetricsList.Columns.Add(GetGridDataColumn("MetricName", "Наименование показателей", "ssRowLabel", 350, true));

            lDataColumn = new DataColumn("MetricCode", typeof(System.String));
            FDateTable.Columns.Add(lDataColumn);
            GridViewMetricsList.Columns.Add(GetGridDataColumn("MetricCode", "Код", "ssRowLabel", 50, true));

            lDataColumn = new DataColumn("MetricSort", typeof(System.String));
            FDateTable.Columns.Add(lDataColumn);
            GridViewMetricsList.Columns.Add(GetGridDataColumn("MetricSort", "MetricSort", "ssRowLabelHidden", 40, true));

            lDataColumn = new DataColumn("Flag", typeof(System.Int64));
            FDateTable.Columns.Add(lDataColumn);
            GridViewMetricsList.Columns.Add(GetGridDataColumn("Flag", "Flag", "ssCellFlag", 40, true));

            lDataColumn = new DataColumn("SumFact", typeof(System.Double));
            FDateTable.Columns.Add(lDataColumn);
            GridViewMetricsList.Columns.Add(GetGridDataColumn("SumFact", KROConstants.HeaderFactYear, "ssFactLabel", 128, true));

            lDataColumn = new DataColumn("SumCum", typeof(System.Double));
            FDateTable.Columns.Add(lDataColumn);
            GridViewMetricsList.Columns.Add(GetGridDataColumn("SumCum", KROConstants.HeaderFactCumulative, "ssCumLabel", 128, true));

            lDataColumn = new DataColumn("SumMade", typeof(System.Double));
            FDateTable.Columns.Add(lDataColumn);
            GridViewMetricsList.Columns.Add(GetGridDataColumn("SumMade", KROConstants.HeaderFactMade, "ssMadeLabel", 128, true));

            if (ADinamicRegionLine.Count > 0)
            {
                //создание динамических полей
                foreach (RegionLine LRegionLine  in ADinamicRegionLine)
                {
                    lDataColumn = new DataColumn("FactID" + LRegionLine.RegionID.ToString(), typeof(System.Int64));
                    FDateTable.Columns.Add(lDataColumn);
                    GridViewMetricsList.Columns.Add(GetGridDataColumn("FactID" + LRegionLine.RegionID.ToString(), "FactID" + LRegionLine.RegionID.ToString(), "ssCellHidden"));

                    lDataColumn = new DataColumn("FactFlag" + LRegionLine.RegionID.ToString(), typeof(System.Int64));
                    FDateTable.Columns.Add(lDataColumn);
                    GridViewMetricsList.Columns.Add(GetGridDataColumn("FactFlag" + LRegionLine.RegionID.ToString(), "FactFlag" + LRegionLine.RegionID.ToString(), "ssCellHiddenFlag"));

                    lDataColumn = new DataColumn("FactYearPlan" + LRegionLine.RegionID.ToString(), typeof(System.Double));
                    FDateTable.Columns.Add(lDataColumn);
                    GridViewMetricsList.Columns.Add(GetGridDataColumn("FactYearPlan" + LRegionLine.RegionID.ToString(), KROConstants.HeaderFactYear, "ssCell"));

                    lDataColumn = new DataColumn("FactCumulativePlan" + LRegionLine.RegionID.ToString(), typeof(System.Double));
                    FDateTable.Columns.Add(lDataColumn);
                    GridViewMetricsList.Columns.Add(GetGridDataColumn("FactCumulativePlan" + LRegionLine.RegionID.ToString(), KROConstants.HeaderFactCumulative, "ssCell"));

                    lDataColumn = new DataColumn("FactMade" + LRegionLine.RegionID.ToString(), typeof(System.Double));
                    FDateTable.Columns.Add(lDataColumn);
                    GridViewMetricsList.Columns.Add(GetGridDataColumn("FactMade" + LRegionLine.RegionID.ToString(), KROConstants.HeaderFactMade, "ssCell"));
                }
                //Заполнение DataTable
                if (ADinamicMetricReportLine.Count > 0)
                {
                    DataRow lDataRow;
                    List<RegionLine> lRegionBlockFlagList = GetBlockRegionFlag(ADinamicRegionLine); //получим блокировки
                    foreach (DinamicMetricReportLine lDinamicMetricReportLine in ADinamicMetricReportLine)
                    {
                        lDataRow = FDateTable.NewRow();

                        lDataRow["MetricID"] = lDinamicMetricReportLine.MetricID;
                        lDataRow["MetricScreenCode"] = lDinamicMetricReportLine.MetricScreenCode;
                        lDataRow["MetricName"] = lDinamicMetricReportLine.MetricName;
                        lDataRow["MetricCode"] = lDinamicMetricReportLine.MetricCode;
                        lDataRow["MetricSort"] = lDinamicMetricReportLine.MetricSort;
                        lDataRow["Flag"] = lDinamicMetricReportLine.MetricFlag;
                        lDataRow["SumFact"] = DBNull.Value;
                        lDataRow["SumCum"]  = DBNull.Value;
                        lDataRow["SumMade"] = DBNull.Value;
                        // добавим данные регионов
                        long? lID;
                        double? lDouble;
                        foreach (RegionLine LRegionLine in ADinamicRegionLine)
                        {
                            lID = lDinamicMetricReportLine.MetricRegionFactList.Find(Line => Line.RegionDirectionID == LRegionLine.RegionID).FactID;
                            if (lID != null) lDataRow["FactID" + LRegionLine.RegionID.ToString()] = lID;
                            else lDataRow["FactID" + LRegionLine.RegionID.ToString()] = DBNull.Value;
                            //блокировки
                            lDataRow["FactFlag" + LRegionLine.RegionID.ToString()] = lRegionBlockFlagList.Find(Line => Line.RegionID == LRegionLine.RegionID).RegionUserFlag;

                            lDouble = lDinamicMetricReportLine.MetricRegionFactList.Find(Line => Line.RegionDirectionID == LRegionLine.RegionID).FactYearPlan;
                            if (lDouble != null) lDataRow["FactYearPlan" + LRegionLine.RegionID.ToString()] = lDouble;
                            else lDataRow["FactYearPlan" + LRegionLine.RegionID.ToString()] = DBNull.Value;

                            lDouble = lDinamicMetricReportLine.MetricRegionFactList.Find(Line => Line.RegionDirectionID == LRegionLine.RegionID).FactCumulativePlan;
                            if (lDouble != null) lDataRow["FactCumulativePlan" + LRegionLine.RegionID.ToString()] = lDouble;
                            else lDataRow["FactCumulativePlan" + LRegionLine.RegionID.ToString()] = DBNull.Value;

                            lDouble = lDinamicMetricReportLine.MetricRegionFactList.Find(Line => Line.RegionDirectionID == LRegionLine.RegionID).FactMade;
                            if (lDouble != null) lDataRow["FactMade" + LRegionLine.RegionID.ToString()] = lDouble;
                            else lDataRow["FactMade" + LRegionLine.RegionID.ToString()] = DBNull.Value;
                        }
                        //добавим строку данных
                        FDateTable.Rows.Add(lDataRow);
                    }
                  
                }
            }
        }

        private List<RegionLine> GetBlockRegionFlag(List<RegionLine> ARegionList)
        {
            List<RegionLine> lResult = new List<RegionLine>();
            if (ARegionList != null)
            {
                foreach (RegionLine lRegionLine in ARegionList)
                {
                    RegionLine lBlockRegionLine = new RegionLine();
                    lBlockRegionLine.SetRegionID(lRegionLine.RegionID);
                    if (CheckedReportsParameterLine != null)
                    {
                        if (((CheckedReportsParameterLine.ReportFlag & KROFlag.flReportIsCheckEconomic) == KROFlag.flReportIsCheckEconomic) || //если подписан на уровне ЦА то все блокируем
                            ((CheckedReportsParameterLine.ReportFlag & KROFlag.flReportIsCheckFilial) == KROFlag.flReportIsCheckFilial)) //если подписан на уровне филиала то все блокируем
                        {
                            lBlockRegionLine.RegionUserFlag = KROFlag.flMetricRegionBlockedInDinamicFactLine;
                        }
                        else
                        {   //если подписан на уровне дирекции
                            if ((CheckedReportsParameterLine.ReportFlag & KROFlag.flReportIsCheckRegion) == KROFlag.flReportIsCheckRegion)
                            {   // проверяем заблокированные регионы
                                if ((FCheckedDinamicRegionBlockReportList != null) &&
                                    (FCheckedDinamicRegionBlockReportList.Count > 0) &&
                                    (FCheckedDinamicRegionBlockReportList.Exists(Line => Line.RegionID == lRegionLine.RegionID)))
                                {
                                    lBlockRegionLine.RegionUserFlag = KROFlag.flMetricRegionBlockedInDinamicFactLine;
                                }
                                else
                                {   //если нет права на чтение блокируем
                                    if ((lRegionLine.RegionUserFlag & KROFlag.flCheckWrite) == 0)
                                    {
                                        lBlockRegionLine.RegionUserFlag = KROFlag.flMetricRegionBlockedInDinamicFactLine;
                                    }
                                }
                            }
                            else
                            {
                                //если нет права на чтение блокируем
                                if ((lRegionLine.RegionUserFlag & KROFlag.flCheckWrite) == 0)
                                {
                                    lBlockRegionLine.RegionUserFlag = KROFlag.flMetricRegionBlockedInDinamicFactLine;
                                }
                            }
                        }
                    }
                    lResult.Add(lBlockRegionLine);
                }
            }
            return lResult;
        }

        private TemplateField GetGridDataColumn(string AFieldName, string AHeaderText, string ACssClass, int AColumnWidth = 128, bool AOnlyLabel = false)
        {
            // Динамическое создание полевых столбцы для отображения желаемого 
            // Поля из источника данных. Создание объекта TemplateField 
            // Для отображения первого и последнего имя автора.
            TemplateField lTemplateField = new TemplateField();
            lTemplateField.ItemStyle.HorizontalAlign = HorizontalAlign.Right;
            lTemplateField.ItemStyle.CssClass = ACssClass;
            lTemplateField.ControlStyle.Width = AColumnWidth;
            lTemplateField.HeaderText = AHeaderText;
            // Создание динамических шаблонов и назначать их 
            // Соответствующее свойство шаблона.
            lTemplateField.ItemTemplate = new CellTemplate(DataControlRowType.DataRow, AFieldName, AOnlyLabel);

            return lTemplateField;
        }
        protected void dvViewMetricsListHeader_DataBound(object sender, EventArgs e)
        {   //первая строка заголовка
            GridViewRow lRowHeader1 = new GridViewRow(0, 0, DataControlRowType.Header, DataControlRowState.Normal);
            TableHeaderCell lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "№ п/п";
            lCellHeader.RowSpan = 2;
            lCellHeader.Width = 40;
            lRowHeader1.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Показатели";
            lCellHeader.RowSpan = 2;
            lCellHeader.Width = 350;
            lRowHeader1.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Код";
            lCellHeader.RowSpan = 2;
            lCellHeader.Width = 50;
            lRowHeader1.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.ColumnSpan = 3;
            lCellHeader.Text = "Филиал (дирекция в целом)";
            lCellHeader.Width = 390;
            lCellHeader.CssClass = "ssHeaderMetricSum";
            lRowHeader1.Controls.Add(lCellHeader);
            // вторая строка заголовка
            GridViewRow lRowHeader2 = new GridViewRow(0, 0, DataControlRowType.Header, DataControlRowState.Normal);
            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = KROConstants.HeaderFactYear;
            lCellHeader.Width = 130;
            lCellHeader.CssClass = "ssHeaderMetricSecondSum";
            lRowHeader2.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = KROConstants.HeaderFactCumulative;
            lCellHeader.Width = 130;
            lCellHeader.CssClass = "ssHeaderMetricSecondSum";
            lRowHeader2.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = KROConstants.HeaderFactMade;
            lCellHeader.Width = 130;
            lCellHeader.CssClass = "ssHeaderMetricSecondSum";
            lRowHeader2.Controls.Add(lCellHeader);

            if (FCheckedDinamicRegionReportList != null)
            {
                string lCssClassBlock;
                string lCssClassSecondBlock;
                foreach (RegionLine lRegionLine in FCheckedDinamicRegionReportList)
                {
                    lCssClassBlock = String.Empty;
                    lCssClassSecondBlock = String.Empty;
                    if ((CheckedReportsParameterLine.ReportFlag & KROFlag.flReportIsCheckEconomic) ==
                        KROFlag.flReportIsCheckEconomic) //если подписан на уровне ЦА то красным шапку
                    {
                        lCssClassBlock = KROConstants.cssHeaderMetricListBlockEconomic;
                        lCssClassSecondBlock = KROConstants.cssSecondHeaderMetricListBlockEconomic;
                    }
                    else
                    {
                        if ((CheckedReportsParameterLine.ReportFlag & KROFlag.flReportIsCheckFilial) ==
                            KROFlag.flReportIsCheckFilial) //если подписан на уровне филиала то фиолетовым шапку 
                        {
                            lCssClassBlock = KROConstants.cssHeaderMetricListBlockFilial;
                            lCssClassSecondBlock = KROConstants.cssSecondHeaderMetricListBlockFilial;
                        }
                        else
                        {
                            if ((CheckedReportsParameterLine.ReportFlag & KROFlag.flReportIsCheckRegion) == KROFlag.flReportIsCheckRegion) //если подписан на уровне дирекции
                            {   // проверяем заблокированные регионы
                                if ((FCheckedDinamicRegionBlockReportList != null) &&
                                    (FCheckedDinamicRegionBlockReportList.Count > 0) &&
                                    (FCheckedDinamicRegionBlockReportList.Exists(Line => Line.RegionID == lRegionLine.RegionID)))
                                {
                                    lCssClassBlock = KROConstants.cssHeaderMetricListBlockRegion;
                                    lCssClassSecondBlock = KROConstants.cssSecondHeaderMetricListBlockRegion;
                                }
                            }
                        }
                    }
                    // первая строка заголовка
                    lCellHeader = new TableHeaderCell();
                    lCellHeader.ColumnSpan = 3;
                    lCellHeader.Text = lRegionLine.RegionName;
                    lCellHeader.Width = 390;
                    // разукрасим заблокированные заголовки
                    if (lCssClassBlock.Length > 0) lCellHeader.CssClass = lCssClassBlock;
                    lRowHeader1.Controls.Add(lCellHeader);
                    // вторая строка заголовка
                    lCellHeader = new TableHeaderCell();
                    lCellHeader.Text = KROConstants.HeaderFactYear;
                    lCellHeader.Width = 130;
                    if (lCssClassSecondBlock.Length > 0) lCellHeader.CssClass = lCssClassSecondBlock;
                    lRowHeader2.Controls.Add(lCellHeader);

                    lCellHeader = new TableHeaderCell();
                    lCellHeader.Text = KROConstants.HeaderFactCumulative;
                    lCellHeader.Width = 130;
                    if (lCssClassSecondBlock.Length > 0) lCellHeader.CssClass = lCssClassSecondBlock;
                    lRowHeader2.Controls.Add(lCellHeader);

                    lCellHeader = new TableHeaderCell();
                    lCellHeader.Text = KROConstants.HeaderFactMade;
                    lCellHeader.Width = 130;
                    if (lCssClassSecondBlock.Length > 0) lCellHeader.CssClass = lCssClassSecondBlock;
                    lRowHeader2.Controls.Add(lCellHeader);
                }
            }

            lRowHeader1.CssClass = KROConstants.cssHeaderMetricListUnBlock;
            lRowHeader2.CssClass = KROConstants.cssSecondHeaderMetricListUnBlock;

            gvMetricsListHeader.HeaderRow.Parent.Controls.AddAt(0, lRowHeader2);
            gvMetricsListHeader.HeaderRow.Parent.Controls.AddAt(0, lRowHeader1);
        }
        protected void gvMetricsListHeaderFixedColumn_DataBound(object sender, EventArgs e)
        {
            GridViewRow lRowHeader1 = new GridViewRow(0, 0, DataControlRowType.Header, DataControlRowState.Normal);
            TableHeaderCell lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "№ п/п";
            lCellHeader.RowSpan = 2;
            lCellHeader.Width = 40;
            lRowHeader1.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Показатели";
            lCellHeader.RowSpan = 2;
            lCellHeader.Width = 350;
            lRowHeader1.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Код";
            lCellHeader.RowSpan = 2;
            lCellHeader.Width = 50;
            lRowHeader1.Controls.Add(lCellHeader);


            lRowHeader1.CssClass = "ssHeaderMetricSpan";
            gvMetricsListHeaderFixedColumn.HeaderRow.Parent.Controls.AddAt(0, lRowHeader1);
        }
        protected void gvMetricsListFixedColumn_DataBound(object sender, EventArgs e)
        {
            GridViewRow lRowHeader1 = new GridViewRow(0, 0, DataControlRowType.Header, DataControlRowState.Normal);
            TableHeaderCell lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "№ п/п";
            lCellHeader.RowSpan = 2;
            lCellHeader.Width = 40;
            lRowHeader1.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Показатели";
            lCellHeader.RowSpan = 2;
            lCellHeader.Width = 350;
            lRowHeader1.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Код";
            lCellHeader.RowSpan = 2;
            lCellHeader.Width = 50;
            lRowHeader1.Controls.Add(lCellHeader);

            lRowHeader1.CssClass = "ssHeaderMetric";
            GridViewRow lRowHeader2 = new GridViewRow(0, 0, DataControlRowType.Header, DataControlRowState.Normal);
            lRowHeader2.CssClass = "ssHeaderMetricSecond";

            gvMetricsListFixedColumn.HeaderRow.Parent.Controls.AddAt(0, lRowHeader2);
            gvMetricsListFixedColumn.HeaderRow.Parent.Controls.AddAt(0, lRowHeader1);
        }
        /// <summary>
        /// Призводит изменение в базе данных и FDinamicMetricReportList  и в FDataTable ,а так же возвращает на клиента строку измененных данных
        /// </summary>
        /// <param name="ARowIndex">индекс параметра со стороны клиента</param>
        /// <param name="ANewValue">новое значение</param>
        /// <param name="ATExtBoxName">наименование ячейки измененных данных</param>
		[WebMethod]
        public static string UpdateCellData(int AMetricID, string ANewValue, string ATExtBoxName)
        {
	        lock (Locker)
	        {
		        string lResult = "";
		        long lMetricID = AMetricID;
				List<DinamicMetricReportLine> lDinamicMetricReportList = (List<DinamicMetricReportLine>)HttpContext.Current.Session["FDinamicMetricReportList"];
				List<MetricFunctionLine> lDinamicMetricFunctionList = (List<MetricFunctionLine>)HttpContext.Current.Session["FDinamicMetricFunctionList"];

		        if (lDinamicMetricReportList == null || lDinamicMetricFunctionList == null)
		        {
			        return lResult;
		        }

				DinamicMetricReportLine lMetricData = lDinamicMetricReportList.Find(
			        delegate(DinamicMetricReportLine lMetric) { return lMetric.MetricID == lMetricID; });

		        if (lMetricData == null)
		        {
			        return lResult;
		        }
		        //получаем наименование и индекс изменненного свойства класса DinamicMetricReportLine.List<DinamicFactLine>
		        string lNameProperty = Regex.Replace(ATExtBoxName, @"[\d-]", string.Empty);
		        lNameProperty = lNameProperty.Replace("tb", string.Empty);
		        int lRegionID = int.Parse(Regex.Match(ATExtBoxName, @"\d+").Value);
		        // теперь есть данные нахождения объекта таблицы Fact
		        DinamicFactLine lFactDataLine = lMetricData.MetricRegionFactList.Find(Line => Line.RegionDirectionID == lRegionID);
		        //находим старое значения
		        double? lOldValue = null;
		        switch (lNameProperty)
		        {
			        case "FactYearPlan":
				        lOldValue = (double?) GetObjProperty(lFactDataLine, lNameProperty, "");
				        break;
			        case "FactCumulativePlan":
				        lOldValue = (double?) GetObjProperty(lFactDataLine, lNameProperty, "");
				        break;
			        case "FactMade":
				        lOldValue = (double?) GetObjProperty(lFactDataLine, lNameProperty, "");
				        break;
		        }
		        //приведем новое знечение к типу double?
		        double? lNewValue = null;
		        if (!ANewValue.Equals(String.Empty))
		        {
			        ANewValue = ANewValue.Replace(".", ",");
			        lNewValue = double.Parse(ANewValue);
		        }
		        //проверка необходимости внесения изменений
		        if (lNewValue == lOldValue)
			        return lResult;
		        else
		        {
			        // если сюда провалились то явные изменения в базе данных значит необходим пересчет всеро столбца                
			        if (UpdateInDataBase(lMetricData, lFactDataLine, lNameProperty, lNewValue))
			        {
				        //начнем формировать  строку возврата
				        string lResonseChanged = "";
				        lResonseChanged = lMetricID.ToString() + "~" + lNameProperty + lRegionID.ToString() + "~" + lNewValue.ToString();
					        //String.Format("{000 000 000 000 000.00###}"*/
				        if (lDinamicMetricFunctionList != null)
				        {
					        // найдем все вычисляемые показатели в формуле которых присутствует исходный (учтем что теперь перекрестные формулы отсутствуют как класс и нам побарабану в какой последовательности отрабатывать функции)
					        List<MetricFunctionLine> lCalculatedMetricNeed = lDinamicMetricFunctionList.FindAll(Line => Line.SumMetricID == lMetricData.MetricID);
					        if ((lCalculatedMetricNeed != null) && (lCalculatedMetricNeed.Count > 0))
						        // список вычисляемых показателей на которых влияет исходный, но формулы здесь неполные (точнее их нет вообще)
					        {
						        // установили факт, что исходный показатель участвует в каких либо рассчетах
						        // организуем цикл по определенным вычисляемым показателям 
						        foreach (MetricFunctionLine lCalculatedMetricID in lCalculatedMetricNeed)
						        {
							        List<MetricFunctionLine> lSumMetricFunctionList =
								        lDinamicMetricFunctionList.FindAll(Line => Line.CalcMetricID == lCalculatedMetricID.CalcMetricID);
							        //получили наконец реальную функцию для вычислений
							        // лезем в действующие значения и считаем
							        // найдем DinamicFactLine вычисляемого показателя
							        DinamicMetricReportLine lMetricCalculatedData = lDinamicMetricReportList.Find(
								        delegate(DinamicMetricReportLine lMetric) { return lMetric.MetricID == lCalculatedMetricID.CalcMetricID; });
							        DinamicFactLine lFactDataCalculatedLine = lMetricCalculatedData.MetricRegionFactList.Find(Line => Line.RegionDirectionID == lRegionID);
							        // находим старое значение
							        //находим старое значения
							        double? lOldCalculatedValue = null;
							        switch (lNameProperty)
							        {
								        case "FactYearPlan":
									        lOldCalculatedValue = (double?) GetObjProperty(lFactDataCalculatedLine, lNameProperty, "");
									        break;
								        case "FactCumulativePlan":
									        lOldCalculatedValue = (double?) GetObjProperty(lFactDataCalculatedLine, lNameProperty, "");
									        break;
								        case "FactMade":
									        lOldCalculatedValue = (double?) GetObjProperty(lFactDataCalculatedLine, lNameProperty, "");
									        break;
							        }
							        // тут начинаются ветки анализа расчета 
							        double? lNewCalculatedValue = null;
							        // создаем цикл по функции
							        foreach (MetricFunctionLine lSumMetricLine in lSumMetricFunctionList)
							        {
								        DinamicMetricReportLine lSumMetricReportLine = lDinamicMetricReportList.Find(
									        delegate(DinamicMetricReportLine lMetric) { return lMetric.MetricID == lSumMetricLine.SumMetricID; });
								        DinamicFactLine lFactDataSumLine = lSumMetricReportLine.MetricRegionFactList.Find(Line => Line.RegionDirectionID == lRegionID);
								        //находим старое значения
								        double? lOldSumValue = null;
								        switch (lNameProperty)
								        {
									        case "FactYearPlan":
										        lOldSumValue = (double?) GetObjProperty(lFactDataSumLine, lNameProperty, "");
										        break;
									        case "FactCumulativePlan":
										        lOldSumValue = (double?) GetObjProperty(lFactDataSumLine, lNameProperty, "");
										        break;
									        case "FactMade":
										        lOldSumValue = (double?) GetObjProperty(lFactDataSumLine, lNameProperty, "");
										        break;
								        }
								        // нашли значение к суммисованию проведем анализ на DK и на null (возможна ошибка если lNewCalculatedValue еще null надо проверить)
								        if (lOldSumValue != null)
									        if (lNewCalculatedValue == null)
									        {
										        lNewCalculatedValue = lOldSumValue*lSumMetricLine.DK;
									        }
									        else
									        {
										        lNewCalculatedValue = lNewCalculatedValue + lOldSumValue*lSumMetricLine.DK;
									        }
							        } // конец цикла по функции
							        // проведем анализ а надо ли что нибудь делать в базе
							        if (lNewCalculatedValue != lOldCalculatedValue)
							        {
								        // необходимо подменить в базе данных
								        if (UpdateInDataBase(lMetricCalculatedData, lFactDataCalculatedLine, lNameProperty, lNewCalculatedValue))
									        lResonseChanged = lResonseChanged + "_" + lMetricCalculatedData.MetricID.ToString() + "~" + lNameProperty + lRegionID.ToString() +
									                          "~" + lNewCalculatedValue.ToString(); //String.Format("{000 000 000 000 000.00###}"*/
							        }
						        } // конец цикла по вычисляемым показателям
					        }
				        }
				        lResult = lResonseChanged;
			        }
		        }
		        return lResult;
	        }
        }
        public static object GetObjProperty(object obj, string ANameProperty, string AIndexProperty)
        {
            Type t = obj.GetType();
            PropertyInfo p = t.GetProperty(ANameProperty + AIndexProperty);
            object lvalue = p.GetValue(obj, null);
            return lvalue;
        }
        public static void SetObjProperty(object obj, string ANameProperty, string AIndexProperty, double? AValue)
        {
            Type t = obj.GetType();
            PropertyInfo p = t.GetProperty(ANameProperty + AIndexProperty);
            p.SetValue(obj, AValue);
        }
        public static void SetObjProperty(object obj, string ANameProperty, string AIndexProperty, long? AValue)
        {
            Type t = obj.GetType();
            PropertyInfo p = t.GetProperty(ANameProperty + AIndexProperty);
            p.SetValue(obj, AValue);
        }
        public static long? InsertIntoFact(int ARegionID,long AMetricID,int ADepartmentID,int AContractorID,int AMonthID,int AYearID,int ATypeID,double? AYearPlan,double? ACumulativePlan,double?  AMade)
        {
            long? lNewRecordID = null;
            try
            {
                SqlParameter lParameter = null;
				using (SqlConnection connection = new SqlConnection(WebConfigurationManager.ConnectionStrings["EFDbContext"].ConnectionString))
				{
					SqlCommand command = new SqlCommand(KROSQLs.InsertFactRowWithIDRecord, connection);
                    try
                    {
                        command.CommandType = CommandType.StoredProcedure;

                        lParameter = new SqlParameter("@RegionID", SqlDbType.Int);
                        lParameter.IsNullable = true;
                        lParameter.Value = ARegionID;
                        command.Parameters.Add(lParameter);

                        lParameter = new SqlParameter("@MetricID", SqlDbType.Int);
                        lParameter.IsNullable = true;
                        lParameter.Value = AMetricID;
                        command.Parameters.Add(lParameter);

                        lParameter = new SqlParameter("@DepartmentID", SqlDbType.Int);
                        lParameter.IsNullable = true;
                        lParameter.Value = ADepartmentID;
                        command.Parameters.Add(lParameter);

                        lParameter = new SqlParameter("@ContractorID", SqlDbType.Int);
                        lParameter.IsNullable = true;
                        lParameter.Value = AContractorID;
                        command.Parameters.Add(lParameter);

                        lParameter = new SqlParameter("@MonthID", SqlDbType.Int);
                        lParameter.IsNullable = true;
                        lParameter.Value = AMonthID;
                        command.Parameters.Add(lParameter);

                        lParameter = new SqlParameter("@YearID", SqlDbType.Int);
                        lParameter.IsNullable = true;
                        lParameter.Value = AYearID;
                        command.Parameters.Add(lParameter);

                        lParameter = new SqlParameter("@TypeID", SqlDbType.Int);
                        lParameter.IsNullable = true;
                        lParameter.Value = ATypeID;
                        command.Parameters.Add(lParameter);

                        lParameter = new SqlParameter("@YearPlan", SqlDbType.Decimal);
                        lParameter.IsNullable = true;
                        if (AYearPlan == null) lParameter.Value = DBNull.Value; else lParameter.Value = AYearPlan;
                        command.Parameters.Add(lParameter);

                        lParameter = new SqlParameter("@CumulativePlan", SqlDbType.Decimal);
                        lParameter.IsNullable = true;
                        if (ACumulativePlan == null) lParameter.Value = DBNull.Value; else lParameter.Value = ACumulativePlan;
                        command.Parameters.Add(lParameter);

                        lParameter = new SqlParameter("@Made", SqlDbType.Decimal);
                        lParameter.IsNullable = true;
                        if (AMade == null) lParameter.Value = DBNull.Value; else lParameter.Value = AMade;
                        command.Parameters.Add(lParameter);

						command.Connection.Open();
                        lNewRecordID = (long?)command.ExecuteScalar();
                    }
                    finally { if (connection != null) connection.Close(); }
                }
            }
            catch
            {
                lNewRecordID = null;
            }
            return lNewRecordID;
        }

	    public static bool UpdateFactOnlyValue(long? AFactID, double? AYearPlan, double? ACumulativePlan, double? AMade)
	    {
		    bool lExecuted = true;
		    try
		    {
			    using (SqlConnection connection = new SqlConnection(WebConfigurationManager.ConnectionStrings["EFDbContext"].ConnectionString))
			    {
				    SqlCommand command = new SqlCommand(KROSQLs.UpdateFactOnlyValue, connection);
				    command.CommandType = CommandType.Text;
				    SqlParameter lParameter = new SqlParameter("@FactID", SqlDbType.BigInt);
				    lParameter.IsNullable = true;
				    if (AFactID == null) lParameter.Value = DBNull.Value;
				    else lParameter.Value = AFactID;
				    command.Parameters.Add(lParameter);
				    lParameter = new SqlParameter("@YearPlan", SqlDbType.Decimal);
				    lParameter.IsNullable = true;
				    if (AYearPlan == null) lParameter.Value = DBNull.Value;
				    else lParameter.Value = AYearPlan;
				    command.Parameters.Add(lParameter);
				    lParameter = new SqlParameter("@CumulativePlan", SqlDbType.Decimal);
				    lParameter.IsNullable = true;
				    if (ACumulativePlan == null) lParameter.Value = DBNull.Value;
				    else lParameter.Value = ACumulativePlan;
				    command.Parameters.Add(lParameter);
				    lParameter = new SqlParameter("@Made", SqlDbType.Decimal);
				    lParameter.IsNullable = true;
				    if (AMade == null) lParameter.Value = DBNull.Value;
				    else lParameter.Value = AMade;
				    command.Parameters.Add(lParameter);

				    command.Connection.Open();
				    command.ExecuteNonQuery();
			    }
		    }
		    catch
		    {
			    lExecuted = false;
		    }
		    return lExecuted;
	    }

	    public static bool DeleteFromFactByFactID(long? AFactID)
	    {
		    bool lExecuted = true;
		    try
		    {
			    SqlParameter lParameter = null;
			    using (SqlConnection connection = new SqlConnection(WebConfigurationManager.ConnectionStrings["EFDbContext"].ConnectionString))
			    {
				    SqlCommand command = new SqlCommand(KROSQLs.DeleteFromFact, connection);

				    try
				    {
					    command.CommandType = CommandType.Text;
					    lParameter = new SqlParameter("@FactID", SqlDbType.BigInt);
					    lParameter.IsNullable = true;
					    if (AFactID == null) lParameter.Value = DBNull.Value;
					    else lParameter.Value = AFactID;
					    command.Parameters.Add(lParameter);

					    command.Connection.Open();
					    command.ExecuteNonQuery();
				    }
				    finally
				    {
				    }
			    }
		    }
		    catch
		    {
			    lExecuted = false;
		    }
		    return lExecuted;
	    }

	    /// <summary>
        /// обновляет значение в FMetricReportLine затем в базе данных возвращает значение положительного или отрицательного результата
        /// </summary>
        /// <param name="AMetricData">Строка массива FMetricReportLine которую меняем</param>
        /// <param name="AMetricID">ID показателя</param>
        /// <param name="ANameProperty">Наименование свойства</param>
        /// <param name="AIndex">порятковый номер  свойства</param>
        /// <param name="ANewValue">новое значение</param>
        /// <returns></returns>
        protected static bool UpdateInDataBase(DinamicMetricReportLine ADinamicMetricReportLine,DinamicFactLine AFactDataLine, string ANameProperty, double? ANewValue)
        {   
            bool lResult = false;
           // if (StaticCheckedReportsParameterLine == null) CheckedReportsParameterLine = ModelsManager.GetChangeReportParameterLineFromSession(Session);
            try
            {   //lFactDataLine = ADinamicMetricReportLine.MetricRegionFactList.Find(Line => Line.RegionDirectionID == ARegionID);
                switch (ANameProperty)
                {
                    case "FactYearPlan":
                        SetObjProperty(AFactDataLine, ANameProperty, "", ANewValue);
                        break;
                    case "FactCumulativePlan":
                        SetObjProperty(AFactDataLine, ANameProperty, "", ANewValue);
                        break;
                    case "FactMade":
                        SetObjProperty(AFactDataLine, ANameProperty, "", ANewValue);
                        break;
                }
                //обновление данных в базе получим все значения для изменения секции
                long? lFactID = (long?)GetObjProperty(AFactDataLine, "FactID","");
                double? lFactYearPlan = (double?)GetObjProperty(AFactDataLine, "FactYearPlan","");
                double? lFactCumulativePlan = (double?)GetObjProperty(AFactDataLine, "FactCumulativePlan","");
                double? lFactMade = (double?)GetObjProperty(AFactDataLine, "FactMade", "");
                // проверяем отсутствие всех значений фактов
                if ((lFactYearPlan == null) && (lFactCumulativePlan == null) && (lFactMade == null))
                { //все значения пустые надо удалять строку если есть, если нет то ничего не делаем достаточно только подчистить lMetricData
                    if (lFactID != null)
                        if (DeleteFromFactByFactID(lFactID)) SetObjProperty(AFactDataLine, "FactID", "", null);
                }
                else
                {   // какое-то значение присутствует надо либо Insert либо Update                 
                    if (lFactID == null)
                    { //Insert с вставкой нового MetricID в lMetricData
						ReportsParameterLine checkedReportsParameterLine = ModelsManager.GetChangeReportParameterLineFromSession(HttpContext.Current.Session);
                        long? lNewID = InsertIntoFact(AFactDataLine.RegionDirectionID,
                                                      ADinamicMetricReportLine.MetricID,
													  checkedReportsParameterLine.DepartmentID,
													  checkedReportsParameterLine.ContractorID,
													  checkedReportsParameterLine.MonthID,
													  checkedReportsParameterLine.YearID,
													  checkedReportsParameterLine.TypeID, 
                                                      lFactYearPlan, lFactCumulativePlan, lFactMade
                                                      );
                        if (lNewID != null) SetObjProperty(AFactDataLine, "FactID", "", lNewID);
                    }
                    else
                    { //Update существующих показателей таблицы фактов
                        if (lFactID != null) { UpdateFactOnlyValue(lFactID, lFactYearPlan, lFactCumulativePlan, lFactMade); }
                    }
                }
                lResult = true;
            }
            catch { }
            return lResult;
        }
        protected void btnPrintReport_Click(object sender, EventArgs e)
        {
            try
            {
                if ((CheckedReportsParameterLine != null) && (FCheckedDinamicRegionReportList != null))
                {   // find region id list
                    string lReportRegionIDString = "";
                    foreach (RegionLine lRegionLine in FCheckedDinamicRegionReportList)
                    {
                        lReportRegionIDString = lReportRegionIDString + "," + lRegionLine.RegionID;
                    }
                    if (lReportRegionIDString.Length > 0) lReportRegionIDString=lReportRegionIDString.Remove(0, 1);
                    //old report URL string
                    string lShowReportURL = KROConstants.REPORTSERVER_URL +
                                            KROConstants.REPORTSERVER_REPORTNAME + "&" +
                                            KROConstants.REPORTSERVER_ALLDATAONLYACTIVE_FILIALBALANS + "=" +
                                            CheckedReportsParameterLine.DepartmentID.ToString() + "&" +
                                            KROConstants.REPORTSERVER_ALLDATAONLYACTIVE_YEAR + "=" +
                                            CheckedReportsParameterLine.YearID.ToString() + "&" +
                                            KROConstants.REPORTSERVER_ALLDATAONLYACTIVE_MONTH + "=" +
                                            CheckedReportsParameterLine.MonthID.ToString() + "&" +
                                            KROConstants.REPORTSERVER_ALLDATAONLYACTIVE_TYPE + "=" +
                                            CheckedReportsParameterLine.TypeID.ToString() + "&" +
                                            KROConstants.REPORTSERVER_ALLDATAONLYACTIVE_PARAMETER;
                    //new report URL string
                    string lNewShowReportURL = KROConstants.REPORTSERVER_URL +
                                            KROConstants.REPORTSERVER_REPORTNAME + "&" +
                                            KROConstants.REPORTSERVER_ALLDATAONLYACTIVE_FILIALBALANS + "=" +
                                            CheckedReportsParameterLine.DepartmentID.ToString() + "&" +
                                            KROConstants.REPORTSERVER_ALLDATAONLYACTIVE_YEAR + "=" +
                                            CheckedReportsParameterLine.YearID.ToString() + "&" +
                                            KROConstants.REPORTSERVER_ALLDATAONLYACTIVE_MONTH + "=" +
                                            CheckedReportsParameterLine.MonthID.ToString() + "&" +
                                            KROConstants.REPORTSERVER_ALLDATAONLYACTIVE_ACTIVE_REGION_LIST + "=" +
                                            lReportRegionIDString;
                   // lNewShowReportURL = lNewShowReportURL + " ";
                    Response.Redirect(lShowReportURL);
                }
            }
            catch (Exception exp)
            {
            }
        }
        protected void btnCheckReport_Click(object sender, EventArgs e)
        {
            try
            {
                if (CheckedReportsParameterLine != null)
                {
                    User lActiveUser = AuthenticationManager.GetAuthenticationUserModel(Session);
                    if ((lActiveUser.UserFlag & KROFlag.flUserRegionDirection) == KROFlag.flUserRegionDirection)
                     {
                        //пользователь региональной дирекции
                         if (!CheckedReportsParameterLine.ReportIsCheckRegion)
                             CheckedReportsParameterLine.SetReportIsCheckRegion();
                         else CheckedReportsParameterLine.SetReportIsUnCheckRegion();
                      }
                    if ((lActiveUser.UserFlag & KROFlag.flUserFilialDepartment) == KROFlag.flUserFilialDepartment)
                      {  // пользователь филиала или РЦКУ
                         if (!CheckedReportsParameterLine.ReportIsCheckFilial)
                           CheckedReportsParameterLine.SetReportIsCheckFilial();
                         else CheckedReportsParameterLine.SetReportIsUnCheckFilial();
                            
                      }
                    if ((lActiveUser.UserFlag & KROFlag.flUserEconomicDepartment) == KROFlag.flUserEconomicDepartment)
                      {
                        //пользователь ЦА
                        if (!CheckedReportsParameterLine.ReportIsCheckEconomic)
                            CheckedReportsParameterLine.SetReportIsCheckEconomic();
                        else CheckedReportsParameterLine.SetReportIsUnCheckEconomic();
                      }
                    if (ModelsManager.UpdateOnlyFlagReportsParameter(Session, CheckedReportsParameterLine,
                        KROConstants.lgReportChangeFromMetricLictForm + lActiveUser.Family + " " +
                        lActiveUser.OfficeName))
                    {   //change only data from table becose change report checked
                        ModelsManager.AddChangeReportParameterLineInSession(Session, CheckedReportsParameterLine);
                        HttpContext.Current.Response.Redirect(HttpContext.Current.Request.Url.ToString()); // полная перезагрузка страницы т.к. нужно шапки таблиц перерисовать
                    }
                }
            }
            catch (Exception exp)
            {
            }
        }
    }
}