﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KRO.Authentication;
using KRO.Contents;
using KRO.Models;

namespace KRO.Pages
{
    public partial class Navigation : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            Init_Button();
        }

        protected void Init_Button()
        {   //в этой процедуре настроим наименования, видимость и события кнопок необходимых пользователю
            User lActiveUser = AuthenticationManager.GetAuthenticationUserModel(Session); //определили активного пользователя
            if ((lActiveUser == null) || (lActiveUser.ID <= 0)) //нет аутентификации ничего не показываем
            {
                lblFirst.Visible = false;
                lblSecond.Visible = false;
                lblThree.Visible = false;
                lblFour.Visible = false;
                btnOne.Visible = false;
                btnTwo.Visible = false;
                btnThree.Visible = false;
                btnFour.Visible = false;
                btnFive.Visible = false;
                btnSix.Visible = false;
                btnSeven.Visible = false;
                btnEight.Visible = false;
                btnNine.Visible = false;
                btnTen.Visible = false;
                return;
            }
            // пользователь есть начинаем настройку кнопок по аналогии 
            // с процедурой AuthenticationManager.IsPageProtectedChecked
            // сначала роли потом у каждой флаги пользователя
            if (AuthenticationManager.IsAdmin(lActiveUser)) // только администраторы
            {
                lblFirst.Visible = true;
                lblSecond.Visible = true;
                lblThree.Visible = true;
                lblFour.Visible = true;
                btnOne.Text = Constants.USERS_PAGE_TITLE_NAME;
                btnOne.Click += ButtonUsers_Click;
                btnTwo.Text = Constants.MANAGER_USERS_PAGE_TITLE_NAME;
                btnTwo.Click += ButtonManagerUsers_Click;
                btnThree.Text = Constants.LOGOUTS_PAGE_TITLE_NAME;
                btnThree.Click += ButtonLogOuts_Click;
                btnFour.Text = Constants.DEPARTMENT_LIST_PAGE_TITLE_NAME;
                btnFour.Click += ButtonDepartments_Click;
                btnFive.Text = Constants.DEPLISTINPERIOD_LIST_PAGE_TITLE_NAME;
                btnFive.Click += ButtonDepListInPeriod_Click;
                btnSix.Text = Constants.REGION_LIST_PAGE_TITLE_NAME;
                btnSix.Click += ButtonRegions_Click;
                btnSeven.Text = Constants.DEPINCLUDEREGION_LIST_PAGE_TITLE_NAME;
                btnSeven.Click += ButtonDepIncludeRegion_Click;
                btnEight.Text = Constants.METRIC_LIST_PAGE_TITLE_NAME;
                btnEight.Click += ButtonMetricList_Click;
                btnNine.Text = Constants.CHANGE_METRICLISTINPERIOD_PAGE_TITLE_NAME;
                btnNine.Click += ButtonMetricListInPeriod_Click;
                btnTen.Visible = false;
            }
            else // пока все остальные пользователи
            {
                lblFirst.Text = KROConstants.NAVIGATION_USER_INPUT;
                lblFirst.CssClass = "lblChangeUser";
                lblFirst.Visible = true;
                lblSecond.Text = KROConstants.NAVIGATION_USER_REPORT;
                lblSecond.CssClass = "lblChangeUser";
                lblSecond.Visible = true;
                lblThree.Visible = false;
                lblFour.Visible = false;

                btnOne.Text = Constants.REPORTS_PARAMETER_LIST_PAGE_TITLE_NAME;
                btnOne.Click += ButtonReports_Click;
                btnTwo.Visible = false;
                btnThree.Visible = false;
                btnFour.Text = Constants.BUTTON_TITLE_REPORTS;
                btnFour.Click += ButtonReport_Click;
                btnFive.Visible = false;
                btnSix.Visible = false;
                btnSeven.Visible = false;
                btnEight.Visible = false;
                btnNine.Visible = false;
                btnTen.Visible = false;
            }            
        }

        protected void ButtonReport_Click(object sender, EventArgs e)
        {
           // Response.Redirect("http://87.255.254.62:2459/Reports/Pages/Folder.aspx?ItemPath=%2fKRO"); // real string for CA
           // Response.Redirect("http://87.255.254.62:2459/Reports/Pages/Report.aspx?ItemPath=%2fKRO%2fbalansodergately"); //old string
            User lUser = AuthenticationManager.GetAuthenticationUserModel(Session);
            if (lUser != null)
            {
                if ((lUser.UserFlag & KROFlag.flUserRCKU) == KROFlag.flUserRCKU)
                {   // этот отчет видят только работники принадлежащие к РКЦУ
                    Response.Redirect(Constants.GET_REPORT_PARAMETER_FOR_RKCU_PAGE_URL);
                }
                else 
                {
                    if ((lUser.UserFlag & KROFlag.flUserEconomicDepartment) == KROFlag.flUserEconomicDepartment)
                    {   // этот отчет видят только работники ЦА
                        Response.Redirect("http://87.255.254.62:2459/Reports/Pages/Folder.aspx?ItemPath=%2fKRO");
                    }
                }            
            }
        }

        protected void ButtonUsers_Click(object sender, EventArgs e)
        {
            Response.Redirect(Constants.USERS_PAGE_NAME);
        }

        protected void ButtonReports_Click(object sender, EventArgs e)
        {
            Response.Redirect(Constants.REPORTS_PARAMETER_LIST_PAGE_URL);
        }
        protected void ButtonManagerUsers_Click(object sender, EventArgs e)
        {
            Response.Redirect(Constants.MANAGER_USERS_PAGE_URL);
        }
        protected void ButtonLogOuts_Click(object sender, EventArgs e)
        {
            Response.Redirect(Constants.LOGOUTS_PAGE_URL);
        }
        protected void ButtonDepartments_Click(object sender, EventArgs e)
        {
            Response.Redirect(Constants.DEPARTMENT_LIST_PAGE_URL);
        }
        protected void ButtonRegions_Click(object sender, EventArgs e)
        {
            Response.Redirect(Constants.REGION_LIST_PAGE_URL);
        }
        protected void ButtonDepIncludeRegion_Click(object sender, EventArgs e)
        {
            Response.Redirect(Constants.DEPINCLUDEREGION_LIST_PAGE_URL);
        } 
        protected void ButtonDepListInPeriod_Click(object sender, EventArgs e)
        {
            Response.Redirect(Constants.DEPLISTINPERIOD_LIST_PAGE_URL);
        }
        protected void ButtonMetricList_Click(object sender, EventArgs e)
        {
            Response.Redirect(Constants.METRIC_LIST_PAGE_URL);
        }
        protected void ButtonMetricListInPeriod_Click(object sender, EventArgs e)
        {
            Response.Redirect(Constants.METRICLISTINPERIOD_LIST_PAGE_URL);
        }
    }
}