﻿using System;
using System.Collections.Generic;
using System.Web.UI.WebControls;
using System.Drawing;
using KRO.Models;
using KRO.Authentication;
using KRO.Contents;

namespace KRO.Pages
{
    public partial class ReportsParameterList : System.Web.UI.Page
    {
        int FUserCheckRule;
        bool FCreatedHeader;
        private static List<ReportsParameterLine> FReportsParameterLine = new List<ReportsParameterLine>();
        private static List<ReportsParameterLine> FReportsParameterLineHeaderEmty = new List<ReportsParameterLine>();
        public ReportsParameterLine CheckedReportsParameterLine
        {
            get { return (ReportsParameterLine)ViewState["ReportsParameterLine"]; }
            set { ViewState["ReportsParameterLine"] = value; }
        }
        protected void Page_Load(object sender, EventArgs e)
        {
            //определим тип подъема формы               
            GetUserFlag();
            FCreatedHeader = false;
            if (!Page.IsPostBack)
            {
                PrepearGridData();
                gvReportsParameterHeader.DataSource = FReportsParameterLineHeaderEmty;
                gvReportsParameterHeader.DataBind();
                FCreatedHeader = true;
            }
            if (!FCreatedHeader)
            {
                gvReportsParameterHeader_DataBound(gvReportsParameterList, null);
            }
        }
        protected void GetUserFlag()
        {
            if ((AuthenticationManager.GetAuthenticationUserModel(Session).UserFlag & KROFlag.flUserAddNewReportParameter) == KROFlag.flUserAddNewReportParameter)
            { FUserCheckRule = KROConstants.FORM_USERS_FOR_MANAGER; }
            else { FUserCheckRule = 0; }
        }

        protected void gvReportsParameterHeader_DataBound(object sender, EventArgs e)
        {
            GridViewRow lRowHeader = new GridViewRow(0, 0, DataControlRowType.Header, DataControlRowState.Normal);
            TableHeaderCell lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Год";
            lCellHeader.Width = 30;
            lRowHeader.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Месяц";
            lCellHeader.Width = 50;
            lRowHeader.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Департамент";
            lCellHeader.Width = 200;
            lRowHeader.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Отчет";
            lCellHeader.Width = 250;
            lRowHeader.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Тип";
            lCellHeader.Width = 80;
            lRowHeader.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "РД";
            lCellHeader.Width = 60;
            lRowHeader.Controls.Add(lCellHeader);
            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Ф/РЦКУ";
            lCellHeader.Width = 60;
            lRowHeader.Controls.Add(lCellHeader);
            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "ЦА";
            lCellHeader.Width = 60;
            lRowHeader.Controls.Add(lCellHeader);

            lCellHeader = new TableHeaderCell();
            lCellHeader.Text = "Примечание";
            lCellHeader.Width = 250;
            lRowHeader.Controls.Add(lCellHeader);
            //добавим кнопку новый отчет
            lCellHeader = new TableHeaderCell();
            ImageButton lImageButton = new ImageButton();
            lImageButton.Enabled = false;
            lImageButton.ImageUrl = KROConstants.IMAGE_EMTY_32;
            lImageButton.ID = "NewUser";
            if (FUserCheckRule == KROConstants.FORM_USERS_FOR_MANAGER)
            {
                lImageButton.Visible = true;
                lImageButton.Enabled = true;
                lImageButton.ImageUrl = KROConstants.IMAGE_NEW_RECORD;
                lImageButton.Click += lImageButton_Click;
            }
            lCellHeader.ColumnSpan = 3;
            lCellHeader.Width = 102;
            lCellHeader.Controls.Add(lImageButton);
            lRowHeader.Controls.Add(lCellHeader);

            lRowHeader.CssClass = "ssHeader";
            gvReportsParameterHeader.HeaderRow.Parent.Controls.AddAt(0, lRowHeader);
        }
        protected void lImageButton_Click(object sender, EventArgs e)
        {
            CheckedReportsParameterLine = new ReportsParameterLine();
            Server.Transfer(Constants.CHANGE_REPORTS_PARAMETER_LIST_PAGE_URL);
        }

        protected void gvReportsParameterList_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow)
            {
               /* int lColumnCount = e.Row.Cells.Count;
                if (e.Row.RowIndex % 2 == 0) ChangeColorCells(e, lColumnCount, "background:#f7f9fc;", "#f7f9fc"); */
                // подменим рисунок блокировки
                string lImageUrl;
                if (((ReportsParameterLine)e.Row.DataItem).ReportIsCheckEconomic) lImageUrl =  KROConstants.IMAGE_LOCKED; else lImageUrl =  KROConstants.IMAGE_UNLOCK;

                try 
                {
                    ((ImageButton)e.Row.Cells[e.Row.Cells.Count - 1].Controls[0]).ImageUrl = lImageUrl;
                }
                catch {}
                // типа подменили уже
            }
        }
        protected void ChangeColorCells(GridViewRowEventArgs e, int AEndColumnindex, string AAttributeColor, string AColor)
        {
            for (int columnIndex = 0; columnIndex < AEndColumnindex + 1; columnIndex++)
            {
                try
                {
                    if (columnIndex <= AEndColumnindex)
                    {
                        e.Row.Cells[columnIndex].Attributes["style"] += AAttributeColor;
                        TextBox lTextBox = (TextBox)e.Row.Cells[columnIndex].Controls[3];
                        lTextBox.BackColor = ColorTranslator.FromHtml(AColor);
                    }
                    else { e.Row.Cells[columnIndex].Attributes["style"] += AAttributeColor; }
                }
                catch { }
            }
        }

        protected void gvReportsParameterList_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (lblReportError.Visible == true) lblReportError.Visible = false;
            GridView lGridView = (GridView)sender;
            if (lGridView.SelectedIndex >= 0)
            {
                CheckedReportsParameterLine = (ReportsParameterLine) FReportsParameterLine.Find(x => x.ReportParameterID == (int)lGridView.SelectedDataKey.Value);
            }
            else { CheckedReportsParameterLine = null; }
            if (CheckedReportsParameterLine != null)
            {
                ModelsManager.AddChangeReportParameterLineInSession(Session, CheckedReportsParameterLine); 
                Response.Redirect(Constants.METRICS_LIST_PAGE_NAME);
            }
            else { lblReportError.Visible = true; }
        }

        protected void gvReportsParameterList_RowCommand(object sender, GridViewCommandEventArgs e)
        {
            if (e.CommandName == KROConstants.COMMAND_REPORTPARAMETER_SHOWREPORT) {
                try
                {
                    if (lblReportError.Visible == true) lblReportError.Visible = false;
                    int lReportParameterID = -1;
                        Int32.TryParse(e.CommandArgument.ToString(), out lReportParameterID);
                        ReportsParameterLine lShowingReportParameter = (ReportsParameterLine)FReportsParameterLine.Find(x => x.ReportParameterID == lReportParameterID);
                    
                    string lShowReportURL = KROConstants.REPORTSERVER_URL +
                                            KROConstants.REPORTSERVER_REPORTNAME + "&" +
                                            KROConstants.REPORTSERVER_ALLDATAONLYACTIVE_FILIALBALANS + "=" +
                                            lShowingReportParameter.DepartmentID.ToString() + "&" +
                                            KROConstants.REPORTSERVER_ALLDATAONLYACTIVE_YEAR + "=" +
                                            lShowingReportParameter.YearID.ToString() + "&" +
                                            KROConstants.REPORTSERVER_ALLDATAONLYACTIVE_MONTH + "=" +
                                            lShowingReportParameter.MonthID.ToString() + "&" +
                                            KROConstants.REPORTSERVER_ALLDATAONLYACTIVE_TYPE + "=" +
                                            lShowingReportParameter.TypeID.ToString() + "&" +
                                            KROConstants.REPORTSERVER_ALLDATAONLYACTIVE_PARAMETER;
                    //new print report parameter URl string
                    // find region id list by user ID and report parameter ID
                    List<RegionLine> FDinamicRegionReportList = ModelsManager.GetReportRegionList(lReportParameterID, AuthenticationManager.GetAuthenticationUserModel(Session).ID);
                    string lReportRegionIDString = "";
                    foreach (RegionLine lRegionLine in FDinamicRegionReportList)
                    {
                        lReportRegionIDString = lReportRegionIDString + "," + lRegionLine.RegionID;
                    }
                    if (lReportRegionIDString.Length > 0) lReportRegionIDString = lReportRegionIDString.Remove(0, 1);
                    string lNewShowReportURL = KROConstants.REPORTSERVER_URL +
                                              KROConstants.REPORTSERVER_REPORTNAME + "&" +
                                              KROConstants.REPORTSERVER_ALLDATAONLYACTIVE_FILIALBALANS + "=" +
                                              lShowingReportParameter.DepartmentID.ToString() + "&" +
                                              KROConstants.REPORTSERVER_ALLDATAONLYACTIVE_YEAR + "=" +
                                              lShowingReportParameter.YearID.ToString() + "&" +
                                              KROConstants.REPORTSERVER_ALLDATAONLYACTIVE_MONTH + "=" +
                                              lShowingReportParameter.MonthID.ToString() + "&" +
                                              KROConstants.REPORTSERVER_ALLDATAONLYACTIVE_ACTIVE_REGION_LIST + "=" +
                                              lReportRegionIDString;
                  
                    Response.Redirect(lShowReportURL);
                }
                catch (Exception exp)
                {
                    lblReportError.Visible = true;
                }
            }
            if (e.CommandName == KROConstants.COMMAND_REPORTPARAMETER_BLOCKREPORT)
            {
                try
                {
                    if (lblReportError.Visible == true) lblReportError.Visible = false;
                    int lReportParameterID = -1;
                    Int32.TryParse(e.CommandArgument.ToString(), out lReportParameterID);
                    ReportsParameterLine lBlockReportParameter = (ReportsParameterLine)FReportsParameterLine.Find(x => x.ReportParameterID == lReportParameterID);
                    if (lBlockReportParameter != null)
                    {
                        ModelsManager.AddChangeReportParameterLineBlockInSession(Session, lBlockReportParameter);
                        Response.Redirect(Constants.CHANGE_REPORTPARAMETERBLOCK_PAGE_NAME);
                    }
                    else { lblReportError.Visible = true; }
                }
                catch (Exception exp)
                {
                    lblReportError.Visible = true;
                }
            }
        }
        protected void cbWithOutEconomicBlock_CheckedChanged(object sender, EventArgs e)
        {
            PrepearGridData();
        }
        protected void cbWithOutFilialBlock_CheckedChanged(object sender, EventArgs e)
        {
            PrepearGridData();
        }
        protected void cbWithOutRegionBlock_CheckedChanged(object sender, EventArgs e)
        {
            PrepearGridData();
        }
        protected void PrepearGridData()
        {
            User lUserID = AuthenticationManager.GetAuthenticationUserModel(Session);
            FReportsParameterLine = ModelsManager.GetReportsParameterListByUserIDAndBlock(lUserID.ID, cbWithOutEconomicBlock.Checked, cbWithOutFilialBlock.Checked, cbWithOutRegionBlock.Checked);
            gvReportsParameterList.SelectedIndex = -1;
            gvReportsParameterList.DataSource = FReportsParameterLine;
            gvReportsParameterList.DataBind();
        }
    }
}